# SymPyCore

[![Docs](https://img.shields.io/badge/docs-dev-blue.svg)](https://jverzani.github.io/SymPyCore.jl/dev)

[![Build Status](https://github.com/jverzani/SymPyCore.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/jverzani/SymPyCore.jl/actions/workflows/CI.yml?query=branch%3Amain)

[SymPy](https://www.sympy.org/) is a Python library for symbolic mathematics.

At present, there are two means to call `Python` code from `Julia`. As such, two packages have been developed to call into SymPy:

* [SymPy.jl](https://github.com/JuliaPy/SymPy.jl) is a long-standing `Julia` package using `PyCall.jl` to provide a "`Julia`n" interface to SymPy.

* [SymPyPythonCall.jl](https://github.com/jverzani/SymPyPythonCall.jl) is a `Julia` package using `PythonCall.jl` to provide a "`Julia`n" interface to SymPy providing a nearly identical experience as `SymPy.jl`.

The `SymPyCore` package aims to unify the underlying code, leaving only a small amount of glue code in the primary packages. As of version `0.2` of `SymPyPythonCall.jl`  and version `2.0` of `SymPy` the `SymPyCore` package is used.

To use `SymPyCore` you should install one of the two primary packages, and load that into a session. Installation of either `SymPyPythonCall` or `SymPy` should install the core package, the glue package, and arrange for the underlying sympy library of Python to be installed.

## promote

## convert is either convert or pyconvert; defined in python_connection
_convert() = ()
# no general conversion for "Number", just subtypes
#Base.convert(::Type{S}, x::Sym{T}) where {S<:Number, T} = _convert(S, ↓(x))
Base.convert(::Type{S}, x::Sym{T}) where {S<:Real, T} = _convert(S, ↓(x))
Base.convert(::Type{S}, x::Sym{T}) where {S<:Bool, T} = _convert(S, ↓(x))
Base.convert(::Type{Complex{S}}, x::Sym{T}) where {S, T} =
    Complex(convert(S, real(x)), convert(S, imag(x)))

## N
# special case numbers in sympy.core.numbers
sympy_core_numbers = ((:Zero, 0),
                      (:One, 1),
                      (:NegativeOne, -1),
                      (:Half, 1//2),
                      (:NaN, NaN),
                      (:Exp1, ℯ),
                      (:ImaginaryUnit, im),
                      (:Pi, pi),
                      (:EulerGamma, Base.MathConstants.eulergamma),
                      (:Catalan, Base.MathConstants.catalan),
                      (:GoldenRation, Base.MathConstants.golden),
                      (:TribonacciConstant, big(1)/3 + (-big(3)*sqrt(big(33)) + 19)^(1//3)/3 + (3*sqrt(big(33)) + 19)^(1//3)/3))


# N(x.evalf([prec]))
function N(x)

    !is_symbolic(x) && return x
    !isempty(free_symbols(x)) && return x # need constant
    y = ↓(x)
    #y.is_constant() || return Sym(y)

    cname = Symbol(classname(y))
    for (u,v) ∈ sympy_core_numbers
        cname == u && return v
    end

    if x.is_infinite == true
        if x.is_extended_real == true
            x > 0 && return Inf
            return -Inf
        else
            return  Complex(Inf, Inf)
        end
    end

    if iscall(x)
        z = y.evalf()
        if _convert(Bool, Sym(z.is_real))
            return _convert(Float64, z)
        end
        if _convert(Bool, Sym(z.is_complex))
            return Complex(convert(Float64, real(Sym((z)))), convert(Float64, imag(Sym(z))))
        end
        return _convert(Float64, z)
    end

    if x.is_real == true
        x.is_zero == true && return 0
        x.is_infinite == true && return (y.is_negative ? -1 : 1) * Inf
        if x.is_integer == true
            u = abs(x)
            T = Le(u, typemax(Int)) == Sym(true) ? Int : BigInt
            return _convert(T, y)
        end
        if string(y.__class__.__name__) == "Float"
            if _convert(Bool, y._prec <= 64)# <= 64
                return _convert(Float64, y)
            else
                return _convert(BigFloat, y)
            end
        end
        Sym(y.is_rational) == Sym(true) && return Rational(N(numerator(x)), N(denominator(x)))
        if iscall(x)
            if length(args(x)) > 1
                def_precision_decimal = ceil(Int, log10(big"2"^Base.MPFR.DEFAULT_PRECISION.x))
                return _convert(BigFloat, y.evalf(def_precision_decimal))
            end
        end
        return _convert(Float64, y.evalf())
    end
    cnm = string(y.__class__.__name__)
    cnm == "ComplexRootOf" && return N(y.evalf(16))
    cnm == "int" && return _convert(Int, y)
    cnm == "float" && return _convert(Float64, y)
    cnm == "mpf" && return  _convert(Float64, y)
    cnm == "complex" && return complex(N(real(x)), N(imag(x)))
    cnm == "mpc" && return complex(N(real(x)), N(imag(x)))
    cnm == "Infinity" && Inf
    cnm == "NegativeInfinity" && -Inf
    cnm == "ComplexInfinity" && complex(Inf)
    Eq(x, Sym(true)) == Sym(true) && return true
    Eq(x, Sym(false)) == Sym(true) && return false

    x.is_imaginary == Sym(true) && return complex(0, N(imag(x)))
    x.is_complex == Sym(true) && return complex(N(real(x)), N(imag(x)))
@show x
    try
        N(x.evalf())
    catch err
        @info "FAILED to find type for $x. Please report"
        x
    end
end

function N(x::Sym, digits::Int; kwargs...)
    @info "deprecated; use `N(x.evalf())"
    N(x.evalf(digits; kwargs...))
end




## infix logical operators
import Base: &, |, !

## XXX Experimental! Not sure these are such a good idea ...
Base.:&(x::Sym, y::Sym) =  ↑(↓(x).__and__(↓(y)))
Base.:|(x::Sym, y::Sym) =  ↑(↓(x).__or__(↓(y)))
Base.:!(x::Sym)         =  ↑(↓(x).__invert__())

## use ∨, ∧, ¬ for |,&,! (\vee<tab>, \wedge<tab>, \neg<tab>)
∨(x::Sym, y::Sym) = x | y
∧(x::Sym, y::Sym) = x & y
¬(x::Sym) = !x

## Work with symbolic expression tree including lambdify

# to keep SymPy.Introspection alive
Introspection_docs = md"""
     Introspection

Struct holding functions used to inspect an object

* `Introspection.func`: Return pointer to Python function.
* `Introspection.operation`: Return `Julia` generic function for given underlying function
* `Introspection.funcname`: Returns name of function
* `Introspection.args`: Returns arguments for expression or empty tuple
* `Introspection.arguments`: Return arguments
* `Introspection.iscall`: Check if object is an expression (with operation and arguments) or not
* `Introspection.class`: Returns `__class__` value
* `Introspection.classname`: Returns `__class__` value as a string
* `Introspection.similarterm`: Create a similar term

[Invariant:](http://docs.sympy.org/dev/tutorial/manipulation.html)

As `args` returns symbolic objects, this becomes:
every well-formed SymPy expression `ex` must either have `length(args(ex)) == 0` or
`func(ex)(↓(args(ex))...) = ex`.

Using the methods designed for `SymbolicUtils` usage, this becomes
every expression one of `!iscall(ex)`  or `operation(ex)(args(ex)...) == ex` should hold.
"""

@doc Introspection_docs
Base.@kwdef struct Introspection{T}
    _sympy_::T
    funcname::Function  = (x::Sym) -> SymPyCore.funcname(x, _sympy_)
    func::Function      = (x::Sym) -> SymPyCore.func(x, _sympy_)
    args::Function      = (x::Sym) -> SymPyCore.args(x, _sympy_)
    class::Function     = (x::Sym) -> SymPyCore.class(x, _sympy_)
    classname::Function = (x::Sym) -> SymPyCore.classname(x, _sympy_)
    operation::Function = (x::Sym) -> SymPyCore.operation(x)
    arguments::Function = (x::Sym) -> SymPyCore.args(x, _sympy_)
    iscall::Function    = (x::Sym) -> SymPyCore.iscall(x)
end

is_symbolic(x::SymbolicObject) = true
is_symbolic(x) = false

"""
    Introspection.funcname(x)

Return name or ""
"""
function funcname(x::Sym, _sympy_=nothing)
    y = ↓(x)
    if hasproperty(y, :func)
        return string(y.func.__name__)
    else
        return ""
    end
end

func(ex::Sym, _sympy_=nothing) = return ↓(ex).func
function args(x::Sym, _sympy_=nothing)
    y = ↓(x)
    if hasproperty(y, :args)
        return Tuple(Sym(aᵢ) for aᵢ in y.args)
    else
        return ()
    end
end

function class(x::T, _sympy_=nothing) where {T}
    y = ↓(x)
    if hasproperty(y, :__class__)
        return y.__class__
    else
        return nothing
    end
end

function classname(x::T, _sympy_=nothing) where {T}
    cls = class(x)
    if cls == nothing
        "NULL"
    else
        string(cls.__name__)
    end
end

# function getmembers(x::T) where {T <: Union{Sym, PyObject}}
#     Dict(u=>v for (u,v) in inspect.getmembers(x))
# end

## --------------------------------------------------
# Methods for TermInterface
function TermInterface.iscall(x::SymbolicObject)
    hasproperty(↓(x), :is_Atom) && return !x.is_Atom
    return false
end

function TermInterface.operation(x::SymbolicObject)
    @assert iscall(x)
    nm = funcname(x)
    λ = get(sympy_fn_julia_fn, nm, nothing)
    isnothing(λ) && return getfield(Main, Symbol(nm))
    return first(λ)
end

TermInterface.arguments(x::SymbolicObject) = [aᵢ for aᵢ in args(x)]

function TermInterface.maketerm(T::Type{<:SymbolicObject}, head, args, metadata)
    return head(Iterators.flatten(args)...)
end

# make symbols
function TermInterface.maketerm(T::Type{<:SymbolicObject}, ::Nothing, args, metadata)
    Sym.(args)
end

## -----
# desired extensions to TermInterface for `exchange`
# is x a variable
function issym(x::SymbolicObject)
    iscall(x) && return false
    x.is_Atom && !x.is_number
end

makesymbol(T::Type{<:SymbolicObject}, x::Symbol) = maketerm(T, nothing, (x,), nothing)

value(x) = N(x)

## Exchange
## Use TermInterface to switch between different symbolic types
_issymbol(x) = false
_issymbol(x::Sym) = issym(x)

_value(x) = x
_value(x::Sym) = value(x)

_makesymbol(T::Type{<:SymbolicObject}, x::Symbol) = makesymbol(T, x)

"""
    exchange(T, ex::𝑇)
    exchange(T)

Exchange an expression in one symbolic representation with another.

## Example

This shows how to exchange between `SymPy` with `SymbolicUtils`:

```
import SymPy
T = SymPy.Sym

import SymbolicUtils
𝐓 = SymbolicUtils.BasicSymbolic

import SymPyCore: exchange, _issymbol, _value, _makesymbol
_issymbol(x::𝐓) = SymbolicUtils.issym(x)
_value(x::𝐓) = x
_makesymbol(::Type{<:𝐓}, 𝑥::Symbol) = SymbolicUtils.Sym{Number}(𝑥)

SymPy.@syms x y
ex = x * tanh(exp(x)) - max(0, y)

ex |> exchange(𝐓) isa 𝐓
ex |> exchange(𝐓) |> exchange(T) isa T

SymbolicUtils.@syms x y
ex = y*cos(x)^2
ex′ = exchange(T, ex)
𝑥, 𝑦 = SymPy.free_symbols(ex′)
ex′ = SymPy.integrate(ex′, 𝑥) # y*(x/2 + sin(x)*cos(x)/2)
exchange(𝐓, ex′)              # y*((1//2)*x + (1//2)*sin(x)*cos(x))
```

**EXPERIMENTAL** -- interface is subject to change.

"""
function exchange(T, ex)
    if iscall(ex)
        op = operation(ex)
        args = arguments(ex)
        args′ = exchange.(T, args)
        return maketerm(T, op, collect(args′), metadata(ex))
    elseif _issymbol(ex)
        return _makesymbol(T, Symbol(ex))
    else
        return _value(ex)
    end
end

exchange(T) = Base.Fix1(exchange, T)

## --------------------------------------------------

# lambdify an expression

## Mapping of SymPy Values into julia values
val_map = Dict(
               "Zero"             => :(0),
               "One"              => :(1),
               "NegativeOne"      => :(-1),
               "Half"             => :(1/2),
               "Pi"               => :pi,
               "Exp1"             => :ℯ,
               "Infinity"         => :Inf,
               "NegativeInfinity" => :(-Inf),
    "ComplexInfinity"  => :Inf, # error?
    "NaN" => :NaN,
               "ImaginaryUnit"    => :im,
               "BooleanTrue"      => :true,
               "BooleanFalse"     => :false
               )

## Mapping of Julia function names into julia ones
## most are handled by Symbol(fnname), the following catch exceptions
## Hack to avoid Expr(:call,  :*,2, x)  being  2x and  not  2*x
## As of newer sympy versions, this is no longer needed.

# Some julia functions for use within lambdify
function _piecewise(args...)
    as = copy([args...])
    val, cond = pop!(as)
    ex = Expr(:call, :ifelse, cond, convert(Expr,val), :NaN)
    while length(as) > 0
        val, cond = pop!(as)
        ex = Expr(:call, :ifelse, cond, convert(Expr,val), convert(Expr, ex))
    end
    ex
end

_ANY_(xs...) = any(xs) # any∘tuple ?
_ALL_(xs...) = all(xs) # all∘tuple
_ZERO_(xs...) = 0      #
# not quite a match; NaN not θ(0) when evaluated at 0 w/o second argument
_HEAVISIDE_(a...)  = (a[1] < 0 ? 0 : (a[1] > 0 ? 1 : (length(a) > 1 ? a[2] : NaN)))
_sinc_(x) = iszero(x) ? 1 : sin(x)/x # sympy.sinc ->

## Map to get function object from type information
# we may want fn or expression, Symbol(+) yields :+ but allocates to make a string
sympy_fn_julia_fn = Dict(
    "Add" => (+, :+),
    "Sub" => (-, :-),
    "Mul" => (*, :*),
    "Div" => (/, :/),
    "Pow" => (^, :^),
    "re"  => (real, :real),
    "im"  => (imag, :imag),
    "Abs" => (abs, :abs),
    "Min" => (min, :min),
    "Max" => (max, :max),
    "Poly" => (identity, :identity),
    "conjugate" => (conj, :conj),
    "atan2" => (atan, :atan),
    #
    "Less" => (<, :(<)),
    "LessThan" => (<=, :(<=)),
    "StrictLessThan" => (<, :(<)),
    "Equal" => (==, :(==)),
    "Equality" => (==, :(==)),
    "Unequality" => (!==, :(!==)),
    "StrictGreaterThan" => (>, :(>)),
    "GreaterThan" => (>=, :(>=)),
    "Greater" => (>, :(>)),
    #
    "sinc" => (SymPyCore._sinc_, :(SymPyCore._sinc_)),
    "Piecewise" => (SymPyCore._piecewise,  :(SymPyCore._piecewise)),
    "Heaviside" => (SymPyCore._HEAVISIDE_, :(SymPyCore._HEAVISIDE_)),
    "Order" =>     (SymPyCore._ZERO_,      :(SymPyCore._ZERO_)),
    "And" =>       (all∘tuple,             :(SymPyCore._ALL_)),
    "Or" =>        (any∘tuple,             :(SymPyCore._ANY_)),
)


const  fn_map = Dict(k => last(v) for (k,v) ∈ pairs(sympy_fn_julia_fn))

map_fn(key, fn_map) = haskey(fn_map, key) ? fn_map[key] :
    isdefined(@__MODULE__, Symbol(key)) ? Symbol(key) :
    error("Lambdify doesn't know what to do with $key. Sorry.")

##

Base.convert(::Type{Expr}, x::SymbolicObject) = walk_expression(x)

"""
    walk_expression(ex; values=Dict(), fns=Dict())

Convert a symbolic SymPy expression into a `Julia` expression. This is needed to use functions in external packages in lambdified functions.

# Extended help

## Example

```julia
using SymPy
@syms x y
ex = sympy.hyper((2,2),(3,3),x) * y
```

Calling `lambdify(ex)` will fail to make a valid function, as `hyper` is implemented in `HypergeometricFunctions.pFq`. So, we have:

```julia
using HypergeometricFunctions
d = Dict("hyper" => :pFq)
body = SymPy.walk_expression(ex, fns=d)
syms = Symbol.(free_symbols(ex))
fn = eval(Expr(:function, Expr(:call, gensym(), syms...), body));
fn(1,1) # 1.6015187080185656
```

"""
operation_name(ex) = funcname(ex)
const _vd = Dict{String, Symbol}()
const _fd = Dict{String, Symbol}()


function walk_expression(ex;
                     values=_vd,
                     fns=_fd)

    fns_map = merge(fn_map, fns) # these modify
    vals_map = merge(val_map, values)

    op = operation_name(ex)

    # base cases variables, numbers
    if !iscall(ex)
        if any(==(op),  ("Symbol", "Dummy", "IndexedBase"))
            str_ex = string(ex)
            return get(vals_map, str_ex, Symbol(str_ex))
        elseif any(==(op), ("Integer", "Float"))
            return N(ex)
        elseif any(==(op), ("Rational",))
            return N(numerator(ex)) / N(denominator(ex))
        end
    end

    # special cases
    haskey(vals_map, op) && return vals_map[op]

    hasmethod(walk_expression_case, (Val{Symbol(op)}, typeof(ex))) &&
        return walk_expression_case(Val(Symbol(op)), ex; values, fns)

    # special case `F(t) = ...` output from ODE
    # this may be removed if it proves a bad idea....
    if op == "Equality" && lhs(ex).is_Function
        return walk_expression(rhs(ex); values, fns)
    end

    op′ = map_fn(op, fns_map)
    args′ = walk_expression.(args(ex); values, fns)

    Expr(:call, op′, args′...)

end


function walk_expression_case(::Val{:Piecewise}, ex; values=_vd, fns=_fd)
    return _piecewise(walk_expression.(args(ex); values, fns)...)
end

function walk_expression_case(::Val{:ExprCondPair}, ex; values=_vd, fns=_fd)
        val, cond = args(ex)
        return (val, walk_expression(cond; values, fns))
end

function walk_expression_case(::Val{:Tuple}, ex; values=_vd, fns=_fd)
    args′ = walk_expression.(args(ex); values, fns)
    return Expr(:tuple, args′...)
end

function walk_expression_case(::Val{:Indexed}, ex; values=_vd, fns=_fd)
    args′ = walk_expression.(args(ex); values, fns)
    return Expr(:ref, args′...)
end

function walk_expression_case(::Val{:Pow}, ex; values=_vd, fns=_fd)
    a, b = args(ex)
    aargs′ = walk_expression(a; values, fns)
    b == 1//2 && return Expr(:call, :sqrt, aargs′)
    b == 1//3 && return Expr(:call, :cbrt, aargs′)
    bargs′ = walk_expression.(b; values, fns)
    return Expr(:call, :^, aargs′, bargs′)
end

function _integral_case(op::Val{X}, ex; values=_vd, fns=_fd) where X
    expr, lims... = args(ex)

    respect = first.(args.(lims))

    fxargs = walk_expression(expr; values=values, fns=fns)
    fn_expr = Expr(:->, Expr(:tuple, Symbol.(respect)...), fxargs)


    lim_ranges = [Expr(:tuple, walk_expression.(Base.tail(args(lim)), values=values, fns=fns)...) for lim in lims]

    op = map_fn(string(X), fns)

    return Expr(:call, op, fn_expr, lim_ranges...)
end
walk_expression_case(op::Val{:Integral}, ex; values=_vd, fns=_fd) =
    _integral_case(op, ex; values, fns)
walk_expression_case(op::Val{:NonElementaryIntegral}, ex; values=_vd, fns=_fd) =
    _integral_case(op, ex; values, fns)




struct 𝐹{F,E,N} <: Function

    λ::F
    expr::E
    xs::NTuple{N, Symbol}
end

function Base.show(io::IO, ::MIME"text/plain", F::𝐹)
    vars = isempty(F.xs) ? "no variables" :
        length(F.xs) == 1 ? "a single variable $(only(F.xs))" :
        "variables $(F.xs)"
    print(io, "Callable function with $vars")
end

(F::𝐹)() = F.λ()
(F::𝐹{FF,E,0})(xs...) where {FF, E} = F.λ() # no vars can be called in which way
(F::𝐹)(x) = F.λ(x...)
(F::𝐹)(x, xs...) = F.λ(x, xs...)

function Base.iterate(F::𝐹, state=nothing)
    isnothing(state) && return (F.xs,1)
    state == 1 && return ((), 2)
    state == 2 && return (F.expr, 3)
    return nothing
end

#

"""
    lambdify(ex, vars...;
             fns=Dict(), values=Dict,
             expression = Val{false},
             conv = walk_expression,
             use_julia_code=false,
             invoke_latest=true)

Take a symbolic expression and return a `Julia` struct subtyping `Function` or expression to build a function. The struct contains the expression.

* `ex::Sym` a symbolic expression with 0, 1, or more free symbols

* `vars` Either a tuple of variables or each listed separately, defaulting to `free_symbols(ex)` and its ordering. If `vars` is empty, a 0-argument function is returned.

* `fns::Dict`, `vals::Dict`: Dictionaries that allow customization of the function that walks the expression `ex` and creates the corresponding AST for a Julia expression. See `SymPy.fn_map` and `SymPy.val_map` for the default mappings of sympy functions and values into `Julia`'s AST.

# `expression`: the default, `Val{false}`, will return a callable struct; passing `Val{true}` will return the expression. (This is also in the `expr` field of the struct, so changing this is unnecessary.) (See also `invoke_latest=false`.)

* `conv`: a method to convert a symbolic expression into an expression. The default is part of this package; the alternative, the unexpored `julia_code`, is from the Python package. (See also `use_julia_code`)

* `use_julia_code::Bool`: use SymPy's conversion to an expression, the default is `false`

* `invoke_latest=true`: if `true` will call `eval` and `Base.invokelatest` to return a function that should not have any world age issue. If `false` will return a Julia expression that can be `eval`ed to produce a function.

Example:

```jldoctest lambdify
julia> using SymPyPythonCall

julia> @syms x y z
(x, y, z)

julia> ex = x^2 * sin(x)
 2
x ⋅sin(x)

julia> fn = lambdify(ex);

julia> fn(pi)
0.0

julia> ex = x + 2y + 3z
x + 2⋅y + 3⋅z

julia> fn = lambdify(ex);

julia> fn(1,2,3) # order is by free_symbols
14

julia> ex(x=>1, y=>2, z=>3)
14

julia> fn = lambdify(ex, (y,x,z));

julia> fn(1,2,3)
13
```

!!! note

    The default produces slower functions due to the calls to `eval` and
    `Base.invokelatest`.  In the following `g2` (which, as seen, requires
    additional work to compute) is as fast as calling `f` (on non symbolic
    types), whereas `g1` is an order of magnitude slower in this example.

```julia lambdify
julia> @syms x
(x,)

julia> f(x) = exp(cot(x))
f (generic function with 1 method)

julia> g1 = lambdify(f(x));

julia> ex = lambdify(f(x), invoke_latest=false);

julia> @eval g2(x) = (\$ex)(x)
g2 (generic function with 1 method)
```

A performant and easy alternative, say, is to use `GeneralizedGenerated`'s `mk_function`, as follows:

```julia
julia> using GeneralizedGenerated, BenchmarkTools

julia> f(x,p) = x*tanh(exp(p*x));

julia> @syms x p; g = lambdify(f(x,p), x, p)
Callable function with variables (:x, :p)

julia> gg = mk_function(g...);

julia> @btime \$g(1,2)
  48.862 ns (1 allocation: 16 bytes)
0.9999992362042291

julia> @btime \$gg(1,2)
 1.391 ns (0 allocations: 0 bytes)
0.9999992362042291

julia> @btime \$f(1,2)
  1.355 ns (0 allocations: 0 bytes)
0.9999992362042291

```

As seen, the function produced by `GeneralizedGenerated` is as performant as the original, and **much** more so than calling that returned by `lambdify`, which uses a call to `Base.invokelatest`.

"""
function lambdify(ex::SymbolicObject; kwargs...)
    vars = free_symbols(ex)
    _λfy(ex, vars...; kwargs...)
end
lambdify(ex::SymbolicObject, xs...; kwargs...) = _λfy(ex, xs...; kwargs...)
lambdify(ex::SymbolicObject, xs::Tuple; kwargs...) = _λfy(ex, xs...; kwargs...)
lambdify(ex::SymbolicObject, xs::AbstractArray; kwargs...) = _λfy(ex, xs...; kwargs...)

# from @mistguy cf. https://github.com/JuliaPy/SymPy.jl/issues/218
# T a data type to convert to, when specified
function lambdify(exs::Array{S, N}, vars = union(free_symbols.(exs)...); T::DataType=Nothing, kwargs...) where {S <: Sym, N}
    #f = λfy.(exs, (vars,)) # prevent broadcast in vars
    f = _λfy.(exs, vars...) # prevent broadcast in vars
    if T == Nothing
        (args...) -> map.(f, args...)
    else
        (args...) -> convert(Array{T,N}, map.(f, args...))
    end
end


function _λfy(ex, xs...;
              invoke_latest = true,
              use_julia_code=false,
              expression = Val{false},
              conv = walk_expression,
              kwargs...)

    # legacy arguments
    use_julia_code && (conv = julia_code)
    !invoke_latest && (expression = Val{true})

    body = conv(ex; kwargs...)
    syms = Symbol.(xs)
    λ = Expr(:->, Expr(:tuple, syms...), body)

    if expression == Val{true}
        return λ
    else
        fn = eval(λ)
        λ′ = (args...) -> Base.invokelatest(fn, args...)
        return 𝐹(λ′, body, syms)
        return 𝐹(GeneralizedGenerated.mk_function(expression_module, λ), body, syms)
    end
end

julia_code() = nothing # stub for function to convert in SymPy/

# convert alternative to lambdify
Base.convert(::Type{Function}, ex::Sym) = lambdify(ex)

# Should deprecate, as one can just use lambdify and grab expr
# convert symbolic expression to julia AST
# more flexibly than `convert(Expr, ex)`
function convert_expr(ex::Sym;
                      fns=Dict(), values=Dict(),
                      use_julia_code=false)
    _convert_expr(Val(use_julia_code), ex, fns=fns, values=values)
end

# _convert_expr(use_julia_code::Val(true}, ex; kwargs...) defined in sympy
function _convert_expr(::Val{false}, ex::SymbolicObject; fns=Dict(), values=Dict())
    walk_expression(ex; fns = fns, values=values)
end

using Documenter

using SymPyCore

# xxx need means to incorporate docs for methods defined in SymPy glue package

makedocs(
    sitename = "SymPyCore",
    format = Documenter.HTML(),
    modules = [SymPyCore],
    doctest = false, # true once SymPyPythonCall brought on board
    warnonly = [:cross_references, :missing_docs], # <-- what can be relaxed
    pages = [
        "Home" => "index.md",
        "Introduction" => "introduction.md",
        "SymPy Tutorial" => [
            "Home"             => "Tutorial/index.md",
            "Preliminaries"    => "Tutorial/preliminaries.md",
            "Introduction"     => "Tutorial/intro.md",
            "Basic operations" => "Tutorial/basic_operations.md",
            "Simplification"   => "Tutorial/simplification.md",
            "Calculus"         => "Tutorial/calculus.md",
            "Solvers"          => "Tutorial/solvers.md",
            "Matrices"         => "Tutorial/matrices.md",
            "Manipulation"     => "Tutorial/manipulation.md",
            "Gotchas"          => "Tutorial/gotchas.md",
            "printing"         => "Tutorial/printing.md",
            "Next"             => "Tutorial/next.md"
        ],
        "Overview" => "overview.md",
        "Reference/API" => "reference.md"
    ],

)


#=
=#
# Documenter can also automatically deploy documentation to gh-pages.
# See "Hosting Documentation" and deploydocs() in the Documenter manual
# for more information.

deploydocs(
    repo = "github.com/jverzani/SymPyCore.jl.git"
)

# test pattern matching

#     ## match, replace, xreplace, rewrite
#     x,y,z = symbols("x, y, z")
#     #a,b,c = map(sympy.Wild, (:a,:b,:c)) ## XXX Wild needs strings -- not symbols
#     a,b,c = map(sympy.Wild, ("a", "b", "c")) ## XXX Wild needs strings -- not symbols
#     # ## match: we have pattern, expression to follow `match`
#     d = match(a^a, (x+y)^(x+y))
#     @test d[a] == x+y
#     d = match(a^b, (x+y)^(x+y))
#     @test d[b] == x + y
#     ex = (2x)^2
#     pat = a*b^c
#     d = match(pat, ex)
#     @test d[a] == 4 && d[b] == x && d[c] == 2
#     @test pat.xreplace(d) == 4x^2

#     ## replace
#     a = Wild("a")
#     ex = log(sin(x)) + tan(sin(x^2))
#     ##XXX    @test replace(ex, func(sin(x)), u ->  sin(2u)) == log(sin(2x)) + tan(sin(2x^2))
#     @test replace(ex, func(sin(x)), func(tan(x))) == log(tan(x)) + tan(tan(x^2))
#     @test replace(ex, sin(a), tan(a)) ==  log(tan(x)) + tan(tan(x^2))
#     @test replace(ex, sin(a), a) == log(x) + tan(x^2)
#     @test replace(x*y, a*x, a) == y

#     ## xreplace
#     @test (1 + x*y).xreplace(Dict(x => PI)) == 1 + PI*y
#     @test (x*y + z).xreplace(Dict(x*y => PI)) == z + PI
#     @test (x*y * z).xreplace(Dict(x*y => PI)) == x* y * z
#     @test (x + 2 + exp(x + 2)).xreplace(Dict(x+2=>y)) == x + exp(y) + 2

# # generic method pattern: (pymodule, pymethod, juliamodule, juliamethod)
# # these don't need to be exported
# # in SymPy we use getmembers to generate this; not sure what is better
# #const
##--------------------------------------------------
# generic method pattern: (pymodule, pymethod, juliamodule, juliamethod)
# these don't need to be exported
# in SymPy we use getmembers to generate this; not sure what is better
#const
generic_methods = (
    (:_sympy_, :cos, :Base, :cos),
    (:_sympy_, :sin, :Base, :sin),
    (:_sympy_, :tan, :Base, :tan),
    (:_sympy_, :sec, :Base, :sec),
    (:_sympy_, :csc, :Base, :csc),
    (:_sympy_, :cot, :Base, :cot),
    (:_sympy_, :acos, :Base, :acos),
    (:_sympy_, :asin, :Base, :asin),
    #(:_sympy_, :atan, :Base, :atan), # need 2 arg version
    (:_sympy_, :asec, :Base, :asec),
    (:_sympy_, :acsc, :Base, :acsc),
    (:_sympy_, :acot, :Base, :acot),


    #
    (:_sympy_, :cosh,  :Base, :cosh),
    (:_sympy_, :sinh,  :Base, :sinh),
    (:_sympy_, :tanh,  :Base, :tanh),
    (:_sympy_, :sech,  :Base, :sech),
    (:_sympy_, :csch,  :Base, :csch),
    (:_sympy_, :coth,  :Base, :coth),
    (:_sympy_, :acosh, :Base, :acosh),
    (:_sympy_, :asinh, :Base, :asinh),
    (:_sympy_, :atanh, :Base, :atanh),
#    (:_sympy_, :asech, :Base, :asech),
#    (:_sympy_, :acsch, :Base, :acsch),
    (:_sympy_, :acoth, :Base, :acoth),
    #
    (:_sympy_, :sqrt, :Base, :sqrt),
    (:_sympy_, :exp,  :Base, :exp),
#    (:_sympy_, :log, :Base, :log),
    (:_sympy_, :factorial, :Base, :factorial),
    #
    (:_sympy_, :Mod,     :Base, :mod),
    (:_sympy_, :floor,   :Base, :floor),
    (:_sympy_, :ceiling, :Base, :ceil),
    #
    (:_sympy_, :numer, :Base, :numerator),
    (:_sympy_, :denom, :Base, :denominator),
    (:_sympy_, :Max,   :Base, :max),
    (:_sympy_, :Abs,   :Base, :abs),
    (:_sympy_, :Min,   :Base, :min),
    #
    (:_sympy_, :re,        :Base, :real),
    (:_sympy_, :im,        :Base, :imag),
    (:_sympy_, :transpose, :Base, :transpose),
    #
    (:_sympy_, :sign,  :Base, :sign),
    #
    (:_sympy_, :diff,  :Base, :diff),

    # solve
    (:_sympy_, :solve, :CommonSolve, :solve),

    # Eq
    #(:_sympy_, :Eq, :CommonEq, :Eq),
    #(:_sympy_, :Lt, :CommonEq, :Lt),
    #(:_sympy_, :Le, :CommonEq, :Le),
    #(:_sympy_, :Ne, :CommonEq, :Ne),
    #(:_sympy_, :Ge, :CommonEq, :Ge),
    #(:_sympy_, :Gt, :CommonEq, :Gt),


    # collect
    #(:_sympy_, :collect, :Base, :collect),

    # SpecialFunctions
    (:_sympy_, :airyai ,      :SpecialFunctions, :airyai),
    (:_sympy_, :airyaiprime , :SpecialFunctions, :airyaiprime),
    (:_sympy_, :airybi ,      :SpecialFunctions, :airybi),
    #(:_sympy_, :besseli ,     :SpecialFunctions, :besseli),
    #(:_sympy_, :besselj ,     :SpecialFunctions, :besselj),
    #(:_sympy_, :besselk ,     :SpecialFunctions, :besselk),
    #(:_sympy_, :bessely ,     :SpecialFunctions, :bessely),
    (:_sympy_, :beta ,        :SpecialFunctions, :beta),
    (:_sympy_, :elliptic_e ,  :SpecialFunctions, :ellipe),
    (:_sympy_, :elliptic_k ,  :SpecialFunctions, :ellipk),
    (:_sympy_, :erf ,         :SpecialFunctions, :erf),
    (:_sympy_, :erfc ,        :SpecialFunctions, :erfc),
    (:_sympy_, :erfi ,        :SpecialFunctions, :erfi),
    (:_sympy_, :erfinv ,      :SpecialFunctions, :erfinv),
    (:_sympy_, :erfcinv ,     :SpecialFunctions, :erfcinv),
    (:_sympy_, :gamma ,       :SpecialFunctions, :gamma),
    (:_sympy_, :digamma ,     :SpecialFunctions, :digamma),
    (:_sympy_, :polygamma ,   :SpecialFunctions, :polygamma),
    (:_sympy_, :hankel1,      :SpecialFunctions, :hankelh1),
    (:_sympy_, :hankel2,      :SpecialFunctions, :hankelh2),
    (:_sympy_, :zeta ,        :SpecialFunctions, :zeta),
)

## --------------------------------------------------
# pmod, pmeth, meth
#const
# XXX how to document these things>
# XXX maybe move this to SymPyCore?
new_exported_methods = (
    #
    (:_sympy_, :simplify,    :simplify),
    (:_sympy_, :expand,      :expand),
    (:_sympy_, :together,    :together),
    (:_sympy_, :apart,       :apart),
    (:_sympy_, :factor,      :factor),
    (:_sympy_, :cancel,      :cancel),
    #
    (:_sympy_, :degree,      :degree),
    #
    (:_sympy_, :integrate,   :integrate),
    #
    (:_sympy_, :real_roots,  :real_roots),
    (:_sympy_, :roots,       :roots),
    (:_sympy_, :nroots,      :nroots),
    #(:_sympy_, :dsolve,      :dsolve),
    (:_sympy_, :nsolve,      :nsolve),
    (:_sympy_, :linsolve,    :linsolve),
    (:_sympy_, :nonlinsolve, :nonlinsolve),
    (:_sympy_, :solveset,    :solveset),
    #
    (:_sympy_, :series,      :series),
    (:_sympy_, :summation,   :summation),
    (:_sympy_, :hessian,     :hessian),
    #
    #(:_sympy_, :ask,         :ask),
    (:_sympy_, :refine,      :refine),
    #
    (:_sympy_, :Heaviside,   :Heaviside),
)

## --------------------------------------------------
# M.meth
matrix_meths = (
    (:adjoint, :Base, :adjoint),
    (:exp, :Base, :exp),
    (:inv, :Base, :inv),
    (:transpose, :Base, :transpose),
    (:det, :LinearAlgebra, :det),
    #(:diag, :LinearAlgebra, :diag),
    #(:eigenvects, :LinearAlgebra, :eigvecs),
    #(:eigenvals, :LinearAlgebra, :eigvals),
    (:norm, :LinearAlgebra, :norm),
    (:pinv, :LinearAlgebra, :pinv),
    (:rank, :LinearAlgebra, :rank),
)

## --------------------------------------------------
object_methods = (
    (:conjugate, :Base, :conj),
)


# ## --------------------------------------------------



# set up ↓, ↑ uparrow, downarrow
# set up ↑, ↓, ↓ₖ
"""
   ↓(::SymbolicObject)
   ↓ₖ([kwargs...])

The `\\downarrrow[tab]` and `\\downarrow[tab]\\_k[tab]` operators
push a symbolic object (or a container of symbolic objects) into a Python counterpart
for passing to an underlying Python function.
"""
↓(x::SymbolicObject) = x.o
↓(x) = ↓(↑(x))
#↓(x::AbstractString) = ↓(↑(x))
↓(x::Tuple) = Tuple(↓(xᵢ) for xᵢ ∈ x)
↓(x::AbstractArray) = map(↓, x)
↓(x::Pair) = (↓(first(x)), ↓(last(x))) # Not the most useful?

↓ₖ(kw) = collect(k => ↓(v) for (k,v) ∈ kw) # unsym NamedTuple?
#↓ₖ(kw) = tuple((k => ↓(v) for (k,v) ∈ kw)...) # unsym NamedTuple?


"""
   ↑(::SymbolicObject)

Method to lift a python object into a symbolic counterpart.
"""
↑(x::Sym) = x
↑(x) = ↑(typeof(x), x)
↑(::Type{<:Dict}, x) = Dict(↑(k) => ↑(v) for (k,v) ∈ pairs(x))
↑(::Type{<:AbstractArray}, x) = map(↑, x)
↑(::Type{<:Tuple}, x) = map(↑, x)
↑(::Any, x) = Sym(x)

"""
    SymbolicCallable

Wrapper for python objects with a `__call__` method. This is used by
`sympy.λ` to call the underlying `λ` function without the user needing
to manually convert `Julia` objects into `Python` objects and back.

!!! note
    There are *some* times where this doesn't work well, and using `sympy.o.λ` along with `↓` and `↑` will work.
"""
struct SymbolicCallable{T}
    𝑓::T
end

Base.show(io::IO, λ::SymbolicCallable) = print(io, "Callable SymPy method")
function (v::SymbolicCallable)(args...; kwargs...)
    as = map(↓, args)
    if isempty(kwargs)
        val = v.𝑓(as...)
    else
        kws = (k => ↓(v) for (k,v) ∈ kwargs)
        val = v.𝑓(as...; kws...)
    end
    ↑(val)
end

## --------------------------------------------------

## Document newly exported methods
# tpl = """
# \"\"\"
#     {{:nm}}

# [SymPy documentation](https://docs.sympy.org/latest/search.html?q={{:nm}}&check_keywords=yes&area=default)
# \"\"\"
# {{:nm}}() = nothing
# """
# for r ∈ new_exported_methods
#     print(Mustache.render(tpl, nm=last(r))); println()
# end

"""
    simplify

Simplify symbolic expressions.

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=simplify&check_keywords=yes&area=default)
"""
simplify() = nothing


"""
    expand

Expand a symbolic expression. See [`factor`](@ref).

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=expand&check_keywords=yes&area=default)
"""
expand() = nothing

"""
    together

Combine rational expressions. See [`apart`](@ref).

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=together&check_keywords=yes&area=default)
"""
together() = nothing

"""
    apart

Partial fraction decomposition. See [`together`](@ref).
[SymPy documentation](https://docs.sympy.org/latest/search.html?q=apart&check_keywords=yes&area=default)
"""
apart() = nothing

"""
    factor

Factor an expression. See [`expand`](@ref).
[SymPy documentation](https://docs.sympy.org/latest/search.html?q=factor&check_keywords=yes&area=default)
"""
factor() = nothing

"""
    cancel

Take any rational expression and put it into the standard canonical form, ``p/q``.
[SymPy documentation](https://docs.sympy.org/latest/search.html?q=cancel&check_keywords=yes&area=default)
"""
cancel() = nothing

"""
    degree

Return degree of expression in a given variable. Not exported.

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=degree&check_keywords=yes&area=default)
"""
degree() = nothing

"""
    integrate

Integrate an expression. Can return definite or indefinite integral.

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=integrate&check_keywords=yes&area=default)
"""
integrate() = nothing

"""
    roots

Find roots of a polynomial. Not exported, so needs to be qualified, as in `sympy.roots`.

## Example
```
julia> sympy.roots(x^2 - 2x - 3)
Dict{} with 2 entries:
  3  => 1
  -1 => 1
```

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=roots&check_keywords=yes&area=default)
"""
roots() = nothing


"""
    real_roots

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=real_roots&check_keywords=yes&area=default)
"""
real_roots() = nothing


"""
    nroots

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=nroots&check_keywords=yes&area=default)
"""
nroots() = nothing


"""
    nsolve

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=nsolve&check_keywords=yes&area=default)
"""
nsolve() = nothing

"""
    linsolve

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=linsolve&check_keywords=yes&area=default)
"""
linsolve() = nothing

"""
    nonlinsolve

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=nonlinsolve&check_keywords=yes&area=default)

!!! note "Systems"
    Use a tuple, not a vector, of equations when there is more than one.

"""
nonlinsolve() = nothing

"""
    solveset

Like `solve` but returns a set object. Finite sets are returned as `Set` objects in `Julia`. Infinite sets must be queried.

# Example
```
julia> @syms x
(x,)

julia> u = solveset(sin(x) ~ 1//2, x)
⎧        5⋅π │      ⎫   ⎧        π │      ⎫
⎨2⋅n⋅π + ───  │ n ∊ ℤ⎬ ∪ ⎨2⋅n⋅π + ─ │ n ∊ ℤ⎬
⎩         6  │      ⎭   ⎩        6 │      ⎭

julia> intersect(u, sympy.Interval(0, 2PI))
Set{Sym} with 2 elements:
  pi/6
  5*pi/6
```

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=solveset&check_keywords=yes&area=default)
"""
solveset() = nothing

"""
    series

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=series&check_keywords=yes&area=default)
"""
series() = nothing

"""
    summation

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=summation&check_keywords=yes&area=default)
"""
summation() = nothing


"""
    ask

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=ask&check_keywords=yes&area=default)
"""
ask() = nothing

"""
    refine

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=refine&check_keywords=yes&area=default)
"""
refine() = nothing

"""
    Heaviside

[SymPy documentation](https://docs.sympy.org/latest/search.html?q=Heaviside&check_keywords=yes&area=default)
"""
Heaviside() = nothing

## constructors

Sym(x::AbstractString) = ↑(_sympy_.symbols(x))
Sym(x::Number) = ↑(_sympy_.sympify(x)) # slower that Sym(Py(x)), but more idiomatic
Sym(x::Irrational{:π}) = PI
Sym(x::Irrational{:ℯ}) = E
Sym(x::Irrational{:φ}) = (1 + sqrt(Sym(5))) / 2
Sym(x::Rational) = ↑(_sympy_.Rational(numerator(x), denominator(x)))
function Sym(x::Complex{Bool})
    !x.re &&  x.im && return IM
    !x.re && !x.im && return Sym(0)
     x.re && !x.im && return Sym(1)
     x.re &&  x.im && return Sym(1) + IM
end
Sym(x::Complex{T}) where {T} = Sym(real(x)) + Sym(imag(x)) * IM

# workaround to get inferrability
Sym{P}(x::AbstractString) where {P} = ↑(_sympy_.symbols(x))::Sym{P}
Sym{P}(x::Number) where {P} = Sym{P}(_sympy_.sympify(x))::Sym{P} # slower that Sym(Py(x)), but more idiomatic
Sym{P}(x::Irrational{:π}) where {P} = PI::Sym{P}
Sym{P}(x::Irrational{:ℯ}) where {P} = E::Sym{P}
Sym{P}(x::Irrational{:φ}) where {P} = ((1 + sqrt(Sym{P}(5))) / 2)::Sym{P}
Sym{P}(x::Rational) where {P} = Sym{P}(_sympy_.Rational(numerator(x), denominator(x)))::Sym{P}
function Sym{P}(x::Complex{Bool}) where {P}
    !x.re &&  x.im && return IM
    !x.re && !x.im && return Sym{P}(0)
     x.re && !x.im && return Sym{P}(1)
     x.re &&  x.im && return Sym{P}(1) + IM
end
Sym{P}(x::Complex{T}) where {P,T} = Sym{P}(real(x)) + Sym{P}(imag(x)) * IM

## ---

sympify(x; kwargs...) = ↑(_sympy_.sympify(x; kwargs...))

# ↓ for Vector, Matrix we convert to a matrix
import SymPyCore: ↓
(↓)(x::Vector{<:Sym}) = _sympy_.Matrix(Tuple(map(↓, reshape(x, length(x), 1))))
function (↓)(M::AbstractMatrix{<:Sym})
    _sympy_.Matrix(Tuple(map(↓, Mᵢ) for Mᵢ ∈ eachrow(M)))
end

function Base.getproperty(M::AbstractArray{<:Sym, N}, prop::Symbol) where {N} #XX array or Matrix?
    if prop in fieldnames(typeof(M))
        return getfield(M, prop)
    end
    getproperty(Sym(↓(M)), prop)
end

## ----

function symbols(args...; kwargs...)
    as =  _sympy_.symbols(args...; kwargs...)
    hasproperty(as, :__iter__) && return Tuple((↑)(xᵢ) for xᵢ ∈ as)
    return ↑(as)
end

function SymFunction(x::AbstractString; kwargs...)
    xs = split(x, r",\s*")
    length(xs) > 1 ?  _SymFunction.(xs; kwargs...) : _SymFunction(only(xs); kwargs...)
end

function _SymFunction(x; kwargs...)
    out = _sympy_.Function(x; kwargs...)
    SymPyCore.SymFunction(out)
end

macro syms(xs...)
    # If the user separates declaration with commas, the top-level expression is a tuple
    if length(xs) == 1 && isa(xs[1], Expr) && xs[1].head == :tuple
        SymPyCore._gensyms(xs[1].args...)
    elseif length(xs) > 0
        SymPyCore._gensyms(xs...)
    end
end

## constructors
macro syms(xs...)
    # If the user separates declaration with commas, the top-level expression is a tuple
    if length(xs) == 1 && isa(xs[1], Expr) && xs[1].head == :tuple
        _gensyms(xs[1].args...)
    elseif length(xs) > 0
        _gensyms(xs...)
    end
end

function _gensyms(xs...)
    asstokw(a) = Expr(:kw, esc(a), true)

    # Each declaration is parsed and generates a declaration using `symbols`
    symdefs = map(xs) do expr
        decl = parsedecl(expr)
        symname = sym(decl)
        symname, gendecl(decl)
    end
    syms, defs = collect(zip(symdefs...))

    # The macro returns a tuple of Symbols that were declared
    Expr(:block, defs..., :(tuple($(map(esc,syms)...))))
end


# The map_subscripts function is stolen from Symbolics.jl
const IndexMap = Dict{Char,Char}(
    '-' => '₋',
    '0' => '₀',
    '1' => '₁',
    '2' => '₂',
    '3' => '₃',
    '4' => '₄',
    '5' => '₅',
    '6' => '₆',
    '7' => '₇',
    '8' => '₈',
    '9' => '₉')

function map_subscripts(indices)
    str = string(indices)
    join(IndexMap[c] for c in str)
end

# Define a type hierarchy to describe a variable declaration. This is mainly for convenient pattern matching later.
abstract type VarDecl end

struct SymDecl <: VarDecl
    sym :: Symbol
end

struct NamedDecl <: VarDecl
    name :: String
    rest :: VarDecl
end

struct FunctionDecl <: VarDecl
    rest :: VarDecl
end

struct TensorDecl <: VarDecl
    ranges :: Vector{AbstractRange}
    rest :: VarDecl
end

struct AssumptionsDecl <: VarDecl
    assumptions :: Vector{Symbol}
    rest :: VarDecl
end

# Transform a Decl struct in an Expression that calls SymPy to declare the corresponding symbol
function gendecl(x::VarDecl)
    asstokw(a) = Expr(:kw, esc(a), true)
    val = :($(ctor(x))($(name(x, missing)), $(map(asstokw, assumptions(x))...)))
    :($(esc(sym(x))) = $(genreshape(val, x)))
end

# Transform an expression in a Decl struct
function parsedecl(expr)
    # @syms x
    if isa(expr, Symbol)
        return SymDecl(expr)

    # @syms x::assumptions, where assumption = assumptionkw | (assumptionkw...)
    elseif isa(expr, Expr) && expr.head == :(::)
        symexpr, assumptions = expr.args
        assumptions = isa(assumptions, Symbol) ? [assumptions] : assumptions.args
        return AssumptionsDecl(assumptions, parsedecl(symexpr))

    # @syms x=>"name"
    elseif isa(expr, Expr) && expr.head == :call && expr.args[1] == :(=>)
        length(expr.args) == 3 || parseerror()
        isa(expr.args[3], String) || parseerror()

        expr, strname = expr.args[2:end]
        return NamedDecl(strname, parsedecl(expr))

    # @syms x()
    elseif isa(expr, Expr) && expr.head == :call && expr.args[1] != :(=>)
        length(expr.args) == 1 || parseerror()
        return FunctionDecl(parsedecl(expr.args[1]))

    # @syms x[1:5, 3:9]
    elseif isa(expr, Expr) && expr.head == :ref
        length(expr.args) > 1 || parseerror()
        ranges = map(parserange, expr.args[2:end])
        return TensorDecl(ranges, parsedecl(expr.args[1]))
    else
        parseerror()
    end
end

function parserange(expr)
    range = eval(expr)
    isa(range, AbstractRange) || parseerror()
    range
end

sym(x::SymDecl) = x.sym
sym(x::NamedDecl) = sym(x.rest)
sym(x::FunctionDecl) = sym(x.rest)
sym(x::TensorDecl) = sym(x.rest)
sym(x::AssumptionsDecl) = sym(x.rest)

ctor(::SymDecl) = :symbols
ctor(x::NamedDecl) = ctor(x.rest)
ctor(::FunctionDecl) = :SymFunction
ctor(x::TensorDecl) = ctor(x.rest)
ctor(x::AssumptionsDecl) = ctor(x.rest)

assumptions(::SymDecl) = []
assumptions(x::NamedDecl) = assumptions(x.rest)
assumptions(x::FunctionDecl) = assumptions(x.rest)
assumptions(x::TensorDecl) = assumptions(x.rest)
assumptions(x::AssumptionsDecl) = x.assumptions

# Reshape is not used by most nodes, but TensorNodes require the output to be given
# the shape matching the specification. For instance if @syms x[1:3, 2:6], we should
# have size(x) = (3, 5)
genreshape(expr, ::SymDecl) = expr
genreshape(expr, x::NamedDecl) = genreshape(expr, x.rest)
genreshape(expr, x::FunctionDecl) = genreshape(expr, x.rest)
genreshape(expr, x::TensorDecl) = let
    shape = tuple(length.(x.ranges)...)
    :(reshape(collect($(expr)), $(shape)))
end
genreshape(expr, x::AssumptionsDecl) = genreshape(expr, x.rest)

# To find out the name, we need to traverse in both directions to make sure that each node can get
# information from parents and children about possible name.
# This is done because the expr tree will always look like NamedDecl -> ... -> TensorDecl -> ... -> SymDecl
# and the TensorDecl node will need to know if it should create names base on a NamedDecl parent or
# based on the SymDecl leaf.
name(x::SymDecl, parentname) = coalesce(parentname, String(x.sym))
name(x::NamedDecl, parentname) = coalesce(name(x.rest, x.name), x.name)
name(x::FunctionDecl, parentname) = name(x.rest, parentname)
name(x::AssumptionsDecl, parentname) = name(x.rest, parentname)
name(x::TensorDecl, parentname) = let
    basename = name(x.rest, parentname)
    # we need to double reverse the indices to make sure that we traverse them in the natural order
    namestensor = map(Iterators.product(x.ranges...)) do ind
        sub = join(map(map_subscripts, ind), "_")
        string(basename, sub)
    end
    join(namestensor[:], ", ")
end

function parseerror()
    error("Incorrect @syms syntax. Try `@syms x::(real,positive)=>\"x₀\" y() z::complex n::integer` for instance.")
end

"""
    symtype(x=Sym(1))

Return `Sym{T}` for `T` being the uderlying Python type of `x`.
"""
symtype(x::SymbolicObject{T}=Sym(1)) where {T} = Sym{T}
export symtype



# Math and other functions that don't fit metaprogramming pattern
Base.log(x::Sym) = sympy.log(x) # generated method confuses two argument form
Base.log(n::Number, x::Sym) = sympy.log(x, n) # Need to switch order here
Base.log(n::Sym{T}, x::Sym{T}) where {T} = sympy.log(x, n) # Need to switch order here
Base.log2(x::SymbolicObject)  = sympy.log(x, Sym(2)) # sympy.log has different order
Base.log10(x::SymbolicObject) = sympy.log(x, Sym(10)) # sympy.log has different order
Base.atan(x::Sym) = sympy.atan(x) # generated method confuses two argument form
Base.atan(x::Sym, y) = sympy.atan2(x, y)
Base.angle(z::Sym) = atan(imag(z), real(z))
Base.binomial(a::Sym, b::Sym) = sympy.binomial(a, b)
function limit(ex::Sym, xc::Pair; kwargs...) # allow pairs
    sympy.limit(↓(ex), Sym(first(xc)), Sym(last(xc)); kwargs...)
end
Base.xor(x::Sym, y::Sym) = ↑(_sympy_.Xor(↓(x), ↓(y)))
Base.div(x::Sym, y::Sym) = ↑(first(_sympy_.div(↓(x), ↓(y))))
Base.rem(x::Sym, y::Sym) = ↑(_sympy_.rem(↓(x), ↓(y)))

SpecialFunctions.beta(a::Sym, b::Sym) = sympy.beta(a,b)

SpecialFunctions.besseli(n::Number, b::Sym) = sympy.besseli(n, b)

SpecialFunctions.besselj(n::Number, b::Sym) = sympy.besselj(n, b)
SpecialFunctions.besselj0(b::Sym) = sympy.besselj(0, b)
SpecialFunctions.besselj1(b::Sym) = sympy.besselj(1, b)

SpecialFunctions.besselk(n::Number, b::Sym) = sympy.besselk(n, b)

SpecialFunctions.bessely(n::Number, b::Sym) = sympy.bessely(n, b)
SpecialFunctions.bessely0(b::Sym) = sympy.bessely(n, b)
SpecialFunctions.bessely1(b::Sym) = sympy.bessely(n, b)

# no besselix, besseljx, besselkx, or besselyx


# CommonEq
CommonEq.Lt(a::T,b::T) where {T <: SymbolicObject} = sympy.Lt(a,b)
CommonEq.Le(a::T,b::T) where {T <: SymbolicObject} = sympy.Le(a,b)
CommonEq.Eq(a::T,b::T) where {T <: SymbolicObject} = sympy.Eq(a,b)
CommonEq.Ne(a::T,b::T) where {T <: SymbolicObject} = sympy.Ne(a,b)
CommonEq.Ge(a::T,b::T) where {T <: SymbolicObject} = sympy.Ge(a,b)
CommonEq.Gt(a::T,b::T) where {T <: SymbolicObject} = sympy.Gt(a,b)

LinearAlgebra.norm(x::AbstractVector{T}, args...; kwargs...) where {T <: SymbolicObject} =
    ↑(getproperty(sympy.Matrix(Tuple(xᵢ for xᵢ ∈ x)), :norm)(↓(args)...; ↓ₖ(kwargs)...))

function dsolve(eqn, args...;
                ics::Union{Nothing, AbstractDict, Tuple}=nothing,
                kwargs...)
    sympy.dsolve(eqn, args...; ics=ics, kwargs...)
end


SymPyCore.Wild(x::AbstractString) = sympy.Wild(string(x))

function Permutation(x...; kwargs...)
    if typeof(x) <: UnitRange
        x = collect(x)
    end
    # should do this _check_permutation_format(x)
    # call this way to avoid ↓(x) call
    Sym(_combinatorics_.permutations.Permutation(x...; kwargs...))
end
PermutationGroup(args...; kwargs...) = combinatorics.PermutationGroup(args...; kwargs...)

# Introspection, assumptions use a struct to imitate old use of module; we pass in _sympy_
@doc SymPyCore.Introspection_docs Introspection = SymPyCore.Introspection(_sympy_ = _sympy_) # introspection

# 𝑄 alternative to sympy.Q (maybe unnecessary)
#@doc SymPyCore.Q_docs
#𝑄 = sympy.Q #SymPyCore.𝑄(_sympy_=_sympy_)

function SymPyCore.ask(x::Sym)
    u = sympy.ask(x)
    return SymPyCore.Bool3(u)
    #return convert(SymPyCore.Bool3, u)
end


# lambdify using use_julia_code (`sympy` not available in `lambify.jl`)
SymPyCore.julia_code(ex) = Meta.parse(string(_sympy_.julia_code(↓(ex))))
# deprecate this:
function SymPyCore._convert_expr(use_julia_code::Val{true}, ex; kwargs...)
    Meta.parse(string(_sympy_.julia_code(↓(ex))))
end

# deprecations
import Base: collect
Base.@deprecate collect(x::SymbolicObject, args...; kwargs...) sympy.collect(x, args...; kwargs...)

## Common code

using LinearAlgebra
import SpecialFunctions
import CommonEq
import CommonSolve

#=
Several functions are exported

* generic functions in base `Julia` having a `sympy` counterpart have
  methods defined to dispatch on the first argument. (Basically,
  `Base.sin(x::Sym) = \uparrow(_sympy_.sin(\downarrow(x))`.) These are
  defined in the `generic_methods` list in `SymPyCore` and read in via
  the package once a Python bridge is in place.

* Some object methods, such as `ex.subs(...)` have exported functions
  that use the `Julian` order `subs(ex, ...)`. All object methods
  should be callable using the python syntax `obj.method(...)`.

* Functions in `sympy` that are foundational (e.g., `simplify`) have
  methods created dispatch on the first argument being symbolic
  (typically type `Sym`). These are exported. Other functions, e.g.,
  `trigsimp` may be called via `sympy.trigsimp(...)`.
=#

## import/exports
import SymPyCore: ↑, ↓, ↓ₖ
import SymPyCore: SymbolicObject, Sym, SymFunction
import SymPyCore: symbols, free_symbols
import SymPyCore: simplify, expand, together, apart, factor, cancel
import SymPyCore: solve, dsolve, nsolve, linsolve, nonlinsolve, solveset
import SymPyCore: subs, lambdify, simplify
import SymPyCore: ask, doit
import SymPyCore: N
import SymPyCore: limit, diff, integrate, Differential, Heaviside
import SymPyCore: rhs, lhs
import SymPyCore: Wild, Permutation, PermutationGroup
import SymPyCore: ∨, ∧, ¬  # infix logical operators

# more exports defined in SymPyCore/src/gen_methods_sympy
export Sym, SymFunction
export sympy, PI, E, IM, oo, zoo
export @syms, sympify, symbols, free_symbols
export simplify, expand, together, apart, factor, cancel
export solve, dsolve, nsolve, linsolve, nonlinsolve, solveset
export real_roots,  nroots # roots
export sign #,degree
export series, summation, hessian
export subs, lambdify
export ask, doit, rewrite
export N
export limit, diff, integrate, Differential, Heaviside
export rhs, lhs
export Wild #, cse
export Permutation, PermutationGroup
export ∨, ∧, ¬
export 𝑄, 𝑆, Introspection

export ↓, ↑

# emacs and indent; this goes last
import SymPyCore: Lt, ≪, Le, ≦, Eq, ⩵, Ne, ≶, ≷, Ge, ≫, Gt, ≧
export  Lt, ≪, Le, ≦, Eq, ⩵, Ne, ≶, ≷, Ge, ≫, Gt, ≧

# exported symbols and their python counterparts
const _sympy_  = _pynull()
const sympy = Sym(_sympy_)

const _combinatorics_ = _pynull()
const combinatorics = Sym(_combinatorics_)

const _PI_ =_pynull()
const PI = Sym(_PI_)

const _E_ =_pynull()
const E = Sym(_E_)

const _IM_ =_pynull()
const IM = Sym(_IM_)

const _oo_ =_pynull()
const oo = Sym(_oo_)

const _zoo_ =_pynull()
const zoo = Sym(_zoo_)

Base.@deprecate_binding TRUE Sym(true)
Base.@deprecate_binding FALSE Sym(false)

const _𝑄_ = _pynull()
const 𝑄 = Sym(_𝑄_)

const _𝑆_ = _pynull()
const 𝑆 = Sym(_𝑆_)

# ugly, but needed to speed up python_connection
const _pyset_ = _pynull()
const _pytuple_ = _pynull()
const _pylist_ = _pynull()
const _pydict_ = _pynull()
const _bool_ = _pynull()
const _types_  = _pynull()
const _ModuleType_ = _pynull()
const _FiniteSet_ = _pynull()
const _MutableDenseMatrix_ = _pynull()

function __init__()

    ## Define sympy, mpmath, ...
    _copy!(_sympy_, _pyimport_conda("sympy", "sympy"))
    _copy!(_combinatorics_, _pyimport_conda("sympy.combinatorics", "sympy"))

    _copy!(_PI_, _sympy_.pi)
    _copy!(_E_, _sympy_.E)
    _copy!(_IM_, _sympy_.I)
    _copy!(_oo_, _sympy_.oo)
    _copy!(_zoo_, _sympy_.zoo)
    _copy!(_𝑆_, _sympy_.S)
    _copy!(_𝑄_, _sympy_.Q)

    # ugly, avoids allocation in PyCall
    _copy!(_pyset_, getproperty(_pybuiltin, :set))
    _copy!(_pytuple_, getproperty(_pybuiltin, :tuple))
    _copy!(_pylist_, getproperty(_pybuiltin, :list))
    _copy!(_pydict_, getproperty(_pybuiltin, :dict))
    _copy!(_bool_, getproperty(_pybuiltin, :bool))
    _copy!(_types_, _pyimport_conda("types", "types"))
    _copy!(_ModuleType_, getproperty(_types_, :ModuleType))
    _copy!(_FiniteSet_, _sympy_.FiniteSet)
    _copy!(_MutableDenseMatrix_, _sympy_.MutableDenseMatrix)


end



# includes
core_src_path = joinpath(pathof(SymPyCore), "../../src/SymPy")
include(joinpath(core_src_path, "constructors_sympy.jl"))
include(joinpath(core_src_path, "gen_methods_sympy.jl"))
include(joinpath(core_src_path, "additional_methods_sympy.jl"))
include(joinpath(core_src_path, "show_sympy.jl"))

## Pattern matching modifications


"""
    Wild(x)

Create a "wild card" for pattern matching
"""
Wild(x::Symbol) = Wild(string(x)) # Wild(::String) in syjmpy.jl

"""
    match(pattern, expression, ...)

Match a pattern against an expression; returns a dictionary of matches.

If a match is unsuccessful, returns an *empty* dictionary. (SymPy returns "nothing")

The order of the arguments follows `Julia`'s `match` function, not `sympy.match`, which can be used directly, otherwise.
"""
function Base.match(pat::Sym, ex::Sym, args...; kwargs...)
    out = ex.match(pat, args...; kwargs...)
    out == nothing && return Dict()
    out
end

"""
    replace(expression, pattern, value, ...)
    replace(expression, pattern => value; kwargs...)

In the expression replace a matching pattern with the value. Returns the modified expression.

# Extended help

From: [SymPy Docs](http://docs.sympy.org/dev/modules/core.html)

Traverses an expression tree and performs replacement of matching
subexpressions from the bottom to the top of the tree. The default
approach is to do the replacement in a simultaneous fashion so changes
made are targeted only once. If this is not desired or causes
problems, `simultaneous` can be set to `false`. In addition, if an
expression containing more than one `Wild` symbol is being used to match
subexpressions and the `exact` flag is `true`, then the match will only
succeed if non-zero values are received for each `Wild` that appears in
the match pattern.


Differences from SymPy:

* "types" are specified via calling `func` on the head of an expression: `func(sin(x))` -> `sin`, or directly through `sympy.sin`

* functions are only supported by calling into the glue package.

Examples (from the SymPy docs)

```jldoctest replace
julia> using SymPyPythonCall


julia> @syms x, y, z
(x, y, z)

julia> f = log(sin(x)) + tan(sin(x^2)); show(f)
log(sin(x)) + tan(sin(x^2))

```

## "type" -> "type"

Types are specified through `func`:

```jldoctest replace
julia> func = Introspection.func
#399 (generic function with 1 method)

julia> replace(f, func(sin(x)), func(cos(x))) |> show # type -> type
log(cos(x)) + tan(cos(x^2))

```

The value `sympy.sin` does not work, as it is wrapped. Using `↓(sympy).sin` will work:
```
julia> replace(f, ↓(sympy).sin, ↓(sympy).cos)
log(cos(x)) + tan(cos(x^2))
```



## "pattern" -> "expression"

Using "`Wild`" variables allows a pattern to be replaced by an expression:

```jldoctest replace
julia> a, b = Wild("a"), Wild("b")
(a_, b_)

julia> replace(f, sin(a), tan(2a)) |> show
log(tan(2*x)) + tan(tan(2*x^2))

julia> replace(f, sin(a), tan(a/2)) |> show
log(tan(x/2)) + tan(tan(x^2/2))

julia> f.replace(sin(a), a) |> show
log(x) + tan(x^2)

julia> (x*y).replace(a*x, a)
y

```

In the SymPy docs we have:

Matching is exact by default when more than one Wild symbol is used: matching fails unless the match gives non-zero values for all Wild symbols."

```jldoctest replace
julia> replace(2x + y, a*x+b, b-a)  # y - 2
y - 2

julia> replace(2x + y, a*x+b, b-a, exact=false) |> show
y + 2/x
```

## "type" -> "function"

To replace with a more complicated function, requires some assistance from `Python`, as an anonymous function must be defined within Python, not `Julia`. This is how it might be done:

```julia
julia> import PyCall

julia> ## Anonymous function a -> sin(2a)
       PyCall.py\"\"\"
       from sympy import sin, Mul
       def anonfn(*args):
           return sin(2*Mul(*args))
       \"\"\")


julia> replace(f, sympy.sin, PyCall.py"anonfn")
                   ⎛   ⎛   2⎞⎞
log(sin(2⋅x)) + tan⎝sin⎝2⋅x ⎠⎠
```

## "pattern" -> "func"

The function is redefined, as a fixed argument is passed:

```julia
julia> PyCall.py\"\"\"
       from sympy import sin
       def anonfn(a):
           return sin(2*a)
       \"\"\"

julia> replace(f, sin(a), PyCall.py"anonfn")
                   ⎛   ⎛   2⎞⎞
log(sin(2⋅x)) + tan⎝sin⎝2⋅x ⎠⎠
```

## "func" -> "func"

```julia

julia> PyCall.py\"\"\"
       def fn1(expr):
           return expr.is_Number

       def fn2(expr):
           return expr**2
       \"\"\"

julia> replace(2*sin(x^3), PyCall.py"fn1", PyCall.py"fn2")
     ⎛ 9⎞
4⋅sin⎝x ⎠
```

```julia
julia> PyCall.py\"\"\"
       def fn1(x):
           return x.is_Mul

       def fn2(x):
           return 2*x
       \"\"\"

julia> replace(x*(x*y + 1), PyCall.py"fn1", PyCall.py"fn2")
2⋅x⋅(2⋅x⋅y + 1)
```
"""
function Base.replace(ex::Sym, query::Sym, fn::Function; exact=true, kwargs...)
    ## XXX this is failing!
    ex.replace(query, ↓((args...) ->fn(args...)); exact=exact, kwargs...)
end


function Base.replace(ex::Sym, query::Any, value; exact=true, kwargs...)
    ex.replace(query, value; exact=exact, kwargs...)
end

function Base.replace(ex::Sym, qv::Pair; kwargs...)
    replace(ex, first(qv), last(qv); kwargs...)
end

# avoid some ambiguity
function Base.replace(ex::Sym, qv::Pair, qv1::Pair; kwargs...)
    replace(ex, first(qv), last(qv); kwargs...)
    replace(ex, first(qv1), last(qv1); kwargs...)
end

## Equality involves
## =  assignment has no change
## ==  - we want to promote to Sym to compare
## hash - call out to
## ===
## isequal
## isless

## Equality
#=
Generic equality operator. Falls back to ===. Should be implemented for all types with a notion of equality, based on the abstract value
  that an instance represents. For example, all numeric types are compared by numeric value, ignoring type. Strings are compared as sequences
  of characters, ignoring encoding. For collections, == is generally called recursively on all contents, though other properties (like the
  shape for arrays) may also be taken into account.

This operator follows IEEE semantics for floating-point numbers: 0.0 == -0.0 and NaN != NaN.
=#
import Base: ==
Base.:(==)(x::S, y::Number) where {T, S<:SymbolicObject{T}}  = ==(promote(x,y)...)
Base.:(==)(x::Number, y::S) where {T, S<:SymbolicObject{T}} = ==(promote(x,y)...)
Base.:(==)(::SymbolicObject, ::Missing) = missing
Base.:(==)(::Missing, ::SymbolicObject) = missing
Base.:(==)(x::S, y::Nothing) where {T, S<:SymbolicObject{T}} = y == x
Base.:(==)(::Nothing, y::S) where {T, S<:SymbolicObject{T}} =
    isa(y, Sym{Nothing}) || y == Sym(nothing)

function Base.:(==)(x::SymbolicObject, y::SymbolicObject)

    isnan(x) && isnan(y) && return false
    a, b = Bool3(x), Bool3(y)
    a == b == true  && return true
    a == b == false && return true

    if hasproperty(↓(x), :equals) && hasproperty(↓(y), :equals)
        u = ↑(↓(x).equals(↓(y)))
        v = Bool3(u)
        v == true && return true
        v == false && return false
    end
    return (hash(x) == hash(y))
end

# Bool3: used with ==; true, false or nothing
Bool3(::Sym{Nothing}) = nothing
Bool3(::Sym{P}) where {P} = throw(ArgumentError("Need specific P"))
# specialized method form Sym{P} in python_connection

#=
Similar to ==, except for the treatment of floating point numbers and
of missing values. isequal treats all floating-point NaN values as
equal to each other, treats -0.0 as unequal to 0.0, and missing as
equal to missing. Always returns a Bool value.
=#
function Base.isequal(x::T, y::T) where {T <: SymbolicObject}
    isnan(x) && isnan(y) && return true
    x == y
end


Base.isless(x::S, y::Real) where {T,S<:SymbolicObject{T}} = isless(promote(x,y)...)
Base.isless(x::Real, y::S) where {T, S<:SymbolicObject{T}} = isless(promote(x,y)...)
function Base.isless(x::SymbolicObject{T}, y::SymbolicObject{T}) where {T}

    isnan(x) && isnan(y) && return false
    isnan(x) && return false  # NaN ordered last
    isnan(y) && return true

    if isinf(x)
        sign(x) == -1 && return true
        sign(x) == 1  && return false
    end
    if isinf(y)
        sign(y) == -1 && return false
        sign(y) == 1  && return true
    end

    u, v = Bool3(x), Bool3(y)
    u != nothing && v != nothing && return isless(u,v)

    if x.is_real == true && y.is_real == true
        return Lt(x, y) == Sym(true) ? true : false
    end

    if hasproperty(↓(x), :compare)
        out = x.compare(y)
    elseif hasproperty(↓(y), :compare)
        out = - (y.compare(x))
    else
        @show :huh_shouldnt_get_here, x, y
        out = -1
    end

    out == -1  ? true : false

end

Base.:<(x::S, y) where {S<:SymbolicObject} = <(promote(x,y)...)
Base.:<(x, y::S) where {S<:SymbolicObject} = <(promote(x,y)...)
Base.:<(x::S, y::Missing) where {S<:SymbolicObject} = missing
Base.:<(::Missing, y::S)  where {S<:SymbolicObject} = missing
function Base.:<(x::T, y::T′) where {T <: SymbolicObject, T′ <: SymbolicObject}

    (isnan(x) || isnan(y)) && return false
    isless(x, y)

end

## Implement Julia math functions not
## easily implemented in gen_methods list
## https://github.com/SimonDanisch/AbstractNumbers.jl provides
## a useful list of targeted functions

Base.eps(::Type{<:Sym}) = 0
Base.rtoldefault(::Type{<:Sym}) = 0

Base.float(x::Sym) = _float(N(x))
_float(x::Sym) = throw(ArgumentError("variable must have no free symbols"))
_float(x) = float(x)

Base.Float64(x::Sym) = _Float64(N(x))
_Float64(x::Sym) = throw(ArgumentError("variable must have no free symbols"))
_Float64(x) = Float64(x)

function Base.Int(x::Sym)
    if x.is_integer == true
        abs(x) <= typemax(Int) && return convert(Int, ↓(x))
        return convert(BigInt, ↓(x))
    end
    convert(Int, ↓(x.evalf()))
end

Base.complex(::Type{Sym}) = Sym
Base.complex(r::Sym) = real(r) + imag(r) * im
function Base.complex(r::Sym, i)
    isreal(r) || throw(ArgumentError("r and i must not be complex"))
    isreal(i) || throw(ArgumentError("r and i must not be complex"))
    N(r) + N(i) * im
end
Base.complex(xs::AbstractArray{Sym}) = complex.(xs) # why is this in base?



Base.abs2(x::SymbolicObject) = x * conj(x)
Base.cbrt(x::Sym) = x^(1//3)

## Trig
Base.asech(z::Sym) = log(sqrt(1/z-1)*sqrt(1/z+1) + 1/z)
Base.acsch(z::Sym) = log(sqrt(1+1/z^2) + 1/z) ## http://mathworld.wolfram.com/InverseHyperbolicCosecant.html

Base.sincos(x::Sym) = (sin(x), cos(x))

Base.hypot(x::Sym, y::Number) = hypot(promote(x,y)...)
Base.hypot(xs::Sym...) = sqrt(sum(abs(xᵢ)^2 for xᵢ ∈ xs))

## exponential
Base.expm1(x::Sym) = exp(x) - 1
Base.exp2(x::Sym)  = Sym(2)^x
Base.exp10(x::Sym) = Sym(10)^x
Base.log1p(x::Sym) = log(1 + x)
#Base.log(b::Number, x::Sym) = log(x, b) # sympy.log has different order
function Base.frexp(x::Sym)
    n = ceil(log2(x))
    r = x/2^n
    (r, n)
end
Base.ldexp(x::Sym, n) = x * Sym(2)^n
function Base.modf(x::Sym)
    isinf(x) && return (copysign(zero(T), x), x)
    ix = trunc(x)
    rx = copysign(x - ix, x)
    return (rx, ix)
end

Base.iseven(x::Sym) = x.is_even
Base.isodd(x::Sym) = x.is_odd
function Base.ispow2(x::Sym)
    a = x.is_integer
    a == true && return ispow2(N(x))
    a
end

Base.trunc(x::Sym) = x.is_Number != true ? x :
    (x.is_positive == true) ? floor(x) : ceil(x)
Base.isfinite(x::Sym) = !isinf(x) #x.is_finite == true
Base.isinf(x::Sym) = x.is_infinite == true
Base.isinteger(x::Sym) = x.is_integer == true
Base.isreal(x::Sym) = x.is_real == true
Base.isnan(x::Sym) = _convert(Bool, ↓(x) == ↓(Sym(NaN)))
Base.copysign(x::Sym, y::Sym) = abs(x)*sign(y)
Base.flipsign(x::Sym, y) = isless(y, 0) ? -x : x
Base.fld(x::Sym, y::Sym) = floor(x / y)
Base.clamp(x::Sym, a, b) = min(max(x, a), b)
Base.divrem(x::Sym, y::Sym) = (div(x,y), rem(x,y))


## --------------------------------------------------
# sets
Base.in(x::Sym, I::Sym) = I.contains(x) == Sym(true)
Base.in(x::Number, I::Sym) = Sym(x) in I
Base.intersect(x::Sym, args...; kwargs...) = x.intersect(args...; kwargs...)
Base.union(x::Sym, args...; kwargs...) = x.union(args...; kwargs...)
Base.issubset(x::Sym, args...; kwargs...) = x.issubset(args...; kwargs...)


## --------------------------------------------------
## calculus.
## use a pair for limit x=>0
limit(x::SymbolicObject, xc::Pair, args...;kwargs...) = limit(x, xc[1], xc[2], args...;kwargs...)

# Steal this idea from ModelingToolkit
"""
    Differential(x)

Use to find (partial) derivatives.

## Example
```
@syms x y u()
Dx = Differential(x)
Dx(u(x,y))  # resolves to diff(u(x,y),x)
Dx(u)       # will evaluate diff(u(x), x)
(Dx^2)(u(x))  # two derivatives in x; not () to avoid 2u(x) eager evaluation
```
"""
struct Differential
    x::Sym
    i::Int
end
Differential(x::Sym) = Differential(x, 1)
Base.:^(∂::Differential, n::Int) = Differential(∂.x, ∂.i*n)
(∂::Differential)(u::Sym) = diff(u, ∂.x, ∂.i)
(∂::Differential)(u::SymFunction) = diff(u(∂.x), ∂.x, ∂.i)


## Add interfaces for solve, nonlinsolve when vector of equations passed in

## An alternative to Eq(lhs, rhs) following Symbolics.jl
"""
    lhs ~ rhs

Specify an equation.

Alternative syntax to `Eq(lhs, rhs)` or `lhs ⩵ rhs` (`\\Equal[tab]`). Notation borrowed from `Symbolics.jl`.

See [`rhs`](@ref) or `lhs` to extract the two sides.

Inequalities may be defined using other functions imported from `CommonEq`.
"""
Base.:~(lhs::Number, rhs::SymbolicObject) = Eq(lhs, rhs)
Base.:~(lhs::SymbolicObject, rhs::Number) = Eq(lhs, rhs)
Base.:~(lhs::SymbolicObject, rhs::SymbolicObject) = Eq(lhs, rhs)


"""
    solve

Use `solve` to solve algebraic equations.

# Extended help

Examples:

```jldoctest mathfuns
julia> using SymPyPythonCall


julia> @syms x y a b c d
(x, y, a, b, c, d)

julia> solve(x^2 + 2x + 1, x) # [-1]
1-element Vector{Sym{PythonCall.Py}}:
 -1

julia> solve(x^2 + 2a*x + a^2, x) # [-a]
1-element Vector{Sym{PythonCall.Py}}:
 -a

julia> u = solve([a*x + b*y-3, c*x + b*y - 1], [x,y]); show(u[x])
2/(a - c)
```

!!! note
    A very nice example using `solve` is a [blog](https://newptcai.github.io/euclidean-plane-geometry-with-julia.html) entry on [Napoleon's theorem](https://en.wikipedia.org/wiki/Napoleon%27s_theorem) by Xing Shi Cai.

!!! note "Systems"
    Use a tuple, not a vector, of equations when there is more than one.

"""
solve

## dsolve allowing initial condiation to be specified

"""
    dsolve(eqn, var, args..,; ics=nothing, kwargs...)

Calls `sympy.dsolve`.

ics: The initial conditions are specified with a dictionary or `nothing`

# Extended help

Example:

```jldoctest dsolve
julia> using SymPyPythonCall

julia> @syms α, x, f(), g()
(α, x, f, g)

julia> ∂ = Differential(x)
Differential(x)

julia> eqn = ∂(f(x)) ~ α * x; show(eqn)
Eq(Derivative(f(x), x), x*α)
```

```jldoctest dsolve
julia> dsolve(eqn) |> show
Eq(f(x), C1 + x^2*α/2)
```

```julia jldoctest dsolve
julia> dsolve(eqn(α=>2); ics=Dict(f(0)=>1))
        2
f(x) = x  + 1

julia> eqn = ∂(∂(f(x))) ~ -f(x);

julia> dsolve(eqn)
f(x) = C₁⋅sin(x) + C₂⋅cos(x)

julia> dsolve(eqn; ics = Dict(f(0)=>1, ∂(f)(0) => -1))
f(x) = -sin(x) + cos(x)

julia> eqn = ∂(∂(f(x))) - f(x) - exp(x);

julia> dsolve(eqn, ics=Dict(f(0) => 1, f(1) => Sym(1//2))) |> show
Eq(f(x), (x/2 + (-exp(2) - 2 + E)/(-2 + 2*exp(2)))*exp(x) + (-E + 3*exp(2))*exp(-x)/(-2 + 2*exp(2)))
```

!!! note "Systems"
    Use a tuple, not a vector, of equations when there is more than one.

```julia jldoctest dsolve
julia> @syms x() y() t g
(x, y, t, g)

julia> ∂ = Differential(t)
Differential(t)

julia> eqns = (∂(x(t)) ~ y(t), ∂(y(t)) ~ x(t));

julia> dsolve(eqns)
2-element Vector{Sym{PythonCall.Py}}:
 Eq(x(t), -C1*exp(-t) + C2*exp(t))
  Eq(y(t), C1*exp(-t) + C2*exp(t))

julia> dsolve(eqns, ics = Dict(x(0) => 1, y(0) => 2))
2-element Vector{Sym{PythonCall.Py}}:
 Eq(x(t), 3*exp(t)/2 - exp(-t)/2)
 Eq(y(t), 3*exp(t)/2 + exp(-t)/2)

julia> eqns = (∂(∂(x(t))) ~ 0, ∂(∂(y(t))) ~ -g)
(Eq(Derivative(x(t), (t, 2)), 0), Eq(Derivative(y(t), (t, 2)), -g))

julia> dsolve(eqns)  # can't solve for initial conditions though! (NotAlgebraic)
2-element Vector{Sym{PythonCall.Py}}:
           x(t) = C₁ + C₂⋅t
 Eq(y(t), C3 + C4*t - g*t^2/2)

julia> @syms t x() y()
(t, x, y)

julia> eq = (∂(x)(t) ~ x(t)*y(t)*sin(t), ∂(y)(t) ~ y(t)^2 * sin(t));
```

```julia
julia> dsolve(eq)
Set{Sym{PythonCall.Py}} with 2 elements:
  Eq(x(t), -exp(C1)/(C2*exp(C1) - cos(t)))
  Eq(y(t), -1/(C1 - cos(t)))
```

"""
dsolve() = nothing

rhs(x::SymbolicObject) = x.rhs()
lhs(x::SymbolicObject) = x.lhs()

"""
    rhs(eqn)
    lhs(eqn)

Returns right (or left) side of an equation object. Wrappers around `eqn.rhs()` and `eqn.lhs()`.
"""
rhs, lhs


## --------------------------------------------------
Permutation() = nothing
PermutationGroup() = nothing

"""
    Permutation
    PermutationGroup

Give access to the `sympy.combinatorics.permutations` module

## Example
```jldoctest permutation
julia> using SymPyPythonCall

julia> p = Permutation([1,2,3,0])
(0 1 2 3)

julia> p^2
(0 2)(1 3)

julia> p^2 * p^2
()
```

Rubik's cube example from SymPy documentation

```jldoctest permutation
julia> F = Permutation([(2, 19, 21, 8),(3, 17, 20, 10),(4, 6, 7, 5)])
(2 19 21 8)(3 17 20 10)(4 6 7 5)

julia> R = Permutation([(1, 5, 21, 14),(3, 7, 23, 12),(8, 10, 11, 9)])
(1 5 21 14)(3 7 23 12)(8 10 11 9)

julia> D = Permutation([(6, 18, 14, 10),(7, 19, 15, 11),(20, 22, 23, 21)])
(6 18 14 10)(7 19 15 11)(20 22 23 21)

julia> G = PermutationGroup(F,R,D);

julia> G.order()
3674160
```
"""
Permutation, PermutationGroup

using Test

using SymPyCore
using SpecialFunctions
using LinearAlgebra
using Base.MathConstants

func = Introspection.func
args = Introspection.args
import SymPyCore: SymFunction

## notes -- @vars => @syms; fix syntax

@testset "Core" begin
    ## Symbol creation
    x = Sym("x")
    #x = sym"x" # deprecated
    x = Sym(:x)
    #XXX x,y = Sym(:x, :y)
    x,y = symbols("x,y")

    @syms u1 u2 u3
    @syms u::positive
    @test length(solve(u+1)) == 0
    # make sure @syms defines in a local scope
    let
        @syms w
    end
    @test_throws UndefVarError isdefined(w)
    @syms a b c

    # Renaming with @syms
    @syms a=>"α₁"
    @test string(a) == "α₁"

    ## extract symbols
    @syms z
    ex = x*y*z
    @test isa(free_symbols(ex), Vector{<:Sym})
    @test free_symbols(ex) == [x, y, z]

    ## number conversions
    @test Sym(2) == 2
    @test Sym(2.0) == 2.0
    @test Sym(2//1) == 2
    @test Sym(im) == 1im
    @test Sym(2im) == 2im
    @test Sym(1 + 2im) == 1 + 2im

    pi, e, catalan = Base.MathConstants.pi, Base.MathConstants.e, Base.MathConstants.catalan
    @test N(Sym(pi)) == pi
    @test N(Sym(ℯ)) ==  ℯ
    # @test N(Sym(catalan)) == catalan XXX <<--- expose catalan?


    ## function conversion (just calls lambdify)
    f1 = convert(Function, x^2)
    @test f1(2) == 4

    ### Subs
    ## subs, |> (x == number)
    f = x -> x^2 - 2
    y = f(x)
    @test float(y.subs( x, 1)) == f(1)
    ### @test float( y |> subs(x,1) ) == f(1) no subs method

    ## interfaces
    ex = (x-1)*(y-2)
    @test ex.subs(x, 1) == 0
    @test ex.subs(((x,1),)) == 0
    @test ex.subs(((x,2),(y,2))) == 0

    @test subs(ex, x=>1) == 0       # removed
    @test subs(ex, x=>2, y=>2) == 0
    @test subs(ex, Dict(x=>1)) == 0
    @test ex(x=>1) == 0
    @test ex(x=>2, y=>2) == 0
    @test ex.subs(Dict(x=>1)) == 0

    ### doit
    @syms x g()
    @syms f()

    D = Differential(x)
    df = D(f(x))
    dfx = subs(df, f(x) => x^2)
    @test dfx.doit() == 2*x
    @test doit(dfx) == 2*x
    @test dfx |> doit == 2*x
    # use deep=true to force nested evaluations
    dgfx = g(dfx)
    @test dgfx.doit(deep=true) == g(2*x)
    @test doit(dgfx, deep=true) == g(2*x)
    @test dgfx |> doit(deep=true) == g(2*x)

    ## match, replace, xreplace, rewrite
    x,y,z = symbols("x, y, z")
    #a,b,c = map(sympy.Wild, (:a,:b,:c)) ## XXX Wild needs strings -- not symbols
    a,b,c = map(sympy.Wild, ("a", "b", "c")) ## XXX Wild needs strings -- not symbols
    # ## match: we have pattern, expression to follow `match`
    d = match(a^a, (x+y)^(x+y))
    @test d[a] == x+y
    d = match(a^b, (x+y)^(x+y))
    @test d[b] == x + y
    ex = (2x)^2
    pat = a*b^c
    d = match(pat, ex)
    @test d[a] == 4 && d[b] == x && d[c] == 2
    @test pat.xreplace(d) == 4x^2

    ## replace
    a = Wild("a")
    ex = log(sin(x)) + tan(sin(x^2))
    ##XXX    @test replace(ex, func(sin(x)), u ->  sin(2u)) == log(sin(2x)) + tan(sin(2x^2))
    @test replace(ex, func(sin(x)), func(tan(x))) == log(tan(x)) + tan(tan(x^2))
    @test replace(ex, sin(a), tan(a)) ==  log(tan(x)) + tan(tan(x^2))
    @test replace(ex, sin(a), a) == log(x) + tan(x^2)
    @test replace(x*y, a*x, a) == y

    ## xreplace
    @test (1 + x*y).xreplace(Dict(x => PI)) == 1 + PI*y
    @test (x*y + z).xreplace(Dict(x*y => PI)) == z + PI
    @test (x*y * z).xreplace(Dict(x*y => PI)) == x* y * z
    @test (x + 2 + exp(x + 2)).xreplace(Dict(x+2=>y)) == x + exp(y) + 2


    # Test subs on simple numbers
    @syms x y
    @test Sym(2)(x=>300, y=>1.2) == 2

    #Test subs for pars and dicts
    ex = 1
    dict1 = Dict{String,Any}()
    dict2 = Dict{Any,Any}()
    #test subs
    for i=1:4
        x = Sym("x$i")
        ex=ex*x
        dict2[x] = i
        dict1[string(x)] = i
    end
    for d in [dict1, dict2]
        @test ex |> subs(d) == factorial(4)
        @test subs(ex, d) == factorial(4)
        @test subs(ex, d...) == factorial(4)
        @test ex |> subs(d...) == factorial(4)
        @test ex(d) == factorial(4)
        @test ex(d...) == factorial(4)
    end

    a = Sym("a")
    b = Sym("b")
    line = x -> a + b * x
    sol = solve([line(0)-1, line(1)-2],[a,b])
    ex = line(10)
    @test ex(sol) == ex(sol...) == 11

    ## Simplify (issue 343)
    @syms x
    @test simplify(sin(x)^2 + cos(x)^2) == 1
    @test simplify(sympy.gamma(x)/sympy.gamma(x-2)) == (x-1)*(x-2)
    _ones = (1, 1.0, big"1", "1", one)
    @test simplify.(_ones) == _ones

    ## Conversion
    x = Sym("x")
    p = x.subs(x, pi)
    q = x.subs(x,Sym(1)/2)
    r = x.subs(x,1.2)
    z = x.subs(x,1)
    @test isa(N(p), Irrational) # isa(N(p), Float64)
##XXX    @test isa(N(p, 60), BigFloat)
    @test isa(p.evalf(), Sym)
    @test isa(N(x), Sym)
    @test isa(N(q), Rational)
    @test isa(N(r), Float64)
    @test isa(N(z), Integer)

    ## method calls via getproperty
    p = (x-1)*(x-2)
    @test sympy.roots(p) == Dict(Sym(1) => Sym(1), Sym(2) => Sym(1)) # sympy.roots
    p = sympy.poly(p, x) # XXX sympy.Poly(p, x)
    @test p.coeffs() == Any[1,-3,2] # p.coeffs

    ## algebra
    @test expand((x + 1)*(x + 2)) == x^2 + 3x + 2  # v0.7 deprecates expand, in v1.0 this is fine w/o qualifacation
    x1 = (x + 1)*(x + 2)
    @test expand(x1) == x^2 + 3x + 2
    @test sympy.expand_trig(sin(2x)) == 2sin(x)*cos(x)

    ## math functions
    u = abs(x^2 - 2)
    @test u(x=>0) == 2
    u = min(x, x^2, x^3, x^4)
    @test u(x=>2) == 2
    @test u(x=>1//2) == 1//2^4

    ## solve
    x,y,a = symbols("x,y,a", real=true)
    solve(x^2 - 2x)
    solve(x^2 - 2a, x)
    solve(x^2 - 2a, a)
    solve(Lt(x-2, 0))
    solve( x-2 ≪ 0)
    exs = [x-y-1, x+y-2]
    di = solve(exs)
    @test di[x] == 3//2
    @test map(ex -> subs(ex, di), exs) == [0,0]
    solve([x-y-a, x+y], [x,y])

    ## linsolve
    @syms x y
    M=Sym[1 2 3; 2 3 4]
    as = linsolve(M, x, y)

    # XXX elements -> collect
    @test length(collect(as)) == 1 # XXXlength(elements(as)) == 1
    @syms a b; eqs = (a*x+2y-3, 2b*x + 3y - 4)
    as = linsolve(eqs, x, y)
    @test length(collect(as)) == 1 # XXX length(elements(as)) == 1

    ## nsolve -- not method for arrays, issue 268
    @syms z1::positive z2z1::positive
    # XXX No error? @test_throws MethodError nsolve([z1^2-1, z1+z2z1-2], [z1,z2z1], [1,1])  # non symbolic first argument
    @test all(N.(sympy.nsolve([z1^2-1, z1+z2z1-2], [z1,z2z1], (1,1))) .≈ [1.0, 1.0])

    ## issue 355: direct definition of LinearAlgebra.:\
    @test_throws SingularException Sym[1 1; 1 1] \ [1, 2]
    @syms  a b c d e f
    A, b= [a b; c d], [e, f]
    x = A \ b
    @test  simplify.(A*x-b) == [0,0]
    #out =  Sym[1 1; 1 1] \ [1,1] # XXX non-singular
    #u =   free_symbols(out)[1]
    #@test out ==  [1-u,u]


    # Just a made-up example to test  if manageable
    @syms a1 a2
    n = 7
    A = diagm(0 => ones(Int, n), 1 => fill(a1, n-1), 2 => fill(1, n-2), -1 => fill(a2, n-1))
    b = Vector{Sym}(1:n)
    x = A \ b
    @test length(free_symbols(x)) ==  2


    ## limits
    @syms x
    # @test limit(x -> sin(x)/x, 0) == 1 # XXX deprecated; use x=>c
    #@test limit(sin(x)/x, x, 0) |> float == 1 #XXX deprecated
    @test limit(sin(x)/x, x => 0) == 1
    @syms x h
    out = limit((sin(x+h) - sin(x))/h, h => 0) ## XXX limit((sin(x+h) - sin(x))/h, h, 0)
    @test (out.replace(x, pi) |> float) == -1.0


    ## diff
    diff(sin(x), x)
    out = diff(sin(x), x, 2)
    @test abs((out.replace(x, pi/4) |> float) - - sin(pi/4)) < sqrt(eps())

    # partial derivatives
    @syms x y
    @test diff(x^2 + x*y^2, x, 1) == 2x + y^2

    t = symbols("t", real=true)     # vector-valued functions
    r1(t) = [sin(t), cos(t), t]
    u = r1(t)
    kappa = norm(diff.(u) × diff.(u,t,2)) / norm(diff.(u))^3 |> simplify
    @test kappa == 1//2 # XXX convert(Rational,kappa) == 1//2

    @syms x u()
    eqn = Eq(x^2 + u(x)^2, x^3 - u(x))
    # diff(eqn) doesn't evaluate over Eq:
    @test ↑(func(eqn)(map(↓, diff.(args(eqn)))...)) == Eq(2x + 2u(x) * diff(u(x),x), 3x^2 - diff(u(x),x))

    ## integrate
    @test integrate(sin(x)) == -cos(x)
    @test integrate(sin(x), (x, 0, pi)) == 2.0
    a, b, t = symbols("a, b, t")
    @test integrate(sin(x), (x, a, b)) == cos(a) - cos(b)
    @test integrate(sin(x), (x, a, b)).replace(a, 0).replace(b, pi) == 2.0
    @test integrate(sin(x) * sympy.DiracDelta(x)) == 0
    @test integrate(Heaviside(x), (x, -1, 1)) == 1
    curv = sympy.Curve([exp(t)-1, exp(t)+1], (t, 0, log(Sym(2))))
    @test sympy.line_integrate(x + y, curv, [x,y]) == 3 * sqrt(Sym(2))

    ## summation
    summation(1/x^2, (x, 1, 10))
    out = summation(1/x^2, (x, 1, 10))
    out1 = sum([1//x^2 for  x in 1:10])
    @test out.p == out1.num #XXX round(Integer, out.p) == out1.num
    @test out.q == out1.den ## XXX round(Integer, out.q) == out1.den


    ## Ops
    s = 3
    x = Sym("x")
    v = [x, 1]
    rv = [x 1]
    a = [x 1; 1 x]
    b = [x 1 2; 1 2 x]

    DIMERROR =  DimensionMismatch
    DimensionOrMethodError =  Union{MethodError, DimensionMismatch}
    ## scalar, [vector, matrix]
    @test s .+ v == [x+3, 4]
    @test v .+ s == [x+3, 4]
    @test s .+ rv == [x+3 4]
    @test rv .+ s == [x+3 4]
    @test s .+ a == [x+3 4; 4 x+3]
    @test a .+ s == [x+3 4; 4 x+3]

    @test s .- v == [3-x, 2]
    @test v .- s == [x-3, -2]
    @test s .- rv == [3-x 2]
    @test rv .- s == [x-3 -2]
    @test s .- a == [3-x 2; 2 3-x]
    @test a .- s == [x-3 -2; -2 x-3]

    2v
    2rv
    2a
    s .* v
    v .* s
    s .* rv
    rv .* s
    s .* a
    a .* s

    ## s / v  ## broadcasts s Depreacated
    @test s ./ v == [3/x, 3]
    @test v / s == [x/3, Sym(1)/3]
    @test v .\ s == s ./ v
    @test s \ v == v / s
    ## s / rv ## broadcasts s Deprecated
    @test s ./ rv == [3/x 3]
    @test rv / s == [x/3 Sym(1)/3]
    @test rv .\ s == s ./ rv
    @test s \ rv == rv / s
    ## s / a ## broadcasts s Deprecated
    @test s ./ a == [3/x 3; 3 3/x]
    @test a / s == [x/3 Sym(1)/3; Sym(1)/3 x/3]
    @test a .\ s == s ./ a
    @test s \ a == a / s

    @test_throws MethodError  s ^ v ## error
    @test s .^ v == [3^x, 3]
    @test_throws DimensionOrMethodError v ^ s ## error
    v .^ s
    @test_throws MethodError  s ^ rv ## error
    s .^ rv
    @test_throws DimensionMismatch  rv ^ s ## error
    rv .^ s
    @test_throws MethodError  s ^ a ## error
    s .^ a
    a ^ s
    a .^ s


    ## vector vector
    @test v .+ v == 2v
    ##@test_throws MethodError  v .+ rv ##  no longer an error, broadcast
    @test v .- v == [0, 0]
    @test_throws DIMERROR  v - rv
    @test_throws DimensionOrMethodError   v * v ## error
    @test v .* v == [x^2,1]
    @test dot(v, v) == 1 + conj(x)*x
    v * rv
    rv * v ## 1x2 2 x 1 == 1x1
    v .* rv ## XXX ?? should be what? -- not 2 x 2
    rv .* v ## XXX ditto
    ## @test_throws MethodError  v / v ## error
    v ./ v ## ones()
    v .\ v
    ## @test_throws MethodError  v / rv ## error
    v ./ rv  ## ??
    rv .\ v
    @test_throws MethodError  v ^ v ## error
    v .^ v
    @test_throws MethodError  v ^ rv ## error
    v .^ rv ## ??


    ## vector matrix
    @test_throws DIMERROR v + a ## error (Broadcast?)
    @test_throws DIMERROR a + v ## error
    v .+ a ## broadcasts
    a .+ v
    @test_throws DIMERROR  v - a ## error
    v .- a
    @test_throws DimensionMismatch  v * a ## error
    v .* a
    #@test_throws MethodError  v / a ## error
    v ./ a
    a .\ v
    @test_throws MethodError  v ^ a ## error
    v .^ a
    v
    ## matrix matrix
    a + a
    @test_throws DIMERROR  a + b ## error
    a + 2a
    a - a
    @test_throws DIMERROR  a - b ## error
    a * a
    a .* a
    a * b ## 2x2 * 2*3 -- 2x3
    @test_throws DIMERROR  a .* b ## error -- wrong size
    #@test_throws MethodError  a / a
    a ./ a ## ones
    a .\ a
    ##@test_throws MethodError  a / b ## error
    @test_throws DIMERROR  a ./ b ## error
    @test_throws DIMERROR  b .\ a ## error
    @test_throws MethodError  a ^ a ## error
    a .^ a
    @test_throws MethodError  a ^ b ## error
    @test_throws DIMERROR  a .^ b ## error


    ## Number theory
    #@test isprime(100) == isprime(Sym(100))
    #@test factorint(Sym(100)) == factor(100)
    @test sympy.prime(Sym(100)) == 541 # XXX prime(Sym(100)) == 541
    @test sympy.multiplicity(Sym(10), 100) == 2 # XXX multiplicity(Sym(10), 100) == 2


    ## polynomials
    @syms x y
    f1 = 5x^2  + 10x + 3
    g1 = 2x + 2
    q,r = sympy.div(f1,g1, domain="QQ") # use sympy.div to dispatch; o/w we can't disambiguate div(Sym(7), 5)) to do integer division
    @test r == Sym(-2)
    @test simplify(q*g1 + r - f1) == Sym(0)
    ## sympy.interpolate as first arg is not symbolic
    @test sympy.interpolate([1,2,4], x) == sympy.interpolate(collect(zip([1,2,3], [1,2,4])), x)
    @test sympy.interpolate(collect(zip([-1,0,1], [0,1,0])), x) == 1 - x^2

    ## piecewise
    x = Sym("x")
    # sympy.Piecewise is a FunctionClass,  we qualify, as args not Symbolic
    p = sympy.Piecewise((x, Ge(x,0)), (0, Lt(x,0)), (1, Eq(x,0)))
    ## using infix \ll<tab>, \gt<tab>, \Equal<tab>
    p = sympy.Piecewise((x, (x ≫ 0)), (0, x ≪ 0), (1, x ⩵ 0))
    @test p.subs(x,2) == 2
    @test p.subs(x,-1) == 0
    @test p.subs(x,0) == 1

    ## if VERSION < v"0.7.0-" # ifelse changed
    ##     u = ifelse(Lt(x, 0), "neg", ifelse(Gt(x, 0), "pos", "zero"))
    ##     @test u.subs(u,x,-1) == Sym("neg")
    ##     @test subs(u,x, 0) == Sym("zero")
    ##     @test subs(u,x, 1) == Sym("pos")
    ## end
    p = sympy.Piecewise((-x, x ≪ 0), (x, x ≧ 0))


    ## relations
    x, y = symbols("x, y")
    ex  = Eq(x^2, x)
    @test ex.lhs == x^2
    @test ex.rhs == x
    @test args(ex) == (x^2, x)

    # alternative operators
    for (ex1,ex2) ∈ ((Eq(x^2, x), x^2 ⩵ x),
                   (Eq(x^2, x), x^2 ~ x),
                   (Lt(x^2, x), x^2 ≪ x),
                   (Le(x^2, x), x^2 ≦ x),
                   (Ge(x^2, x), x^2 ≧ x),
                   (Gt(x^2, x), x^2 ≫ x))
        @test lhs(ex1) == lhs(ex2)
        @test rhs(ex1) == rhs(ex2)
    end

    ## mpmath functions
#    if @isdefined mpmath
#    if isdefined(SymPy, :mpmath)
        x = Sym("x")
        Sym(big(2))
        Sym(big(2.0))                   # may need mpmath (e.g., conda install mpmath)

    if VersionNumber(string(↓(sympy).__version__)) >= v"1.12.0"
        @test limit(besselj(Sym(1),1/x), x => 0) == Sym(0)
    end
    complex(N(sympy.hankel2(2, pi)))    # XXX complex(N(SymPy.mpmath.hankel2(2, pi)))

    #XXX        SymPy.mpmath.bei(2, 3.5)
    # XXX       SymPy.mpmath.bei(1+im, 2+3im)
#    end

    ## Assumptions
    @test ask(𝑄.even(Sym(2))) == true
    @test ask(𝑄.even(Sym(3))) == false
    @test ask(𝑄.nonzero(Sym(3))) == true
    @syms x_real::real
    @syms x_real_positive::(real, positive)
    @test ask(𝑄.positive(x_real)) == Sym(nothing) # ==(nothing) promotes to ===
    @test ask(𝑄.positive(x_real_positive)) == true
    @test ask(𝑄.nonnegative(x_real^2)) == true
    ## XXX @test ask(𝑄.upper_triangular([x_real 1; 0 x_real])) == true
    @test ask(𝑄.positive_definite([x_real 1; 1 x_real])) == Sym(nothing)


    ## sets
    ## XXX -- Sets need work
    s = sympy.FiniteSet("H","T")
    s1 = ↓(s).powerset() # XXX s1 = s.powerset()
    # XXX VERSION >= v"0.4.0" && @test length(collect(convert(Set, s1))) == length(collect(s1.__pyobject__))
    a, b = sympy.Interval(0,1), sympy.Interval(2,3)
    @test a.is_disjoint(b) == true
    @test a.union(b).measure == 2



    ## test cse output
    @test sympy.cse(x) == (Any[], Sym[x])
    @test sympy.cse([x]) == (Any[], [reshape([x],1,1)])
    @test sympy.cse([x, x]) == (Any[], [reshape([x,x], 2, 1)] )
    @test sympy.cse([x x; x x]) == (Any[], [[x x; x x]])

    ## sympy"..."(...)
    ## removed
    #@syms x
    #@test sympy"sin"(1) == sin(Sym(1))
end

@testset "Syms macro" begin
    @syms u
    @test isa(u, Sym)

    ret = @syms a, b, c
    @test isa(ret, Tuple{Sym, Sym, Sym})

    @syms x::(real,positive)=>"x₀", y, z::complex, n::integer
    @test isa(x, Sym)
    @test ask(𝑄.real(x) & 𝑄.positive(x)) == true
    @test string(x) == "x₀"

    @test isa(y, Sym)

    @test isa(z, Sym)
    @test ask(𝑄.complex(z)) == true

    @test isa(n, Sym)
    @test ask(𝑄.integer(n)) == true

    @syms f()::(real, positive), g(), h()::complex=>"h̄"
    @test isa(f, SymFunction)
    @test ask(𝑄.real(f(x)) & 𝑄.positive(f(x))) == true

    @test isa(g, SymFunction)

    @test isa(h, SymFunction)
    @test ask(𝑄.complex(h(x))) == true
    @test string(h) == "h̄"

    @syms X[1:20]
    @test isa(X, Vector{<:Sym})
    @test size(X) == (20,)
    @test string(X[11]) == "X₁₁"

    @syms bigy[1:5]=>"Y"
    @test string(bigy[3]) == "Y₃"

    @syms Z[1:5, 1:6]
    @test isa(Z, Matrix{<:Sym})
    @test size(Z) == (5, 6)
    @test string(Z[2,4]) == "Z₂_₄"

    ## XXX
    #@syms F[1:2](), G()[1:2]
    #@test isa(F, Vector{SymFunction})
    #@test isa(G, Vector{SymFunction})

    #@syms WOW[1:3, 1:2:4]()::(real, positive)=>"f"
    #@test isa(WOW, Matrix{SymFunction})
    #@test size(WOW) == (3, 2)
    #@test ask(And(𝑄.real(WOW[1,2](x)), 𝑄.positive(WOW[1,2](x))))
    #@test string(WOW[1,2]) == "f₁_₃"
end

@testset "SymFunctions" begin
    @syms x::real y::real
    #@symfuns f g real=true
    @syms f()::real g()::real

    @test isreal(f(x))
    @test isreal(g(y))

    #@symfuns h real=true positive=true
    @syms h()::(real, positive)
    @test ask(𝑄.positive(h(x))) == true

    # issue #53; not recommended to create functions this way
    v = sympy.Function("v")
    @test diff(v(x), x) != 1

end

@testset "Fix past issues" begin
    @syms x y z
    ## Issue # 56
    @test Sym(1+2im) == 1+2IM
    @test convert(Sym, 1 + 2im) == 1 + 2IM


    ## Issue #59
    sympy.cse(sin(x)+sin(x)*cos(x))
    sympy.cse([sin(x), sin(x)*cos(x)])
    sympy.cse( [sin(x), sin(x)*cos(x), cos(x), sin(x)*cos(x)])

    ## Issue #60, lambidfy
    x, y = symbols("x, y")
    lambdify(sin(x)*cos(2x) * exp(x^2/2))
    fn = lambdify(sin(x)*asin(x)*sinh(x)); fn(0.25)
    lambdify(real(x)*imag(x))
    @test lambdify(min(x,y))(3,2) == 2 # XXX lambdify(Min(x,y))(3,2) == 2

    ex = 2 * x^2/(3-x)*exp(x)*sin(x)*sind(x)
    fn = lambdify(ex); map(fn, rand(10))
    ex = x - y
    @test lambdify(ex, (x,y))(3,2) == 1

    Indicator(x, a, b) = sympy.Piecewise((1, Lt(x, b) & Gt(x,a)), (0, Le(x,a)), (0, Ge(x,b)))
    i = Indicator(x, 0, 1)
    u = lambdify(i)
    @test u(.5) == 1
    @test u(1.5) == 0

    # SymPy issue 567; constants
    u = lambdify(Sym(1//2))
    @test u() ==  1/2
    @test u(1,2,3) == 1/2 # for constants allow variadic call
    @syms x
    ex = integrate(sqrt(1 + (1/x)^2), (x, 1/sympy.E, sympy.E))
    @test lambdify(ex)() ≈ 3.1961985135995072

#    i2 = SymPy.lambdify_expr(x^2,name=:square)
#    @test i2.head == :function
#    @test i2.args[1].args[1] == :square
    ## @test i2.args[2] == :(x.^2) # too fussy


    ## issue #67
    @test N(Sym(4)/3) == 4//3
    @test N(convert(Sym, 4//3)) == 4//3

    ## issue #71
    @test log(Sym(3), Sym(4)) == log(Sym(4)) / log(Sym(3))

    ## issue #103 # this does not work for `x` (which has `classname(x) == "Symbol"`), but should work for other expressions
    for ex in (sin(x), x*y^2*x, sqrt(x^2 - 2y))
        @test ↑(func(ex)((map(↓,args(ex)))...)) == ex
    end

    ## properties (Issue #119)
    @test (sympify(3).is_odd) == true
    @test sympy.poly(x^2 -2, x).is_monic == true # not Poly

    ## test round (Issue #153)
    y = Sym(eps())
    @test round(N(y), digits=5) == 0
    @test round(N(y), digits=16) != 0

    ## lambdify over a matrix #218
    @syms x y
    s = [1 0; 0 1]
    @test lambdify(x*s)(2) == 2 * s
    U = [x-y x+y; x+y x-y]
    @test lambdify(U, [x,y])(2,4) == [-2 6;6 -2]
    @test lambdify(U, [y,x])(2,4) == [ 2 6;6  2]

    @test eltype(lambdify([x 0; 1 x])(0)) <: Integer
    @test eltype(lambdify([x 0; 1 x], T=Float64)(0)) == Float64

    # issue 222 type of eigvals
    A = [Sym("a") 1; 0 1]
    @test typeof(eigvals(A)) <: Vector{<:Sym}

    # issue 231 Q.complex
    @syms x_maybecomplex
    @syms x_imag::imaginary
    @test ask(𝑄.complex(x_maybecomplex)) == Sym(nothing)
    @test ask(𝑄.complex(x_imag)) == true

    # issue 242 lambdify and conjugate
    @syms x
    #expr = conjugate(x)
    expr = conj(x)
    fn = lambdify(expr)
    @test fn(1.0im) == 0.0 - 1.0im
    fn = lambdify(expr, use_julia_code=true)
    @test fn(1.0im) == 0.0 - 1.0im

    # issue 245 missing sincos
    @test applicable(sincos, x)
    @test sincos(x)[1] == sin(x)

    # issue 256 det
    @syms rho::real phi::real theta::real
    xs = [rho*cos(theta)*sin(phi), rho*sin(theta)*sin(phi), rho*cos(phi)]
    J = [diff(x, u) for x in xs, u in (rho, phi, theta)]
    J.det()

    # issue #273 x[i]
    x = sympy.IndexedBase("x")
    i,j = sympy.symbols("i j", integer=true)
    ## XXX not defined
    #@test x[i] == PyCall.py"$x[$i]"


    # issue 298 lambdify for results of dsolve
    @syms t
    F = SymFunction("F")
    diffeq = diff(F(t),t) - 3*F(t)
    res = dsolve(diffeq, F(t), ics=Dict(F(0) => 2))  # 2exp(3t)
    @test lambdify(res)(1) ≈ 2*exp(3*1)

    # issue 304 wrong values for sind, ...
    a = Sym(45)
    @test sind(a) == sin(PI/4)

    # issue #319  with   use   of  Dummy, but
    #  really  a  lambdify issue
    dummy = sympy.Dummy
    # Symbolic differentiation of functions
    function D(f)
        x = dummy("x")
        lambdify(diff.(f(x), x), (x,))
    end
    @test D(t -> t^2)(1) == 2

    # issue   #320  with integrate(f) when
    # f  is consant
    # XXX @test integrate(x -> 1, 0, 1)  == 1 <-- want to deprecate
    # XXX @test limit(x->1,  x, 0) == 1
    # xxx @test diff(x->1)  ==   0

    ## Issue 324 with inference of matrix operations
    A = fill(Sym("a"), 2, 2)
    @test eltype(A*A) == eltype(A)
    @test eltype(A*ones(2,2)) == eltype(A)
    @test eltype(A*Diagonal([1,1])) == eltype(A)
    @test eltype(A * I(2)) == eltype(A)

    ## Issue 328 with E -> e
    @syms x
    ex = 3 * sympy.E * x
    fn = lambdify(ex)
    @test fn(1) ≈ 3*exp(1) * 1

    ## Issue 332 with `abs2`
    @syms x::real
    @test abs2(x) == x*x
    @syms x
    @test abs2(x) == x*conj(x)

    ## Issue 376 promote to Sym Before pycall
    f = x -> x^2 + 1 +log(abs( 11*x-15 ))/99
    @test limit(f(x), x=>15//11) == -oo

    ## Issue #390 on div (__div__ was deprecated, use __truediv__)
    #XXX@test Sym(2):-Sym(2):-Sym(2) |> collect == [2, 0, -2]

    ## Lambda function to create a lambda
    # XXX not working!
    #@syms x
    #ex = x^2 - 2
    #fn1 = Lambda(x, ex)
    #fn2 = lambdify(ex)
    #@test fn1(3) == fn2(3)

    ## issue 402 with lamdify and Order
    @syms x
    t = series(exp(x), x, 0, 2)
    @test lambdify(t)(1/2) == 1 + 1/2

    ## issue #411 with Heaviside
    @syms t
    u = Heaviside(t)
    λ = lambdify(u)
    @test all((iszero(λ(-1)), isone(λ(1))))
    VersionNumber(string(↓(sympy).__version__)) >= v"1.9" && @test λ(0) == 1//2
    u = Heaviside(t, 1)
    λ = lambdify(u)
    @test all((iszero(λ(-1)), isone(λ(0)), isone(λ(1))))

    ## issue #295 with piecewise function
    @syms x
    p = sympy.Piecewise((x,Gt(x,0)), (x^2, Le(x,0)))
    @test lambdify(p)(2) == 2
    @test lambdify(p)(-2) == (-2)^2

    ## Issue catch all for N; floats only
    @syms x
    ex = integrate(sqrt(1 + (1/x)^2), (x, 1/sympy.E, sympy.E))
    @test N(ex) ≈ 3.196198513599507
end

@testset "generic programming, issue 223" begin
    # arose in issue 223
    @syms xreal::real
    @syms xcomplex
    zreal = sympify(1)
    zcomplex = sympify(1) + sympify(2)*IM

    @test isreal(xreal)     # is_real(xreal) is also true, but xreal is Sym, not a Julia object
    @test !isreal(xcomplex) # is_real(xcomplex) is nothing
    @test isreal(zreal)
    @test !isreal(zcomplex)

    # conversions
    @test complex(xreal) == xreal
    @test complex(xreal, xreal) == xreal + IM*xreal
    @test complex(xcomplex) != xcomplex
    @test complex(zreal) == zreal
    @test complex(zreal) !== zreal      # Complex{Int} !== Sym
    @test complex(zcomplex) == zcomplex
    @test complex(zcomplex) !== zcomplex

    ## issue 284 N(PI,50)
    #N(PI, 50) ≈ pi <--- issue with pyconvert????
    #@test length(string(N(PI,50))) == 50 # XXX 2 + 50
    ## issue 284 lambdify of Pi
    ## XXX mpi = SymPy.PyCall.pyimport("sympy.parsing.mathematica")."mathematica"("Pi")
    #= XXX
    #mpi = PythonCall.pyimport("sympy.parsing.mathematica").mathematica("Pi")
    #@test SymPy.walk_expression(mpi) == :pi
    =#
    @test lambdify(PI^4*xreal)(256) == 256 * pi^4


    ## Issue 351 booleans  and arithmetic operations
    @test Sym(1) + true == Sym(2) == true +  Sym(1)
    @test Sym(1) - true == Sym(0) == true -  Sym(1)
    @test Sym(1) * true == Sym(1) == true * Sym(1)
    @test Sym(1) / true == Sym(1) == true / Sym(1)
    @test true^Sym(1)   == Sym(1) == Sym(1)^true

    ## issue with `pycall_hasproperty` and nothing values.
    @test Sym(2.5).is_rational == nothing

    ## Issue #405 with ambiguous methods
    @syms α
    M = Sym[1 2; 3 4] ## XXX M = SymMatrix([1 2; 3 4])
    @test α * M == M * α
    @test 2 * M == M * 2
    @test isa(M/α, Matrix{<:Sym})
    @test isa(α * inv(M), Matrix{<:Sym})

    ## issue #408 with inv
    @syms n::(integer,positive)
    A = sympy.MatrixSymbol("A", n, n)
    ## @test A.inv() == A.I ## XXX inv(A) == A.Ican't compare with equalis
    @test hash(A.inv()) == hash(A.I)
    # ceil broken
    @syms x
    @test limit(ceil(x), x=>0, dir="+") != limit(ceil(x), x=>0, dir="-")
    @test limit(floor(x), x=>0, dir="+") != limit(floor(x), x=>0, dir="-")

    ## Issue #433 add sympy docstrings, clean up docstring
    # XX sprint(io -> show(io, SymPy.Doc(:sin)))
    Base.Docs.getdoc(sin(x))

    ## test sympy.Indexed by comparing expressions
    u = sympy.Indexed(sympy.IndexedBase("x"), 1, -2)
    @test SymPyCore.convert_expr(u) == :(x[1, -2])

end

using Test
using LinearAlgebra
using SpecialFunctions
using SymPyCore

@testset "Math" begin
    ρ = symbols("rho", positive=true)
    ϕ = symbols("phi", real=true)
    x = symbols("x")

    @test simplify(hypot(ρ*cos(ϕ), ρ * sin(ϕ))) == ρ
    @test simplify(hypot(ρ*cos(ϕ), 3)) == sqrt(ρ^2*cos(ϕ)^2 + 9)

    @test real(sqrt(Sym(5))+im) == sqrt(Sym(5))
    @test real(sqrt(Sym(5))+im) isa Sym
    @test imag(sqrt(Sym(5))+im) == 1
    @test imag(sqrt(Sym(5))+im) isa Sym

    @test atan(Sym(1), 1) == PI/4
    @test atan(Sym(1), -1) == 3PI/4

    @test N(angle(Sym(1) + Sym(2)*IM)) ≈ atan(2,1)

    @test factorial(Sym(0)) == 1
    @test factorial(Sym(7)) == 5040

    @test sympy.factorial2(Sym(5)) == 15
    @test sympy.factorial2(Sym(-5)) == Sym(1)/3

    @test erf(Sym(0)) == 0
    @test erf(Sym(oo)) == 1
    @test diff(erf(x), x) == 2*exp(-x^2)/sqrt(PI)


    @test sinc(Sym(0)) == 1
    # test consistency with Julia's sinc
    @test sinc(Sym(1)) == 0
    @test N(sinc(Sym(0.2))) ≈ sinc(0.2)

    # we have sinc(x) -> sin(PI*x)/(PI*x) *but*
    # sympy.sinc(x) as sin(x)/x (their choice).
    # What do do with lambdify(sympy.sinc(x))? we keep the SymPy
    @syms x
    @test lambdify(sinc(x))(1/2) ≈ sinc(1/2)
    @test lambdify(sympy.sinc(x))(1/2) ≈ sinc(1/2/pi)



    @test flipsign(Sym(3), 2.0) == 3
    @test flipsign(Sym(3), 0.0) == 3
    @test flipsign(Sym(3), -0.0) == -3
    @test flipsign(Sym(3), -2.0) == -3

    @test eps(Sym) == 0
    #@test rewrite(sinc(x), "jn") == jn(0, PI * x)

    # divrem
    a, b = x^4 + 2x^2 + 5, x - 2
    u, v = divrem(a, b)
    @test simplify(u*b + v - a) == 0
end

@testset "sign and absolute value functions" begin
    # abs, abs2,s ign, signbit, copysign, flipsign
    @syms x y::real z::positive
    a, b = Sym(22//10), Sym(-3)

    @test !iszero(abs(x) - x)
    @test iszero(abs(z) - z)
    @test abs(b) == 3

    @test abs(x)^2 != abs2(x)
    @test abs(y)^2 == abs2(y)
    @test abs(z)^2 == abs2(z)

    @test sign(x) != 1
    @test sign(z) == 1
    @test sign(a) == 1
    @test sign(b) == -1
    @test sign(Sym(0)) == 0

    # no signbit

    @test copysign(x,y)(x=>1, y=>-2) == copysign(1, -2)
    @test copysign(Sym(1), Sym(-2)) == copysign(1, -2)
    @test copysign(Sym(-1), Sym(2)) == copysign(-1, 2)

    @test flipsign(x, y)(x=>5, y=>3) == 5
    @test flipsign(Sym(5), Sym(3)) == 5
    @test flipsign(Sym(5), Sym(-3)) == -5

end

@testset "powers, logs, roots" begin
    # sqrt, cbrt, hypot, exp, expm1, ldexp, log, log(b,x), log2(x), log10, log1p,
    # XXX exponent, significant
    @syms x y::real z::positive
    u, v = 22//10, -3
    a, b = Sym(u), Sym(v)

    @test sqrt(x) == x^(1//2)
    @test sqrt(z) == z^(1//2)

    @test cbrt(x) == x^(1//3)
    @test cbrt(z) == z^(1//3)

    @test hypot(y,z) == sqrt(y^2 + z^2)
    @test hypot(a,b) ≈ hypot(u, v)

    @test exp(x) == E^x
    @test exp(a) ≈ exp(u)

    @test expm1(x) == E^x - 1
    @test expm1(a) ≈ exp(u) - 1

    @test ldexp(x, y ) == x * 2^y
    @test iszero(ldexp(a, 4) - ldexp(float(u),4))

    @test log(z)(z => a) ≈ log(u)
    @test log(a) ≈ log(u)

    @test log(2, x) == log(x)/log(Sym(2)) # sympy.log(x,b) is order
    @test log2(x) == log(x)/log(Sym(2))
    @test log10(x) == log(x)/log(Sym(10))
    @test log1p(x) == log(1 + x)

end

@testset "isless" begin
    @syms w, x, y
    @test isless(w,x) + isless(x,w) + isequal(x,w) == 1
    a, b = Sym(2), Sym(3)
    @test isless(a,b) + isless(b,a) + isequal(a,b) == 1
    @test isless(a,b)
    @test isless(a,3) # promotes
    @test !isless(x, b)  # sympy.compare specific

    # issue #47
    for i ∈ -2.0:0.5:2.0
        @test -oo < i < oo
    end
end

@testset  "nan"  begin
    #  issue  346
    a = NaN
    b = Sym(a)

    @test (a < 0) == (b < 0)
    @test (a > 0) == (b > 0)
    @test (a == 0) == (b == 0)

end

@testset "Polynomial" begin
    # expand, factor, together, apart
end


@testset "solve" begin
    @syms x::real, y::real, a::Real
    solve(x^2 - 2x)
    solve(x^2 - 2a, x)
    solve(x^2 - 2a, a)
    solve(Lt(x-2, 0))
    solve( x-2 ≪ 0)
    exs = (x-y-1, x+y-2)
    di = solve(exs)
    @test di[x] == 3//2
    @test subs.(exs, Ref(di)) == (0, 0)
    solve((x-y-a, x+y), (x, y))

end

@testset "solveset" begin
end

@testset "nsolve, linsolve, nonlinsolve" begin
    ## nsolve -- not method for arrays, issue 268
    @syms z1::positive z2z1::positive
    # XXX No error? @test_throws MethodError nsolve([z1^2-1, z1+z2z1-2], [z1,z2z1], [1,1])  # non symbolic first argument
    eqs = (z1^2-1, z1+z2z1-2)
    xs = (z1, z2z1)
    x₀s = (1,1)
    out = nsolve(eqs, xs, x₀s)
    @test all(N.(out) .≈ [1.0, 1.0])

    ## linsolve
    @syms x y
    M=Sym[1 2 3; 2 3 4]
    as = linsolve(M, x, y)


end

@testset "roots, real_roots" begin
end

@testset "dsolve" begin
end


@testset "Calculus" begin
    @syms x::real, a::positive
    @test limit(sin(x*a)/x, x=>0) == a
    @test diff(exp(x*a), x) == a*exp(x*a)
    @test integrate(cos(x*a), x) == sin(x*a) / a
    @test summation(x^2, (x, 1, 10)) == sum(x^2 for x ∈ 1:10)

end

@testset "Piecewise" begin
    @syms x
    u = diff(sympy.Piecewise((2x, (Le(0,x) & Le(x, 10))), (3x^2, true)), x)
    @test u(x => 5) == 2
    @syms y::negative
    @test u(x => y) == 6*y
end

@testset "Relations" begin
    # CommonEq

end

@testset "lambdify" begin
    ## Issue #60, lambidfy
    x, y = symbols("x, y")
    lambdify(sin(x)*cos(2x) * exp(x^2/2))
    fn = lambdify(sin(x)*asin(x)*sinh(x)); fn(0.25)
    lambdify(real(x)*imag(x))
    @test lambdify(min(x,y))(3,2) == 2 # XXX lambdify(Min(x,y))(3,2) == 2

    ex = 2 * x^2/(3-x)*exp(x)*sin(x)*sind(x)
    fn = lambdify(ex); map(fn, rand(10))
    ex = x - y
    @test lambdify(ex, (x,y))(3,2) == 1

    Indicator(x, a, b) = sympy.Piecewise((1, Lt(x, b) & Gt(x,a)), (0, Le(x,a)), (0, Ge(x,b)))
    i = Indicator(x, 0, 1)
    u = lambdify(i)
    @test u(.5) == 1
    @test u(1.5) == 0

    # SymPy issue 567; constants
    u = lambdify(Sym(1//2))
    @test u() ==  1/2
    @test u(1,2,3) == 1/2 # changed to allow constants functions to be n-ary
    @syms x
    ex = integrate(sqrt(1 + (1/x)^2), (x, 1/sympy.E, sympy.E))
    @test lambdify(ex)() ≈ 3.1961985135995072

    # SymPyCore issue #83 (avoid QuadGK issue with testing)
    ∫(expr, lim) = sum(expr, range(lim..., length=100))*(lim[2]-lim[1])/100
    fns = Dict("Integral" => ∫, "NonElementaryIntegral" => ∫)

    f(x) = 1/(x+log(x))
    @test lambdify(integrate(f(x), (x, 1, x)); fns)(2) ≈ ∫(f, (1,2))

end

@testset "Assumptions" begin
    @test ask(𝑄.even(Sym(2))) == true
    @test ask(𝑄.even(Sym(3))) == false
    @test ask(𝑄.nonzero(Sym(3))) == true
    @syms x_real::real
    @syms x_real_positive::(real, positive)
    @test ask(𝑄.positive(x_real)) == Sym(nothing)
    @test ask(𝑄.positive(x_real_positive)) == true
    @test ask(𝑄.nonnegative(x_real^2)) == true
    A = [x_real 1;
         0 x_real]
    @test_broken ask(𝑄.upper_triangular(A)) == true # is None, why?
    @test ask(𝑄.positive_definite([x_real 1; 1 x_real])) == Sym(nothing)
end

@testset "use sympy modules" begin

    # issue SymPy #561
    @syms x::real y::real
    u = sympy.solvers.diophantine(2x + 3y ~ 5)
    t0 = only(free_symbols(collect(u)))
    @test u == Set((3t0 - 5, 5 - 2t0))
end

@testset "Fix past issues" begin
    @syms x y z
    ## Issue # 56
    @test Sym(1+2im) == 1+2IM
    @test convert(Sym, 1 + 2im) == 1 + 2IM


    ## Issue #59
    sympy.cse(sin(x)+sin(x)*cos(x))
    sympy.cse((sin(x), sin(x)*cos(x)))
    sympy.cse( (sin(x), sin(x)*cos(x), cos(x), sin(x)*cos(x)) )


    ## issue #67
    @test N(Sym(4)/3) == 4//3
    @test N(convert(Sym, 4//3)) == 4//3

    ## issue #71
    @test log(Sym(3), Sym(4)) == log(Sym(4)) / log(Sym(3))

    ## issue #103 # this does not work for `x` (which has `classname(x) == "Symbol"`), but should work for other expressions
    @syms x y z
    for ex in (sin(x), x*y^2*x, sqrt(x^2 - 2y))
        cmp = Introspection.func(ex)(↓(Introspection.args(ex))...) == ↓(ex)
        @test SymPyCore._convert(Bool, cmp)
    end

    ## properties (Issue #119)
    @test (sympify(3).is_odd) == true
    @test sympy.poly(x^2 -2, x).is_monic == true # not Poly

    ## test round (Issue #153)
    y = Sym(eps())
    @test round(N(y), digits=5) == 0
    @test round(N(y), digits=16) != 0

    ## lambdify over a matrix #218
    @syms x y
    s = [1 0; 0 1]
    @test lambdify(x*s)(2) == 2 * s
    U = [x-y x+y; x+y x-y]
    @test lambdify(U, [x,y])(2,4) == [-2 6;6 -2]
    @test lambdify(U, [y,x])(2,4) == [ 2 6;6  2]

    @test eltype(lambdify([x 0; 1 x])(0)) <: Integer
    @test eltype(lambdify([x 0; 1 x], T=Float64)(0)) == Float64

    # issue 222 type of eigvals
    A = [Sym("a") 1; 0 1]
    @test typeof(eigvals(A)) <: Vector{<:Sym}

    # issue 231 Q.complex
    @syms x_maybecomplex
    @syms x_imag::imaginary
    @test ask(𝑄.complex(x_maybecomplex)) == Sym(nothing)
    @test ask(𝑄.complex(x_imag)) == true

    # issue 242 lambdify and conjugate
    @syms x
    #expr = conjugate(x)
    expr = conj(x)
    fn = lambdify(expr)
    @test fn(1.0im) == 0.0 - 1.0im
    fn = lambdify(expr, use_julia_code=true)
    @test fn(1.0im) == 0.0 - 1.0im

    # issue 245 missing sincos
    @test applicable(sincos, x)
    @test sincos(x)[1] == sin(x)

    # issue 256 det
    @syms rho::real phi::real theta::real
    xs = [rho*cos(theta)*sin(phi), rho*sin(theta)*sin(phi), rho*cos(phi)]
    J = [diff(x, u) for x in xs, u in (rho, phi, theta)]
    J.det()

    # issue #273 x[i]
    x = sympy.IndexedBase("x")
    i,j = sympy.symbols("i j", integer=true)
    ## XXX not defined
    #@test x[i] == PyCall.py"$x[$i]"

    ## issue #295 with piecewise function
    @syms x
    p = sympy.Piecewise((x,Gt(x,0)), (x^2, Le(x,0)))
    @test lambdify(p)(2) == 2
    @test lambdify(p)(-2) == (-2)^2

    # issue 298 lambdify for results of dsolve
    @syms t, F()
    diffeq = diff(F(t),t) - 3*F(t)
    res = dsolve(diffeq, F(t), ics=Dict(F(0) => 2))  # 2exp(3t)
    @test lambdify(res)(1) ≈ 2*exp(3*1)

    # issue 304 wrong values for sind, ...
    a = Sym(45)
    @test sind(a) == sin(PI/4)

    # issue #319  with   use   of  Dummy, but
    #  really  a  lambdify issue
    # f  is consant
    # XXX @test integrate(x -> 1, 0, 1)  == 1 <-- want to deprecate
    # XXX @test limit(x->1,  x, 0) == 1
    # xxx @test diff(x->1)  ==   0

    ## Issue 324 with inference of matrix operations
    A = fill(Sym("a"), 2, 2)
    T = eltype(A)
    @test eltype(A*A) == T
    @test eltype(A*ones(2,2)) == T
    @test eltype(A*Diagonal([1,1])) == T
    VERSION >= v"1.2.0"  && @test eltype(A * I(2)) == T

    ## Issue 328 with E -> e
    @syms x
    ex = 3 * sympy.E * x
    fn = lambdify(ex)
    @test fn(1) ≈ 3*exp(1) * 1

    ## Issue 332 with `abs2`
    @syms x::real
    @test abs2(x) == x*x
    @syms x
    @test abs2(x) == x*conj(x)

    ## Issue 376 promote to Sym Before pycall
    f = x -> x^2 + 1 +log(abs( 11*x-15 ))/99
    @test limit(f(x), x=>15//11) == -oo

    ## Issue 351 booleans  and arithmetic operations
    @test Sym(1) + true == Sym(2) == true +  Sym(1)
    @test Sym(1) - true == Sym(0) == true -  Sym(1)
    @test Sym(1) * true == Sym(1) == true * Sym(1)
    @test Sym(1) / true == Sym(1) == true / Sym(1)
    @test true^Sym(1)   == Sym(1) == Sym(1)^true

    ## Issue #390 on div (__div__ was deprecated, use __truediv__)
    #XXX@test Sym(2):-Sym(2):-Sym(2) |> collect == [2, 0, -2]

    ## Lambda function to create a lambda
    # XXX not working!
    #@syms x
    #ex = x^2 - 2
    #fn1 = Lambda(x, ex)
    #fn2 = lambdify(ex)
    #@test fn1(3) == fn2(3)

    ## issue 402 with lamdify and Order
    @syms x
    t = series(exp(x), x, 0, 2)
    @test lambdify(t)(1/2) == 1 + 1/2

    ## Issue #405 with ambiguous methods
    @syms α
    M = Sym[1 2; 3 4]
    @test α * M == M * α
    @test 2 * M == M * 2
    @test isa(M/α, Matrix)
    @test isa(α * inv(M), Matrix)

    ## issue #408 with inv
    @syms n::(integer,positive)
    A = sympy.MatrixSymbol("A", n, n)
    @test hash(A.inv()) == hash(A.I) ## XXX inv(A) == A.I

    # ceil broken
    @syms x
    @test limit(ceil(x), x=>0, dir="+") != limit(ceil(x), x=>0, dir="-")
    @test limit(floor(x), x=>0, dir="+") != limit(floor(x), x=>0, dir="-")

    ## issue #411 with Heaviside
    @syms t
    u = Heaviside(t)
    λ = lambdify(u)
    @test all((iszero(λ(-1)), isone(λ(1))))
    VersionNumber(string(sympy.o.__version__)) >= v"1.9" && @test λ(0) == 1//2
    u = Heaviside(t, 1)
    λ = lambdify(u)
    @test all((iszero(λ(-1)), isone(λ(0)), isone(λ(1))))

    ## lambdify piecewise without error PR #96
    @syms t
    v = sympy.Piecewise((1, Le(t, 0)))
    vv = lambdify(v)
    @test isnan(vv(1))

    ## Issue catch all for N; floats only
    @syms x
    ex = integrate(sqrt(1 + (1/x)^2), (x, 1/sympy.E, sympy.E))
    @test N(ex) ≈ 3.196198513599507

        ## Issue #433 add sympy docstrings, clean up docstring
    # XX sprint(io -> show(io, SymPy.Doc(:sin)))
    Base.Docs.getdoc(sin(x))

    # permutation
    p = Permutation(0,2)
    @test p([1,2,3]) == [3,2,1]
end

## Code to generate methods for exported functions from Base, LinearAlgebra, and SpecialFunctions
## which have a SymPy counterpart.
## Key to this are two exported operators: ↓ and ↑
## visualized by this diagram
##
## Julia ⋯⋯⋯⋯ >  Julia
##  |                ^
##  |                |
##  | ↓              | ↑
##  |                |
##  v      (SymPy)   |
## Python  ------> Python
##
## The bulk of the translations follow this pattern
## Base.λ(x::Sym, args...; kwargs...) = ↑(_sympy_.λ(↓(x), ↓(args)...; ↓ₖ(kwargs)...)
## which allows for metaprogramming
##
## Also are a few object methods, essentially:
## meth(obj::Sym, args...; kwargs...) = obj.meth(args...; kwargs...)


## --------------------------------------------------
## Generate the methods
for (pmod, pmeth, jmod, jmeth) ∈ SymPyCore.generic_methods
    @eval begin
        ($(jmod).$(jmeth))(x::Sym, args...; kwargs...) =
            ↑($(pmod).$(pmeth)(↓(x), ↓(args)...; ↓ₖ(kwargs)...))
    end
end

for (pmod, pmeth, jmeth) ∈ SymPyCore.new_exported_methods
    @eval begin
        ($(jmeth))(x::Sym, args...; kwargs...) =
            ↑($(pmod).$(pmeth)(↓(x), ↓(args)...; ↓ₖ(kwargs)...))
        export $(jmeth)
    end
end

for (smeth, jmod, jmeth) ∈ SymPyCore.matrix_meths
    @eval begin
        ($(jmod).$(jmeth))(M::Matrix{T}, args...; kwargs...) where {T <: Sym} =
            ↑(↓(M).$(smeth)(↓(args)...; ↓ₖ(kwargs)...))
        ($(jmod).$(jmeth))(M::SubArray{T,2}, args...; kwargs...) where {T <: Sym} =
            ↑(↓(M).$(smeth)(↓(args)...; ↓ₖ(kwargs)...))
    end
end

for (ometh, jmod, jmeth) ∈ SymPyCore.object_methods
    @eval begin
        ($(jmod).$(jmeth))(x::Sym, args...; kwargs...) =
            ↑(↓(x).$(ometh)(↓(args)...; ↓ₖ(kwargs)...))
    end
end

## --------------------------------------------------
## Some trigonometric functions which need PI defined

Base.sinpi(x::Sym) = sin(PI*x)
Base.cospi(x::Sym) = cos(PI*x)
"""
    sinc(x::Sym)

Returns `sin(PI*x)/(PI*x)`.

In the sympy library, `sinc` refers to `sin(x)/x`, differing from `Julia`. When `sympy.sinc(x)` is "lambdified" the value of `sin(x)/x` is used.
"""
Base.sinc(x::Sym) = iszero(x) ? one(x) : sinpi(x)/(PI*x)
Base.cosc(x::Sym) = cospi(x)/x - sinc(x)/x

Base.deg2rad(x::Sym) = x * PI/180
Base.rad2deg(x::Sym) = x * 180 /  PI

for fn ∈ (:sin,:cos, :tan, :sec, :csc, :cot)
    f = Symbol(string(fn) * "d")
    saf = Symbol("a" * string(fn))
    af = Symbol("a" * string(fn) * "d")
    @eval begin
        (Base.$f)(x::Sym)  = $(sympy).$(fn)(deg2rad(x))
        (Base.$af)(x::Sym) = rad2deg(($sympy).$(saf)(x))
    end
end


## Add methods for "solve functions"
for meth ∈ (:solve, :linsolve, :nonlinsolve, :nsolve, :dsolve)
    m = Symbol(meth)
    @eval begin
        ($meth)(V::AbstractArray{T,N}, args...; kwargs...) where {T <: SymbolicObject, N} =
            ↑(_sympy_.$meth(↓(V), ↓(args)...; ↓ₖ(kwargs)...))
        ($meth)(Ts::NTuple{N,T}, args...; kwargs...) where {N, T <: SymbolicObject} =
            sympy.$meth(Ts, args...; kwargs...)
        ($meth)(Ts::Tuple, args...; kwargs...) =
            sympy.$meth(Ts, args...; kwargs...)
    end
end

"""

Plotting of symbolic objects.

The `Plots` package provide a uniform interface to many of `Julia`'s
plotting packages. `SymPy` plugs into `Plots`' "recipes."

The basic goal is that when `Plots` provides an interface for function
objects, this package extends the interface to symbolic expressions.

In particular:


* `plot(ex::Sym, a, b; kwargs...)` will plot a function evaluating `ex` over [a,b]

Example. Here we use the default backend for `Plots` to make a plot:

```julia
using Plots
@syms x
plot(x^2 - 2x, 0, 4)
```



* `plot(ex1, ex2, a, b; kwargs...)` will plot the two expressions in a parametric plot over the interval `[a,b]`.

Example:

```julia
@syms x
plot(sin(2x), cos(3x), 0, 4pi) ## also
```

For a few backends (those that support `:path3d`) a third symbolic
expression may be added to have a 3d parametric plot rendered:

```julia
plot(sin(x), cos(x), x, 0, 4pi) # helix in 3d
```

* `plot(xs, ys, expression)` will make a contour plot (for many backends).

```julia
@syms x y
plot(range(0,stop=5, length=50), range(0,stop=5, length=50), x*y)
```



* To plot the surface  `z=ex(x,y)` over a region we have `Plots.surface`. For example,

```julia
@syms x y
surface(-5:5, -5:5, 25 - x^2 - y^2)
```


* To plot two or more functions at once, the style `plot([ex1, ex2], a, b)` does not work. Rather, use
    `plot(ex1, a, b); plot!(ex2)`, as in:

```julia
@syms x
plot(sin(x), 0, 2pi)
plot!(cos(x))
```

"""
sympy_plotting = nothing
export sympy_plotting


## Recipes for hooking into Plots

@recipe f(::Type{T}, v::T) where {T<:Sym} = lambdify(v)


## for vectors of expressions
## This does not work. See: https://github.com/JuliaPlots/RecipesBase.jl/issues/19
#@recipe f(ss::AbstractVector{Sym}) = lambdify.(ss)
#@recipe  function f{T<:Array{Sym,1}}(::Type{T}, ss::T)  Function[lambdify(s) for s in ss]  end

## --------------------------------------------------

module SymPyCore

using SpecialFunctions
using LinearAlgebra
using Markdown
import CommonSolve
import CommonSolve: solve
using CommonEq
using RecipesBase
using Latexify
using TermInterface

include("types.jl")
include("equality.jl")
include("utils.jl")
include("decl.jl")
include("gen_methods.jl")
include("mathops.jl")
include("mathfuns.jl")
include("numbers.jl")
include("matrix.jl")
include("lambdify.jl")
include("patternmatch.jl")
include("plot_recipes.jl")
include("latexify_recipe.jl")


## Staging ground

ask(x::Bool, args...) = x
ask(x::Nothing, args...) = x


## ambiguities detected by Aqua
Sym(x::Base.TwicePrecision)  = Sym(_sympy_.sympify(x))
Sym(x::Base.AbstractChar) = Sym(string(x))
Sym{T}(x::Base.TwicePrecision) where T = Sym{T}(_sympy_.sympify(x))
Sym{T}(x::Base.AbstractChar) where T = Sym{T}(string(x))

SymFunction(x::Base.TwicePrecision) = nothing
SymFunction(x::Base.AbstractChar) = SymFunction(string(x))
SymFunction(x::SymFunction) = x

SymFunction{T}(x::Base.TwicePrecision) where T = nothing
SymFunction{T}(x::Base.AbstractChar) where T = SymFunction{T}(string(x))
SymFunction{T}(x::SymFunction{T}) where T = x


end

# test extensions

import SymbolicUtils
using SymPyCore: exchange, Sym

@testset "SymbolicUtils exchange" begin
    T = Sym
    𝐓 = SymbolicUtils.BasicSymbolic

    SymbolicUtils.@syms a b
    a*cos(b) |> exchange(T) isa T
    a*cos(b) |> exchange(T) |> exchange(𝐓) isa 𝐓
end

using SymPy
using PyCall: PyError
using Test


import PyCall
PyCall.pyimport_conda("sympy.physics.wigner",       "sympy")
PyCall.pyimport_conda("sympy.physics.optics",       "sympy")
PyCall.pyimport_conda("sympy.physics.quantum.spin", "sympy")

import_from(sympy.physics.wigner)
import_from(sympy.physics.optics)
import_from(sympy.physics.quantum.spin)

@testset "Physics" begin
    @test clebsch_gordan(Sym(3)/2, Sym(1)/2, 2, Sym(3)/2, Sym(1)/2, 2) == 1
    @test clebsch_gordan(Sym(3)/2, Sym(1)/2, 1, Sym(3)/2, -Sym(1)/2, 1) == sqrt(Sym(3))/2
    @test clebsch_gordan(Sym(3)/2, Sym(1)/2, 1, -Sym(1)/2, Sym(1)/2, 0) == -sqrt(Sym(2))/2

    θ, ϕ = symbols("theta, phi")
    @test dot_rot_grad_Ynm(Sym(3), 2, 2, 0, θ, ϕ).doit() == 3*sqrt(Sym(55))*Ynm(Sym(5), 2, θ, ϕ)/(11*sqrt(PI))

    @test gaunt(Sym(1),0,1,1,0,-1) == -1/(2*sqrt(PI))
    @test N(gaunt(Sym(1000),1000,1200,9,3,-12)) ≈ 0.00689500421922113448 # takes forever to compute

    @test_throws PyError gaunt(Sym(1),2,0,1.2,0,0,0)
    @test_throws PyError gaunt(Sym(1),0,1,1.1,0,-1.1)

    @test racah(Sym(3),3,3,3,3,3) == -1//14


    @test wigner_3j(Sym(2), 6, 4, 0, 0, 0) == sqrt(Sym(715))/143
    @test wigner_3j(Sym(2), 6, 4, 0, 0, 1) == 0

    @test wigner_6j(Sym(3),3,3,3,3,3) == -1//14
    @test wigner_6j(Sym(5),5,5,5,5,5) == 1//52


    # Optics
    # sympy.physics.optics.RayTransferMatrix not a function
    @test sympy.physics.optics.RayTransferMatrix(1,2,3,4) == convert(SymMatrix,Sym[1 2; 3 4])
    @test sympy.physics.optics.FlatMirror() == convert(SymMatrix,Sym[1 0; 0 1])

    # Spin
    import_from(sympy.physics.quantum.spin, (:WignerD,), typ=:Any)
    @test WignerD(Sym(3), Sym(2), Sym(1), PI, PI/2, -PI).doit() == -sqrt(Sym(10))/8
    @test WignerD(Sym(1), Sym(1), Sym(0), 0, θ, 0).doit() == -sin(θ)/sqrt(Sym(2))
end

## --------------------------------------------------
## Subs

## Call
## Call symbolic object with natural syntax
## ex(x=>val)
## how to do from any symbolic object?
(ex::Sym)() = ex

## without specification, variables to substitute for come from ordering of `free_symbols`:
function (ex::Sym)(args...)
    if ex.is_Permutation == true
        return ↑(↓(ex)(map(↓, args)...))
    end

    # need to check if callable.
    # This is a total hack!
    if ex.is_Function == true && string(ex.o.__class__.__name__) == "UndefinedFunction"
        return ↑(↓(ex)(map(↓, args)...))
    end

    xs = free_symbols(ex)
    return subs(ex, Dict(zip(xs, args)))
end

## can use a Dict or pairs to specify:
function (ex::Sym)(x::Dict)
    for (k,v) in x
        ex = subs(ex, Pair(k, Sym(v)))
    end
    ex
end
(ex::Sym)(kvs::Pair...) = ex(Dict(kvs...))

##################################################
## subs
##
"""
`subs` is used to substitute a value in an expression with another
value.
Examples:

```jldoctest subs
julia> using SymPyPythonCall



julia> @syms x,y
(x, y)

julia> ex = (x-y)*(x+2y)
(x - y)⋅(x + 2⋅y)

julia> subs(ex, (y, y^2)) |> show
(x - y^2)*(x + 2*y^2)

julia> subs(ex, (x,1), (y,2))
-5

julia> subs(ex, (x,y^3), (y,2))
72

julia> subs(ex, y, 3)
(x - 3)⋅(x + 6)
```

There is a curried form of `subs` to use with the chaining `|>` operator

```jldoctest subs
julia> ex |> subs(x,ℯ)
(ℯ - y)⋅(2⋅y + ℯ)
```
The use of pairs gives a convenient alternative:

```jldoctest subs
julia> subs(ex, x=>1, y=>2)
-5

julia> ex |> subs(x=>1, y=>2)
-5
```


"""
function subs(ex::T, y::Tuple{Any, Any}; kwargs...) where {T <: SymbolicObject}
    ex.subs(y[1], Sym(y[2]), kwargs...)
end

# Alternate interfaces

subs(ex::T, y::Tuple{Any, Any}, args...; kwargs...) where {T <: SymbolicObject} = subs(subs(ex, y), args...)
subs(ex::T, y::S, val; kwargs...)                   where {T <: SymbolicObject, S<:SymbolicObject} = subs(ex, (y,val))
subs(ex::T, dict::Dict; kwargs...)                  where {T <: SymbolicObject} = subs(ex, dict...)
subs(ex::T, d::Pair...; kwargs...)                  where {T <: SymbolicObject} = subs(ex, ((p.first, p.second) for p in d)...)
subs(exs::Tuple{T, N}, args...; kwargs...)          where {T <: SymbolicObject, N} = map(u -> subs(u, args...;kwargs...), exs)
subs(x::Number, args...; kwargs...) = x

## curried versions to use with |>
subs(x::SymbolicObject, y; kwargs...) = ex -> subs(ex, x, y; kwargs...)
subs(;kwargs...)                      = ex -> subs(ex; kwargs...)
subs(dict::Dict; kwargs...)           = ex -> subs(ex, dict...; kwargs...)
subs(d::Pair...; kwargs...)           = ex -> subs(ex, [(p.first, p.second) for p in d]...; kwargs...)


##################################################
## doit
##
"""
    doit

Evaluates objects that are not evaluated by default. Alias for object method.

## Extended help
Examples:

```jldoctest doit
julia> using SymPyPythonCall

julia> @syms x f()
(x, f)

julia> D = Differential(x)
Differential(x)

julia> df = D(f(x)); show(df)
Derivative(f(x), x)

julia> dfx = subs(df, (f(x), x^2));  show(dfx)
Derivative(x^2, x)

julia> doit(dfx)
2⋅x
```

Set `deep=true` to apply `doit` recursively to force evaluation of nested expressions:

```jldoctest doit
julia> @syms g()
(g,)

julia> dgfx = g(dfx);  show(dgfx)
g(Derivative(x^2, x))

julia> doit(dgfx) |> show
g(Derivative(x^2, x))

julia> doit(dgfx, deep=true)
g(2⋅x)
```

There is also a curried form of `doit`:
```jldoctest doit
julia> dfx |> doit
2⋅x

julia> dgfx |> doit(deep=true)
g(2⋅x)
```

"""
doit(ex::T; deep::Bool=false) where {T<:SymbolicObject} = ex.doit(deep=deep)
doit(; deep::Bool=false)                                = ((ex::T) where {T<:SymbolicObject}) -> doit(ex, deep=deep)

## simplify(ex::SymbolicObject, ...) is exported
"""
    simplify

SymPy has dozens of functions to perform various kinds of simplification. There is also one general function called `simplify` that attempts to apply all of these functions in an intelligent way to arrive at the simplest form of an expression. (See [Simplification](https://docs.sympy.org/latest/tutorial/simplification.html) for details on `simplify` and other related functionality). Other simplification functions are available through the `sympy` object.

For non-symbolic expressions, `simplify` returns its first argument.
"""
simplify(x, args...;kwargs...) = x

##################################################
##
## access documentation of SymPy
"""
    SymPy.Doc(f::Symbol, [module=sympy])

Return docstring of `f` found within the specified module.

Examples
```
SymPy.Doc(:sin)
SymPy.Doc(:det, sympy.matrices)
## add module to query
SymPy.pyimport_conda("sympy.crypto.crypto", "sympy")
SymPy.Doc(:padded_key, sympy.crypto)
```
"""
struct Doc
    u
    m
end
Doc(u::Union{Symbol, Function}) = Doc(Symbol(u), sympy)
function Base.show(io::IO, u::Doc)
    v = getproperty(u.m, Symbol(u.u)).__doc__
    print(io, v)
end


"""
    free_symbols(ex)
    free_symbols(ex::Vector{Sym})

Return vector of free symbols of expression or vector of expressions. The results are orderded by
`sortperm(string.(fs))`.

Example:

```jldoctest
julia> using SymPyPythonCall

julia> @syms x y z a
(x, y, z, a)

julia> free_symbols(2*x + a*y) # [a, x, y]
3-element Vector{Sym{PythonCall.Py}}:
 a
 x
 y


julia> free_symbols([x^2, x^2 - 2x*y + y^2])
2-element Vector{Sym{PythonCall.Py}}:
 x
 y
```
"""
function free_symbols(ex::S) where {T, S<:SymbolicObject{T}}
    !hasproperty(↓(ex), :free_symbols) && return Sym{T}[]
    fs = collect(↓(ex).free_symbols)
    isempty(fs) && return Sym{T}[]
    return Sym.(fs[sortperm(string.(fs))] )
end

# over container
function free_symbols(exs::Vector{S}) where {S}
    return sort(unique(reduce(vcat, free_symbols.(exs))))
end

function free_symbols(exs::Tuple)
    map(free_symbols, exs)
end

# matrix
# SymMatrix has methods to expose.
# XXX has issue with @inferred
# XXX link into pyconvert...

Base.promote_op(::O, ::Type{S}, ::Type{T}) where {O, T<:Sym, S <: Number} = T
Base.promote_op(::O, ::Type{T}, ::Type{S}) where {O, T<:Sym, S <: Number} = T
Base.promote_op(::O, ::Type{T}, ::Type{T′}) where {O, T<:Sym, T′<:Sym} = T

Base.eachrow(M::Matrix{T}) where {T <: SymbolicObject} = (M[i,:] for i ∈ 1:size(M,1))

# XXX for *some* reason this was a good idea. Doesn't seem to be necessary
# now, but if that reason resurfaces, will have to see
#function Base.view(A::AbstractArray{T,N}, I::Vararg{Any,M}) where {T <: SymbolicObject, N,M}
#    A[I...] # can't take view!!
#end

call_matrix_meth(M::Matrix{T}, meth::Symbol, args...; kwargs...) where {T <: Sym} =
    ↑(getproperty(↓(M), meth)(↓(args)...; ↓ₖ(kwargs)...))


## -- special methods
function LinearAlgebra.transpose(A::AbstractVecOrMat{T}) where {T <: Sym}
    LinearAlgebra.Transpose{T,typeof(A)}(A)
end
function LinearAlgebra.adjoint(A::AbstractVecOrMat{T}) where {T <: Sym}
    LinearAlgebra.Adjoint{T,typeof(A)}(A)
end
Base.promote_op(::Union{typeof(adjoint),typeof(transpose)}, ::Type{T}) where {T<: Sym} = T # issue #77


#LinearAlgebra.qr(A::AbstractArray{<:Sym,2}) = ↑(↓(A).QRdecomposition())

## ----

# XXX what keyword arguments to support?
function LinearAlgebra.eigvecs(A::AbstractMatrix{T}) where {T <: Sym}
    eigs = A.eigenvects()
    hcat((hcat(v...) for (λ,k,v) ∈ eigs)...)
end

# XXX what keyword arguments to support?
function LinearAlgebra.eigvals(A::AbstractMatrix{T}) where {T <: Sym}
    eigs = A.eigenvects()
    vcat((fill(λ, N(k)) for (λ,k,v) ∈ eigs)...)
end

# add sortby
#
function LinearAlgebra.eigen(A::AbstractMatrix{T}) where {T <: Sym}
    LinearAlgebra.Eigen(eigvals(A), eigvecs(A))
end

## ----

## Issue #359 so that A  +  λI is of type Sym
Base.promote_op(::O, ::Type{S}, ::Type{T}) where {O, P, S<:Sym{P}, R, T<:UniformScaling{R}} = S
Base.promote_op(::O, ::Type{T}, ::Type{S}) where {O, P, S<:Sym{P}, R, T<:UniformScaling{R}} = S

## ----
# solve Ax=b for x, avoiding generic `lu`, which can be very slow for bigger n values
# fix suggested by @olof3 in issue 355
# This is causing many ambiguities

function LinearAlgebra.:\(A::AbstractMatrix{<:SymbolicObject},
    b::AbstractVecOrMat)
    _backslash(A,b)
end

# use solve
# lu(A) works, *but* doesn't simplify (https://github.com/JuliaPy/SymPy.jl/issues/355) so can have exponentially growing complexity
function _backslash(A, b::AbstractVector)
    m,n  = size(A)
    x =  [Sym("x$i") for  i in 1:n]
    out = solve(A*x-b, x)
    isempty(out) && throw(SingularException(0)) # Could also return out here?
    ret = Vector{Sym}(undef, n)
    for (i,xᵢ)  in enumerate(x)
        ret[i] =  get(out,  xᵢ, xᵢ)
    end
    return ret
end

function _backslash(A, B::AbstractMatrix)
    hcat([A \ bⱼ for bⱼ in eachcol(B)]...)
end

import SymPyCore.TermInterface

@testset "Symbol creation" begin
    ## Symbol creation
    Sym("x")
    Sym(:x)

    symbols("x")
    x,y = symbols("x,y")

    # @syms
    @syms x
    @syms x, y
    @syms x, xs[1:3]()
    @syms t, x(), y[1:5], z::positive, a=>"α₁"
    @test SymPyCore.funcname(x(t)) == "x"
    @test string(y[1]) == "y₁"
    @test string(a) == "α₁"
    @test isempty(solve(z+1))

    # make sure @syms defines in a local scope
    let
        @syms locally_grown
    end
    @test_throws UndefVarError isdefined(locally_grown)

end

@testset "Symbolic numbers" begin
    @test Sym(2) == 2
    @test Sym(2.0) == 2.0
    @test Sym(2//1) == 2
    @test Sym(im) == 1im
    @test Sym(2im) == 2im
    @test Sym(1 + 2im) == 1 + 2im

    pi, e, catalan = Base.MathConstants.pi, Base.MathConstants.e, Base.MathConstants.catalan
    @test N(Sym(pi)) == pi
    @test N(Sym(ℯ)) ==  ℯ

    # @test N(Sym(catalan)) == catalan XXX <<--- expose catalan?
end

@testset "conversion, promotion" begin
    @syms x
    a,b,c = Sym(2), Sym(2.3), Sym(1 + 2im)

    # promote to Sym
    @test promote(x, 2)[2] isa Sym
    @test promote(x, pi)[2] == PI
    @test promote(x, ℯ)[2] == E
    @test promote(x, exp(1))[2] != E
    @test promote(x, 1//3)[2] == Sym(1)/3
    @test_broken promote(x, 1/3)[2] != Sym(1)/3 # Sym(1/3).equals(Sym(1//3)) is True!

    # promotion via Number defaults
    @test 1 + Sym(2) == Sym(3)
    @test 1 - Sym(2) == Sym(-1)
    @test 1 * Sym(2) == Sym(2)
    @test Sym(1) / 2 == Sym(1//2)
    @test 1 / Sym(2) == Sym(1//2)

    # conversion to number types.
    @test convert(Int, a) == 2
    @test convert(BigInt, a) isa BigInt
    @test convert(Float64, b) == 2.3
    @test convert(BigFloat, b) isa BigFloat
    @test convert(Complex{Int}, c) == 1 + 2im

    # N gets type right?
    @syms x
    @test isa(PI.evalf(), Sym)
    @test isa(N(x), Sym)
    @test isa(N(Sym(1)), Integer)
    @test isa(N(Sym(1)/2), Rational)
    @test isa(N(Sym(1.2)), Float64)

    # issue #39
    @test promote_type(typeof(one(Sym)), eltype(Sym[1, 2])) == eltype([Sym(1)])

    # SymPy issue #545
    @syms x
    for op ∈ (+,-,*,/,^)
        @inferred op(2,x)
        @inferred op(x,2)
        @inferred op(x,x)
    end
end


@testset "Methods" begin
    @syms x
    p = (x-1)*(x-2)

    # sympy.λ calls
    rs = sympy.roots(p)
    @test rs == Dict{Any,Any}(Sym(1) => 1, Sym(2) => 1)

    p = sympy.poly(p, x)

    # obj.method calls
    @test p.coeffs() == Any[1,-3,2]

end

@testset "substitution" begin
    @syms x
    f = x -> x^2 - 2
    y = f(x)
    @test y.subs(x,1) == f(1)

    ex = (x-1)*(y-2)
    @test ex.subs(x, 1) == 0
    @test ex.subs(((x,1),)) == 0
    @test ex.subs(((x,2),(y,2))) == 0

    # imterface
    @test subs(ex, x=>1) == 0       # removed
    @test subs(ex, x=>2, y=>2) == 0
    @test subs(ex, Dict(x=>1)) == 0
    @test ex(x=>1) == 0
    @test ex(x=>2, y=>2) == 0
    @test ex.subs(Dict(x=>1)) == 0 ## should break. Awkward mix of python/julia

    # Test subs on simple numbers
    @syms x y
    @test Sym(2)(x=>300, y=>1.2) == 2

    #Test subs for pars and dicts
    ex = 1
    dict1 = Dict{String,Any}()
    dict2 = Dict{Any,Any}()
    #test subs
    for i=1:4
        x = Sym("x$i")
        ex=ex*x
        dict1[string(x)] = i ## This shouldn't work!!
        dict2[x] = i
    end
    for d in (dict1,)
        @test ex |> subs(d) == factorial(4)
        @test subs(ex, d) == factorial(4)
        @test subs(ex, d...) == factorial(4)
        @test ex |> subs(d...) == factorial(4)
        @test ex(d) == factorial(4)
        @test ex(d...) == factorial(4)
    end
    for d in (dict2,)
        @test ex |> subs(d) == factorial(4)
        @test subs(ex, d) == factorial(4)
        @test subs(ex, d...) == factorial(4)
        @test ex |> subs(d...) == factorial(4)
        @test ex(d) == factorial(4)
        @test ex(d...) == factorial(4)
    end

    # call is substitution
    @syms x c f()
    @test sin(x)(c) == sin(c)
    @test f(x)(c) == f(c)
end


@testset "simplify" begin
    @syms x y
    @syms xₚ::positive, yₚ::positive
    @syms a::positive b::positive

    @test simplify(sin(x)^2 + cos(x)^2) == 1
    @test simplify((x^3 + x^2 - x - 1)/(x^2 + 2x + 1)) == x - 1
    @test simplify(x^a*x^b) == x^(a+b)
    @test simplify(x^a*y^a) == x^a * y^a
    @test simplify(xₚ^a*yₚ^a) == (xₚ* yₚ)^a
end


@testset "Equality" begin
    T,F, No, N,M = Sym(true), Sym(false), Sym(nothing), Sym(NaN), missing
    @syms x y=>"x" z::real=>"x"


    @test x == x
    @test x == y
    @test x != z
    @test T == T
    @test T == true
    @test F == F
    @test F == false
    @test No == No
    @test No == nothing
    @test N != N
    @test isequal(N, N)
    @test isequal(oo, N) == isequal(Inf, NaN)
    @test ismissing(N == M)
    @test ismissing(M == M)
    @test isequal(M, M)

    a = (T,F,N,M,x,y,z)
    for i ∈ 1:length(a)
        for j ∈ (i+1):length(a)
            u,v = a[i], a[j]
            @test isless(u,v) + isequal(u,v) + isless(v,u) == 1
        end
    end

    @syms x::positive
    @test Lt(x, 0) == false # sympy.logic.boolalg.BooleanFalse == false

end

@testset "solve" begin
    @syms x y::real z::positive

    @test length(solve(x^2 + 1)) == 2
    @test length(solve(y^2 + 1)) != 2
    @test length(solve(y^2 - 1)) == 2
    @test length(solve(z^2 - 1)) != 2
    @test length(solve((z-1)*(z-2))) == 2

end

@testset "solveset" begin
    @syms x y::real z::positive

    @test length(solveset(x^2 + 1)) == 2
    #@test_broken length(solveset(y^2 + 1)) != 2 # solveset ignores assumptions?

    @test length(solveset((x-2)*(x-2) ~ 0)) == 1
    @test length(solveset((x-2)*(x-3) ~ 0)) == 2

    u = solveset(sin(x) ~ 1//2, x) # an infinite set
    J = sympy.Interval(-PI/2, PI/2)
    @test length(intersect(u, J)) == 1

end

@testset "Assumptions" begin
    ## Assumptions
    @syms x_real::real
    @syms x_real_positive::(real, positive)

    @test ask(𝑄.even(Sym(2))) == true
    @test ask(𝑄.even(Sym(3))) == false
    @test ask(𝑄.nonzero(Sym(3))) == true
    @test ask(𝑄.positive(x_real)) == Sym(nothing) # ==(nothing) promotes to ===
    @test ask(𝑄.positive(x_real_positive)) == true
    @test ask(𝑄.nonnegative(x_real^2)) == true
    ## XXX @test ask(𝑄.upper_triangular([x_real 1; 0 x_real])) == true
    @test ask(𝑄.positive_definite([x_real 1; 1 x_real])) == Sym(nothing)
end

@testset "Intervals" begin
    @test sympy.Interval(0,1).boundary == Set(Sym[0,1])
    @test sympy.Interval(0,1, false, false) == sympy.Interval(0,1,true,true).closure # [0,1] == (0,1).closure
    @test sympy.Interval(0,1,true,true).complement(𝑆.Reals) == union(sympy.Interval(-oo, 0), sympy.Interval(1, oo)) # (0,1)^c = (-oo, 0] ∪ [1, oo)

    @test sympy.Interval(0,1).contains(1//2) == true
    @test 1//2 ∈ sympy.Interval(0,1)
end

@testset "Sets" begin
    s = sympy.FiniteSet("H","T")
    s1 = ↓(s).powerset() # XXX s1 = s.powerset()
    a, b = sympy.Interval(0,1), sympy.Interval(2,3)
    @test a.is_disjoint(b) == true
    @test union(a, b).measure == 2
end

@testset "doit" begin
    ### doit
    @syms x f() g()

    D = Differential(x)
    df = D(f(x))
    dfx = subs(df, f(x) => x^2)
    @test dfx.doit() == 2*x
    @test doit(dfx) == 2*x
    @test dfx |> doit == 2*x
    # use deep=true to force nested evaluations
    dgfx = g(dfx)
    @test dgfx.doit(deep=true) == g(2*x)
    @test doit(dgfx, deep=true) == g(2*x)
    @test dgfx |> doit(deep=true) == g(2*x)

end

@testset "getproperty" begin
    # test getproperty override

    # properties have 3-valued logic
    @syms x::positive y
    @test x.is_real
    @test !x.is_zero
    @test y.is_real == nothing
    @test Sym(7).is_prime
    @test !Sym(8).is_prime
    @test x.isprime == nothing

    # we get modules back
    @test Introspection.classname(sympy.logic) == "module"

    # get callable object for objects with __call__ method
    @test x.subs isa SymPyCore.SymbolicCallable
    @test x.subs(x,2) isa Sym # calls return Sym objects (or containers of)
end

@testset "TermInterface" begin
    @syms x
    @test !TermInterface.iscall(x) # istree deprecated
    @test TermInterface.iscall(sin(x))
    @test TermInterface.operation(sin(x)) == sin
    @test only(TermInterface.arguments(sin(x))) == x
end

## code to test plotting
## not part of headless test suite
## has dependencies not in Test.REQUIRES

using SymPy
using Plots
plotly()

@vars x y

info("expression")
plot(x^2, 0, 3)                   # single expression
plot!(9-x^2, 0, 3, color=:green)  # plot!

info("two graphs")
plot([x^2, 1 - x^2/2], 0, 3)      # two graphs at once

plot(x^2, 0, 3)
plot!(1 - x^2/2, 0, 3)


info("parametric plot")
plot(sin(x), cos(x), 0, 2pi)    # parametric


info("3d parameteric")
plot(cos(x), sin(x), x, 0, pi, linewidth=5)


#info("vectorplot")
#vectorfieldplot([cos(x) sin(y)], (x,0,2pi), (y,0,2pi))

info("contour plot")
contour(linspace(-5,5,25), linspace(-5,5,25), x^2 - y^2)

info("surface")
surface(-5:5, -5:5, 25 - x^2 - y^2)



## PyPlot Only for now.

info("parametric surface")
plot_parametric_surface((sin(x)*sin(y), sin(x)*cos(y), cos(x)), (x,0,pi/2), (y,0,pi))


info("implicit")
plot_implicit(x^2 + y^2 <= 1, (x,-5, 5), (y, 0,5))

Base.promote_rule(::Type{S}, ::Type{T})  where {S<:Number, T<:Sym}= T
Base.promote_rule(::Type{S}, ::Type{T})  where {S<:AbstractIrrational, T<:Sym}= T
Base.promote_rule(::Type{Bool}, ::Type{T}) where {T <: Sym} = T
Base.promote_rule(::Type{Bool}, ::Type{T}) where {T <: Sym{Nothing}} = Sym

Base.promote_rule(::Type{Nothing}, ::Type{T}) where {T <: Sym} = T
Base.promote_rule(::Type{Nothing}, ::Type{T}) where {T <: Sym{Nothing}} = Nothing

Base.convert(::Type{T}, o::Number) where {T <: Sym} = Sym(o)
Base.convert(::Type{T}, o::Number) where {P, T <: Sym{P}} = Sym{P}(o)
Base.convert(::Type{T}, o::Nothing) where {T <: Sym} = Sym(nothing)


import Base: +, -, *, /, //, \, ^, inv
+(x::T, y::SymbolicObject) where {T <: SymbolicObject} = T(↓(x) + ↓(y))
*(x::T, y::SymbolicObject) where {T <: SymbolicObject} = T(↓(x) * ↓(y))
-(x::T, y::SymbolicObject) where {T <: SymbolicObject} = T(↓(x) - ↓(y))
(-)(x::T) where {T <: SymbolicObject}     = T(-↓(x))
/(x::T, y::SymbolicObject) where {T <: SymbolicObject} = T(↓(x) / ↓(y))
^(x::T, y::SymbolicObject)  where {T <: SymbolicObject} = T(↓(x) ^ ↓(y))
^(x::SymbolicObject, y::Rational) = x^convert(Sym,y)
#^(x::Sym, y::Integer) = x^convert(Sym,y) # no Union{Integer, Rational}, as that has ambiguity
//(x::Sym, y::Int) = x / Sym(y)
//(x::Sym, y::Rational) = x / Sym(y)
//(x::Sym, y::Sym) = x / y

\(x::Sym, y::Sym) = (y'/x')' # ?

Base.inv(x::Sym) = ↑(↓(x).__pow__(-1))

# special case Boolean; issue   351
# promotion for Boolean here is to 0 or  1,  not False,  True
+(x::Bool, y::Sym)::Sym = Sym(Int(x)) + y #Sym(Int(x)).__add__(y)
*(x::Bool, y::Sym)::Sym = Sym(Int(x)) * y #.__mul__(y)
-(x::Bool, y::Sym)::Sym = Sym(Int(x)) - y #.__sub__(y)
/(x::Bool, y::Sym)::Sym = Sym(Int(x)) / y #.__truediv__(y)
^(x::Bool, y::Sym)::Sym = Sym(Int(x))^y   #.__pow__(y)
+(x::Sym, y::Bool)::Sym = ↑(↓(x).__add__(Int(y)))
*(x::Sym, y::Bool)::Sym = ↑(↓(x).__mul__(Int(y)))
-(x::Sym, y::Bool)::Sym = ↑(↓(x).__sub__(Int(y)))
/(x::Sym, y::Bool)::Sym = ↑(↓(x).__truediv__(Int(y)))
^(x::Sym, y::Bool)::Sym = ↑(↓(x).__pow__(Int(y)))

# strict conversion Sym(true) only
function Base.convert(::Type{Bool}, x::Sym{T}) where {T}
    y = ↓(x)
    hasproperty(y, :is_Boolean) && return _convert(Bool, y)
    hasproperty(y, :__bool__) && return _convert(Bool, y)
    return false
end

_fix_powers(x) = replace(string(x), r"\*\*" => "^")
sstr(x::SymbolicObject)   = _fix_powers(_sympy_.sstr(↓(x)))
pretty(x::SymbolicObject) = _fix_powers(_sympy_.pretty(↓(x)))
latex(x::SymbolicObject)  = string(_sympy_.latex(↓(x)))
srepr(x::SymbolicObject)  = string(_sympy_.srepr(↓(x)))

function Base.show(io::IO, x::SymbolicObject)
    #out = _sympy_.printing.pretty(x.o) # or .sstr
    out = _sympy_.printing.str.sstr(x.o) # or .pretty
    out = replace(string(out), r"\*\*" => "^")
    print(io, out)
end

function Base.show(io::IO, ::MIME"text/plain", x::SymbolicObject)
    out = _sympy_.printing.pretty(x.o) # or .sstr
    #out = _sympy_.printing.str.sstr(x.o) # or .pretty
    out = replace(string(out), r"\*\*" => "^")
    print(io, out)
end

#=
function Base.show(io::IO,  ::MIME"text/plain", x::Array{T, N}) where {N, T<:SymbolicObject)
    o = x.o
    out = string(_sympy_.printing.str.sstr(o)) # or .pretty
    out = replace(out, r"\*\*" => "^")
    print(io, out)
end
=#

## --------------------------------------------------
## LaTeX printing

function Base.show(io::IO,  ::MIME"text/latex", x::SymbolicObject)
    out = _sympy_.latex(↓(x), mode="inline",fold_short_frac=false)
    print(io, string(out))
end

function  Base.show(io::IO, M::MIME"text/latex", x::AbstractArray{<:Sym})
    show(io, M, sympy.ImmutableMatrix(x))
end

function Base.show(io::IO, ::MIME"text/latex", d::Dict{T,S}) where {T<:SymbolicObject, S<:Any}
    Latex(x::Sym) = latex(x)
    Latex(x) = sprint(io -> show(IOContext(io, :compact => true), x))

    out = "\\begin{equation*}\\begin{cases}"
    for (k,v) in d
        out = out * Latex(k) * " & \\text{=>} &" * Latex(v) * "\\\\"
    end
    out = out * "\\end{cases}\\end{equation*}"
    print(io, as_markdown(out))
end

as_markdown(x) = x# Markdown.parse("``$x``") #???

function toeqnarray(x::AbstractVector{T}) where {T <: SymbolicObject}
    a = join([latex(x[i]) for i in 1:length(x)], "\\\\")
end

function toeqnarray(x::AbstractMatrix{T}) where {T <: SymbolicObject}
    sz = size(x)
    a = join([join(map(latex, x[i,:]), "&") for i in 1:sz[1]], "\\\\")
end

using Test

@testset "ODEs" begin
    ## ODEs
    @syms x, a , F()
    ex = diff(F(x), x) - a*F(x)
    ex1 = dsolve(ex)
    ex2 = ex1.rhs()(Sym("C1") => 1, a => 2)
    @test ex2 == exp(2x)

    @syms t, X(), Y()
    eq = (Eq(diff(X(t),t), 12*t*X(t) + 8*Y(t)), Eq(diff(Y(t),t), 21*X(t) + 7*t*Y(t)))
    sympy.dsolve(eq)  # use tuple, not array is not SymbolicObject

    ## ---

    @syms a x y0 y1 u()
    ∂ = Differential(x)

    @test dsolve(∂(u)(x) - a*u(x), u(x), ics=Dict(u(0) => 1)) == Eq(u(x), exp(a*x))
    @test dsolve(∂(u)(x) - a*u(x), u(x), ics=Dict(u(0) => y1)) == Eq(u(x), y1*exp(a*x))

    dsolve(∂(u)(x) - a*u(x), u(x), ics=Dict(u(y0)=>y1)) # == Eq(u(x), y1 * exp(a*(x - y0)))
    dsolve(x*∂(u)(x) + x*u(x) + 1, u(x), ics=Dict(u(1) => 1))
    𝒂 = 2
    dsolve((∂(u)(x))^2 - 𝒂 * u(x), u(x), ics=Dict(u(0) => 0, ∂(u)(0) => 0))
    dsolve(∂(∂(u))(x) - 𝒂 * u(x), u(x), ics=Dict(u(0)=> 1, ∂(u)(0) => 0))

    @syms x, y , F(), G(), K()
    eqn = F(x)*∂(u)(y)*y + G(x)*u(y) + K(x)
    dsolve(eqn, u(y), ics=Dict(u(1) => 0))

    ## dsolve eqn has two answers, but we want to eliminate one
    # based on initial condition
    dsolve(∂(u)(x) - (u(x)-1)*u(x)*(u(x)+1), u(x), ics=Dict(u(0)=> Sym(1//2)))

    ## ----
    ## rhs works
    @syms x y a::positive u()
    eqn = ∂(u)(x) - a * u(x) * (1 - u(x))
    out = dsolve(eqn)
    eq = rhs(out)    # just the right hand side
    C1 = first(setdiff(free_symbols(eq), (x,a)))
    c1 = solve(eq(x=>0) - 1//2, C1)
    @test c1[1] == Sym(1)


    ## dsolve and system of equations issue #291
    @syms t x() y()
    ∂ = Differential(t)
    eq1 = ∂(x(t)) ~ x(t)*y(t)*sin(t)
    eq2 = ∂(y(t)) ~ y(t)^2*sin(t)
    out = dsolve((eq1, eq2)) # tuple of equations


end

using Test
using LinearAlgebra
using SparseArrays

@testset "Matrix" begin
    ## matrices
    @syms x y
    A = [x 1; 1 x]
    B = [x 1; 0 2x]
    v = [x, 2]

    ## These fail for older installations of SymPy
    @test simplify(det(A)) == x^2 - 1

    ## we use inverse for A[:inv]()

    # aliased to use inverse
    @test simplify.(inv(A) * A) ==  [1 0; 0 1]
    @test simplify.(A * inv(A)) == [1 0; 0 1]
    ##XXX    @test simplify.(A[:inv]() - inv(A)) == zeros(2, 2)

    @test adjoint(B) == [adjoint(x) 0; 1 adjoint(2x)]
    @test adjoint(B) == B'
    @test eltype(adjoint(A)) == eltype(A)
    @test eltype(transpose(A)) == eltype(A)


    @test A.dual() == sympy.zeros(2, 2)


    A1 = Sym[25 15 -5; 15 18 0; -5 0 11]
    r = A1.cholesky()
    @test r*r.transpose() == A1


    #    s = LUsolve(A, v)
    s = A.LUsolve(B)
    @test simplify.(A * s) == B

    # norm
    @test norm(A) == sqrt(2 * abs(x)^2 + 2)
    # test norm for different subtypes of AbstractArray
    ## XXX @test norm(A) == norm(Symmetric(A)) LinearAlgebra.Symmetric no long works
    @test norm(A) == norm(view(A, :, :))

    # abs
    @test all(convert.(Bool, abs.(A) .≧ 0))
    @test abs.(A) == abs.(view(A, :, :))

    # is_lower, is_square, is_symmetric much slower than julia only counterparts. May deprecate, but for now they are here
    @syms x::complex # specifically not real
    @test A.is_lower == istril(A)
    @test A.is_square == true
    #@test A.is_symmetric() != issymmetric(A)

    @syms x::real
    A = [x 1; 1 x]
    @test A.is_symmetric() == issymmetric(A)

    @test Set(eigvals(A)) == Set([x-1, x+1])

    # issue with transpose being non-typestable
    @test eltype(transpose(A)) == eltype(A)
    @test eltype(Symmetric(A)) == eltype(A)

    #numerical tests
    M = Sym[1 0 0; 0 1 0; 0 0 x]
    evecs = eigvecs(M)
    @test evecs[:,1] == [1, 0, 0]


    A = Sym[1 2 3; 3 6 2; 2 0 1]
    q, r = A.QRdecomposition()
    @test q * r == A
    @test abs(det(q)) == 1


    # using sympy.Matrix
    L = collect(sympy.Matrix.([[2,3,5], [3,6,2], [8,3,6]]))

    # for v0.4, the vector type is not correctly inferred
    #L = Vector{Sym}[Sym[2,3,5], Sym[3,6,2], Sym[8,3,6]]
    # L = collect(sympy.Matrix.(([[2,3,5]], [[3,6,2]], [[8,3,6]]]))

    L = (Sym[2 3 5],Sym[3 6 2], Sym[8 3 6])
    out = sympy.GramSchmidt(L, true)  # qualify, as L not SymbolicObject type
    for i = 1:3, j = i:3
        @test out[i].dot(out[j]) == (i == j ? 1 : 0)
    end

    A = Sym[4 3; 6 3]
    L, U, _ = A.LUdecomposition()
    @test L == Sym[1 0; 3//2 1]

    A = Sym[1 0; 0 1] * 2
    B = Sym[1 2; 3 4]
    @test A.diagonal_solve(B) == B/2

    M = Sym[1 2 0; 0 3 0; 2 -4 2]
    P, D = M.diagonalize()
    @test D == [1 0 0; 0 2 0; 0 0 3]
    @test P == [-1 0 -1; 0 0 -1; 2 1  2]
    @test D == inv(P) * M * P

    # test SymPy's expm against Julia's expm
    A = [1 2 0; 0 3 0; 2 -4 2]
    M = Sym.(A)
    ## no exp(M)!
    U = M.exp() - exp(A)
    @test maximum(abs.(N.(U))) <= 1e-12

    @syms x, y
    M = [x y; 1 0]
    @test integrate.(M, x) == [x^2/2 x*y; x 0]
    @test integrate.(M, Ref((x, 0, 2))) == [2 2y; 2 0]


    M = Sym[1 3 0; -2 -6 0; 3 9 6]
    @test M.nullspace()[1] ==  reshape(Sym[-3, 1, 0], 3, 1)


    M = Sym[1 2 0; 0 3 0; 2 -4 2]
    # M.cofactor  uses 0-based indexing!
    i, j = 1, 2
    @test M.cofactor(i, j) == (-1)^(i+j) * det(M[setdiff(1:3, i+1), setdiff(1:3, j+1)])
    @test M.adjugate() / M.det() == M.inv()

    M = Sym[ 6  5 -2 -3;
            -3 -1  3  3;
             2  1 -2 -3;
            -1  1  5  5]

    P, J = M.jordan_form()
    @test J == [2 1 0 0;
                0 2 0 0;
                0 0 2 1;
                0 0 0 2]
    @test J == inv(P) * M * P

    ρ, ϕ = symbols("rho, phi")
    X = [ρ*cos(ϕ), ρ*sin(ϕ), ρ^2]
    Y = [ρ, ϕ]
    @test X.jacobian(Y) ==   [cos(ϕ) -ρ*sin(ϕ);
                              sin(ϕ)  ρ*cos(ϕ);
                                  2ρ       0]
    X = [ρ*cos(ϕ), ρ*sin(ϕ)]
    @test convert(Matrix{Sym}, X.jacobian(Y)) == [cos(ϕ) -ρ*sin(ϕ);
                                                  sin(ϕ)  ρ*cos(ϕ)]
    @test X.jacobian(Y) == view(X, :, :).jacobian(view(Y, :, :))

    ## Issue   #359
    if VERSION >= v"1.2"
        @syms a
        A1 = [a 1; 1 a]
        # The first six cases work
        @test isa(A1 + a*I, Matrix{<:Sym})
        @test isa(A1 - a*I, Matrix{<:Sym})
        @test isa(-A1 + a*I, Matrix{<:Sym})
        @test isa(-A1 - a*I, Matrix{<:Sym})
        @test isa(-a*I + A1, Matrix{<:Sym})
        @test isa(a*I + A1, Matrix{<:Sym})
        @test isa(a*I - A1, Matrix{<:Sym})
        @test isa(-a*I - A1, Matrix{<:Sym})

        A2 = [1 2; 2 1]
        @test isa(A2 + a*I, Matrix{<:Sym})
        @test isa(A2 - a*I, Matrix{<:Sym})
        @test isa(-A2 + a*I, Matrix{<:Sym})
        @test isa(-A2 - a*I, Matrix{<:Sym})
        @test isa(-a*I + A2, Matrix{<:Sym})
        @test isa(a*I + A2, Matrix{<:Sym})
        @test isa(a*I - A2, Matrix{<:Sym})
        @test isa(-a*I - A2, Matrix{<:Sym})

    end

    ## Issue #397 adjoint losing type
    A = ones(Sym, 1, 1)
    @test A * A' isa Matrix{<:Sym}

    # issue SymPyCore #77 adjoint of sparse losing type
    @syms x
    m = sparse([1],[1],[x], 2,2)
    @test eltype(m') <: Sym
    @test m + m' == m' + m

    # XXX No SymMatrix?
    # ## Issue 413 with matrix exponential; SymMatrix multiplication
    # @syms a
    # A,A1 = [1 0; 0 a], [1 1; a 2]
    # @test exp(A) == [exp(Sym(1)) 0; 0 exp(a)]
    # B,B1 = convert(SymMatrix,A), convert(SymMatrix,A1)
    # @test B*B1 == convert(SymMatrix, A*A1)

    ## Issue #462 missing pytypemapping
    U = sympy.Matrix(sympy.MatrixSymbol("U",2,2))
    @test U isa Matrix{<:Sym}

    ## Issue 495 with eigenvals
    a = Sym[-5 -6 3; 3 4 -3; 0 0 -2]
    ls = eigvals(a)
    @test ls == sort(ls)
    vs = eigvecs(a)
    for i ∈ 1:3
        λ, v = ls[i], vs[:,i]
        @test (a * v - λ * v == 0 *v)
    end


    @syms a[1:2,1:2]
    ls = eigvals(a)
    vs = eigvecs(a)
    @test simplify.(vs * Diagonal(ls) * inv(vs) -a) == 0*a

    # issue #41 with views
    A = zeros(symtype(), 2, 2)
    A[1,1] = 1
    @test A == [1 0; 0 0]
    A[2,:] .= 2
    @test A == [1 0; 2 2]
end

##################################################
## SymbolicObject types have field x::PyCall.PyObject

## Symbol class for controlling dispatch
abstract type SymbolicObject{T} <: Number end




# SymPy.symbols constructor
# must be implemented in SymPyPyCall or SymPyPythonCall
"""
    symbols(arg; kwargs...)

Construct symbolic values using `sympy.symbols`.
"""
symbols() = nothing

## --------------------------------------------------
## Sym Main type

"""
    Sym{T}

Main wrapper for symbolic Python objects.

This is useful for dispatching methods for generic functions. `Sym` is also used to make symbolic values, in particular numeric values can be made into symbolic values.
"""
struct Sym{T} <: SymbolicObject{T}
    o::T
end
Sym(s::SymbolicObject) = s
Sym(x::Symbol) = Sym(string(x))
Sym(xs::Symbol...) = Tuple(Sym.((string(x) for x in xs)))
Sym{T}(x::Sym{T}) where {T} = x
Sym(x::Rational{T}) where {T} = Sym(numerator(x))/Sym(denominator(x))
# containers
Sym(x::Tuple) = Tuple(Sym(xᵢ) for xᵢ ∈ x)
Sym(x::Vector) = Sym[Sym(xᵢ) for xᵢ ∈ x]
_pytype(::Sym{T}) where {T} = T

Base.convert(::Type{Nothing}, ::Sym{Nothing}) = nothing

Base.promote_rule(::Type{Sym}, ::Type{Sym{T}})  where {T} = Sym{T}
Base.promote_rule(::Type{Sym{T}}, ::Type{Sym})  where {T} = Sym{T}

Base.collect(s::Sym) = Sym.(collect(↓(s)))

## --------------------------------------------------

"""
    SymFunction

A type and constructor to create symbolic functions. Such objects can be used
for specifying differential equations. The macro [`@syms`](@ref) is also available for constructing `SymFunction`s (`@syms f()`)

## Examples:

```jldoctest symfunction
julia> using SymPyPythonCall

julia> @syms t, v(); # recommended way to create a symbolic function

julia> u = SymFunction("u") # alternate
u

julia> diff(v(t), t) |> show
Derivative(v(t), t)
```

## Extended help

For symbolic functions *not* wrapped in the `SymFunction` type, the `sympy.Function` constructor can be used, as can the [`symbols`](@ref) function to construct symbolic functions (`F=sympy.Function("F", real=true)`; `F = sympy.symbols("F", cls=sympy.Function, real=true)`).

```jldoctest symfunction
julia> @syms u(), v()::real, t
(u, v, t)

julia> sqrt(u(t)^2), sqrt(v(t)^2) # real values have different simplification rules
(sqrt(u(t)^2), Abs(v(t)))

```

Such functions are undefined functions in SymPy, and can be used symbolically, such as with taking derivatives:

```jldoctest symfunction
julia> @syms x y u()
(x, y, u)

julia> diff(u(x), x) |> show
Derivative(u(x), x)

julia> diff(u(x, y), x) |> show
Derivative(u(x, y), x)
```


Here is one way to find the second derivative of an inverse function to `f`, utilizing the `SymFunction` class and the convenience `Differential` function:

```jldoctest symfunction
julia> @syms f() f⁻¹() x;

julia> D = Differential(x) # ∂(f) is diff(f(x),x)
Differential(x)

julia> D² = D∘D
Differential(x) ∘ Differential(x)

julia> u1 = only(solve(D((f⁻¹∘f)(x))  ~ 1, D(f⁻¹)(f(x)))); show(u1)
1/Derivative(f(x), x)

julia> u2 = only(solve(D²((f⁻¹∘f)(x)) ~ 0, D²(f⁻¹)(f(x)))); show(u2)
-Derivative(f(x), (x, 2))*Derivative(f⁻¹(f(x)), f(x))/Derivative(f(x), x)^2

julia> u2(D(f⁻¹)(f(x)) => u1) |> show # f''/[f']^3
-Derivative(f(x), (x, 2))/Derivative(f(x), x)^3
```

"""
struct SymFunction{T} <: SymbolicObject{T}
    o::T
end
(F::SymFunction)(xs...) = ↑(↓(F)(↓(xs)...))

## --------------------------------------------------
## XXX resurect?
## Matrices
## We use this class for `ImmutableMatrices`
## Mutable matrices are mapped to `AbstractArray{Sym,N}`
## cf. matrix.jl
# """
#     SymMatrix

# Type to store a SymPy matrix, as created by `sympy.ImmutableMatrix`.

# These have 0-based indexing defined for them to match SymPy

# The traditional infix mathematical operations are defined, but no dot broadcasting.

# The `convert(Matrix{Sym}, M)` call is useful to covert to a Julia matrix

# """
# mutable struct SymMatrix{T} <: SymbolicObject{T}
#     o::T
# end

# Load this from external packages
using SymPyCore
using LinearAlgebra
using SpecialFunctions
using Test

path = @__DIR__
include(joinpath(path, "test-legacy.jl")) # need to clean these up!
include(joinpath(path, "test-core.jl"))
include(joinpath(path, "test-math.jl"))
include(joinpath(path, "test-matrix.jl"))
include(joinpath(path, "test-specialfuncs.jl"))
include(joinpath(path, "test-ode.jl"))
#include(joinpath(path, "test-lambdify.jl"))
#include(joinpath(path, "test-logical.jl"))
#include(joinpath(path, "test-permutations.jl"))
#include(joinpath(path, "test-physics.jl"))
#include(joinpath(path, "test-external-module.jl"))

# Recipe to hook into Latexify.jl's `latexify` function for `Sym`s.
# We do not use SymPy's `latex` function here since it behaves a bit different
# from Latexify.jl. Thus, we let Latexify.jl handle everything for the sake of
# consistency.
# For example, SymPy doesn't print a multiplication symbol by default while
# Latexify uses a `"\\cdot"` (unless the keyword argument `cdot=false` is set).

Latexify.@latexrecipe function _(x::Sym)
  return string(x)
end

using SpecialFunctions
using Test

@testset "SpecialFuns" begin
    @syms a, b, x, y
    @syms n, m, θ, ϕ
    @syms ν::integer



    @test airyai(Sym(0)) == 3^(Sym(1)/3)/(3*gamma(Sym(2)/3))
    @test airybi(Sym(0)) == 3^(Sym(5)/6)/(3*gamma(Sym(2)/3))


    # gamma, beta and related functions
    @test gamma(Sym(1)) == 1
    @test gamma(Sym(3)/2) == sqrt(PI)/2


    @test diff(polygamma(Sym(0), x), x) == polygamma(Sym(1), x)
    @test diff(polygamma(Sym(0), x), x, 2) == polygamma(Sym(2), x)


    @test diff(beta(x, y), x) == (polygamma(Sym(0), x) - polygamma(Sym(0), x + y)) * beta(x, y)
    @test diff(beta(x, y), y) == (polygamma(Sym(0), y) - polygamma(Sym(0), x + y)) * beta(x, y)


    # test numerical consistency with Julia functions
    @test N(gamma(Sym(4.1))) ≈ gamma(4.1)
    @test N(polygamma(Sym(2), Sym(3.2))) ≈ polygamma(2, 3.2)
    @test N(beta(Sym(1)+1im, Sym(1)+1im)) ≈ beta(1.0+1im, 1.0+1im)


    # Bessel-type functions
    @test diff(besselj(n, x), x) == (besselj(n - 1, x) - besselj(n + 1, x))/2
    @test besselj(n, x).rewrite("jn") == sqrt(2x/PI) * sympy.jn(n - 1//2, x)
    @test diff(bessely(n, x), x) == (bessely(n - 1, x) - bessely(n + 1, x))/2
    @test bessely(n, x).rewrite("yn") == sqrt(2x/PI)* sympy.yn(n - 1//2, x)
    @test diff(besseli(n, x), x) == (besseli(n - 1, x) + besseli(n + 1, x))/2
    @test diff(besselk(n, x), x) == -(besselk(n - 1, x) + besselk(n + 1, x))/2


    # test numerical consistency with Julia functions
    @test N(besselj(3.2, Sym(1.5))) ≈ besselj(3.2, 1.5)
    @test N(bessely(3.2, Sym(1.5))) ≈ bessely(3.2, 1.5)
    @test N(besseli(3.2, Sym(1.5))) ≈ besseli(3.2, 1.5)
    @test N(besselk(3.2, Sym(1.5))) ≈ besselk(3.2, 1.5)


end

@testset "SymPy not SpecialFunctions" begin
    @syms a, b, x, y
    @syms n, m, θ, ϕ
    @syms ν::integer

    # fresnels -- in SymPy not in Julia
    @test sympy.fresnels(Sym(0)) == 0
    @test sympy.fresnels(Sym(oo)) == Sym(1)/2
    @test diff(sympy.fresnels(x), x) == sin(PI*x^2/2)
    #@test evalf(fresnels(Sym(2)), 30) == Sym(parse(BigFloat, "0.343415678363698242195300815958"))
    @test  diff(sympy.fresnelc(x), x) == cos(PI*x^2/2)

    @test diff(sympy.hankel1(n, x), x) == sympy.hankel1(n - 1, x)/2 - sympy.hankel1(n + 1, x)/2
    @test diff(sympy.hankel2(n, x), x) == sympy.hankel2(n - 1, x)/2 - sympy.hankel2(n + 1, x)/2




    @test sympy.Ei(Sym(-1)) == sympy.Ei(exp(1im*PI))
    @test diff(sympy.Ei(x), x) == exp(x)/x
    @test diff(sympy.Si(x), x) == sin(x)/x
    @test diff(sympy.Ci(x), x) == cos(x)/x

    @test sympy.jacobi(0, a, b, x) == 1
    @test sympy.jacobi(1, a, b, x) == a/2 - b/2 + x*(a/2 + b/2 + 1)
    @test sympy.jacobi(n, 0, 0, x) == sympy.legendre(n, x)
    @test sympy.jacobi(n, a, b, -x) == (-1)^n*sympy.jacobi(n, b, a, x)
    @test adjoint(sympy.jacobi(n, a, b, x)) == sympy.jacobi(n, adjoint(a), adjoint(b), adjoint(x))


    @test sympy.gegenbauer(0, a, x) == 1
    @test sympy.gegenbauer(1, a, x) == 2a*x
    @test sympy.gegenbauer(2, a, x) == -a + x^2*(2a^2 + 2a)
    @test adjoint(sympy.gegenbauer(n, a, x)) == sympy.gegenbauer(n, adjoint(a), adjoint(x))
    @test diff(sympy.gegenbauer(n, a, x), x) == 2a*sympy.gegenbauer(n-1, a+1, x)


    @test sympy.chebyshevt(0, x) == 1
    @test sympy.chebyshevt(1, x) == x
    @test sympy.chebyshevt(2, x) == 2x^2-1


    @test sympy.chebyshevu(0, x) == 1
    @test sympy.chebyshevu(1, x) == 2x
    @test sympy.chebyshevu(2, x) == 4x^2 - 1
    @test sympy.chebyshevu(n, 0) == cos(π*n/2)
    @test sympy.chebyshevu(n, 1) == n + 1




    @test sympy.legendre(0, x) == 1
    @test sympy.legendre(1, x) == x
    @test sympy.legendre(2, x) == 3x^2/2 - 1//2
    @test sympy.legendre(n, x) == sympy.legendre(n, x)
    @test diff(sympy.legendre(n,x), x) == n*(x*sympy.legendre(n, x) - sympy.legendre(n - 1, x))/(x^2 - 1)


    @test sympy.assoc_legendre(0,0, x) == 1
    @test sympy.assoc_legendre(1,0, x) == x
    @test sympy.assoc_legendre(1,1, x) == -sqrt(-x^2 + 1)
    #@test sympy.assoc_legendre(n,m,x) == sympy.assoc_legendre(n, m, x)


    @test sympy.hermite(0, x) == 1
    @test sympy.hermite(1, x) == 2x
    @test sympy.hermite(2, x) == 4x^2 - 2
    @test sympy.hermite(n, x) == sympy.hermite(n, x)
    @test diff(sympy.hermite(n,x), x) == 2n*sympy.hermite(n - 1, x)
    @test sympy.hermite(n, -x) == (-1)^n*sympy.hermite(n, x)


    @test sympy.laguerre(0, x) == 1
    @test sympy.laguerre(1, x) == -x + 1
    @test sympy.laguerre(2, x) == x^2/2 - 2x + 1
    @test sympy.laguerre(3, x) == -x^3/6 + 3x^2/2 - 3x + 1
    @test diff(sympy.laguerre(n, x), x) == -sympy.assoc_laguerre(n - 1, 1, x)


    @test sympy.assoc_laguerre(0, a, x) == 1
    @test sympy.assoc_laguerre(1, a, x) == a - x + 1
    @test sympy.assoc_laguerre(2, a, x) == a^2/2 + 3a/2 + x^2/2 + x*(-a - 2) + 1
    @test sympy.assoc_laguerre(n, 0, x) == sympy.laguerre(n, x)
    @test diff(sympy.assoc_laguerre(n, a, x), x) == -sympy.assoc_laguerre(n - 1, a + 1, x)


    @test sympy.Ynm(n, m, θ, ϕ) == sympy.Ynm(n, m, θ, ϕ)
    @test sympy.Ynm(n, -m, θ, ϕ) == (-1)^m*exp(-2im*m*ϕ)*sympy.Ynm(n, m, θ, ϕ)
    @test sympy.Ynm(n, m, -θ, ϕ) == sympy.Ynm(n, m, θ, ϕ)
    @test sympy.Ynm(n, m, θ, -ϕ) == exp(-2im*m*ϕ)*sympy.Ynm(n, m, θ, ϕ)
    @test expand(simplify(sympy.Ynm(0, 0, θ, ϕ)), func=true) == 1/(2*sqrt(PI))

    @test sympy.Ynm_c(n, m, θ, ϕ) == adjoint(sympy.Ynm(n, m, θ, ϕ))


    @test sympy.expand_func(sympy.jn(0, x)) == sin(x)/x
    @test sympy.expand_func(sympy.jn(1, x)) == sin(x)/x^2 - cos(x)/x
    @test sympy.jn(ν, x).rewrite("besselj") == sqrt(2PI/x)*besselj(ν + Sym(1)/2, x)/2
    @test sympy.jn(ν, x).rewrite("bessely") == (-1)^ν*sqrt(2PI/x)*bessely(-ν - Sym(1)/2, x)/2
    u = N(sympy.jn(2, 5.2+0.3im).evalf(20))
    @test norm(real(u) - 0.099419756723640344491) <= 1e-15 && norm(imag(u) + 0.054525080242173562897) <= 1e-15


    @test sympy.expand_func(sympy.yn(0, x)) == -cos(x)/x
    @test sympy.expand_func(sympy.yn(1, x)) == -cos(x)/x^2-sin(x)/x
    @test sympy.yn(ν, x).rewrite("besselj") == (-1)^(ν + 1)*sqrt(2PI/x)*besselj(-ν - Sym(1)/2, x)/2
    @test sympy.yn(ν, x).rewrite("bessely") == sqrt(2PI/x)*bessely(ν + Sym(1)/2, x)/2
    @test N(sympy.yn(2, 5.2+0.3im)) ≈ 0.18525034196069722536 + 0.014895573969924817587im

    # Elliptic-type functions
    @test sympy.elliptic_k(Sym(0)) == PI/2
    @test N(sympy.elliptic_k(Sym(1.0 + im))) ≈ 1.50923695405127 + 0.625146415202697im

    @test N(sympy.elliptic_f(Sym(3.0 + im/2), Sym(1.0 + im))) ≈ 2.909449841483 + 1.74720545502474im

    @test sympy.elliptic_e(Sym(0)) == PI/2
    @test N(sympy.elliptic_e(Sym(2.0 - im))) ≈ 0.991052601328069 + 0.81879421395609im

    @test sympy.elliptic_pi(Sym(0), Sym(0)) == PI/2
    @test N(sympy.elliptic_pi(Sym(1.0 - im/3), Sym(2.0 + im))) ≈ 3.29136443417283 + 0.32555634906645im

    @test sympy.expand_func(x * sympy.hyper([1, 1], [2], -x)) == log(x + 1)



end

module SymPyCoreSymbolicUtilsExt

import SymbolicUtils
𝐓 = SymbolicUtils.BasicSymbolic

# setup some utilities
import SymPyCore
SymPyCore._issymbol(x::𝐓) = SymbolicUtils.issym(x)
SymPyCore._value(x::𝐓) = x
SymPyCore._makesymbol(::Type{<:𝐓}, 𝑥::Symbol) = SymbolicUtils.Sym{Number}(𝑥)

end

using SymPy
import PyCall
using Test

## Test of importing an external module using `pyimport_conda` and `import_from`.
## from issue #262

stats = PyCall.pyimport_conda("sympy.stats", "sympy")

# this brings in all functions into the session using introspection, specialized on a
# symbolic first argument
import_from(stats)


@testset "Test stats module" begin

    @vars mu z x
    @vars sigma positive=true
    X = stats.Normal("x", mu, sigma)

    # some operations:
    @test variance(X) == sigma^2
    @test E(X) == mu
    P(Gt(X,3)) ## or P(X ≫ 3)

    Z = stats.Normal("Z", 0, 1)  # needs `stats.` as "Z" is not symbolic,
    # could also do this:
    @vars Z
    Z = Normal(Z, 0, 1)
    @test E(Z) == 0
    @test variance(Z) == 1

    simplify(P(Gt(Z, 1)))

    @test 0.68 <= 1 - 2*N(P(Gt(Z, 1))) <= 0.69


    @vars Y
    @vars a b c
    Y = DiscreteUniform(Y, (a,b,c))
    density(Y).dict
    @test density(Y).dict[a] == 1//3

    # And density
    density(X)  #NormalDistribution(mu, sigma)
    density(X).pdf(z)  # need the `pdf` call here

end

using Test

@testset "Latexify" begin
  @syms α
  @test_nowarn SymPyCore.Latexify.latexify(- 3/(8*α) + 1/(8*α^2))
  @test  occursin("\\cdot", SymPyCore.Latexify.latexify(- 3/(8*α) + 1/(8*α^2), cdot=true))
  @test !occursin("\\cdot", SymPyCore.Latexify.latexify(- 3/(8*α) + 1/(8*α^2), cdot=false))
end

Calculus
==========

This section covers how to do basic calculus tasks such as derivatives,
integrals, limits, and series expansions in SymPy.  If you are not familiar
with the math of any part of this section, you may safely skip it.

```@setup Julia
using SymPyPythonCall
```


```@repl Julia
@syms x y z
```

----



```@raw html
<details><summary>Expand for Python example</summary>
```


```python
    >>> from sympy import *
    >>> x, y, z = symbols('x y z')
    >>> init_printing(use_unicode=True)
```

```@raw html
</details>
```
----


Derivatives
===========

To take derivatives, use the `diff` function.


```@repl Julia
diff(cos(x), x)
diff(exp(x^2), x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> diff(cos(x), x)
    -sin(x)
    >>> diff(exp(x**2), x)
         ⎛ 2⎞
         ⎝x ⎠
    2⋅x⋅ℯ
```

```@raw html
</details>
```
----


`diff` can take multiple derivatives at once.  To take multiple derivatives,
pass the variable as many times as you wish to differentiate, or pass a number
after the variable.  For example, both of the following find the third
derivative of ``x^4``.


```@repl Julia
diff(x^4, x, x, x)
diff(x^4, x, 3)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> diff(x**4, x, x, x)
    24⋅x
    >>> diff(x**4, x, 3)
    24⋅x
```

```@raw html
</details>
```
----


You can also take derivatives with respect to many variables at once.  Just
pass each derivative in order, using the same syntax as for single variable
derivatives.  For example, each of the following will compute

```math
\frac{\partial^7}{\partial x\partial y^2\partial z^4} e^{x y z}.
```


```@repl Julia
expr = exp(x*y*z)
diff(expr, x, y, y, z, z, z, z)
diff(expr, x, y, 2, z, 4)
diff(expr, x, y, y, z, 4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = exp(x*y*z)
    >>> diff(expr, x, y, y, z, z, z, z)
     3  2 ⎛ 3  3  3       2  2  2                ⎞  x⋅y⋅z
    x ⋅y ⋅⎝x ⋅y ⋅z  + 14⋅x ⋅y ⋅z  + 52⋅x⋅y⋅z + 48⎠⋅ℯ
    >>> diff(expr, x, y, 2, z, 4)
     3  2 ⎛ 3  3  3       2  2  2                ⎞  x⋅y⋅z
    x ⋅y ⋅⎝x ⋅y ⋅z  + 14⋅x ⋅y ⋅z  + 52⋅x⋅y⋅z + 48⎠⋅ℯ
    >>> diff(expr, x, y, y, z, 4)
     3  2 ⎛ 3  3  3       2  2  2                ⎞  x⋅y⋅z
    x ⋅y ⋅⎝x ⋅y ⋅z  + 14⋅x ⋅y ⋅z  + 52⋅x⋅y⋅z + 48⎠⋅ℯ
```

```@raw html
</details>
```
----


`diff` can also be called as a method.  The two ways of calling `diff` are
exactly the same, and are provided only for convenience.


```@repl Julia
expr.diff(x, y, y, z, 4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr.diff(x, y, y, z, 4)
     3  2 ⎛ 3  3  3       2  2  2                ⎞  x⋅y⋅z
    x ⋅y ⋅⎝x ⋅y ⋅z  + 14⋅x ⋅y ⋅z  + 52⋅x⋅y⋅z + 48⎠⋅ℯ
```

```@raw html
</details>
```
----



To create an unevaluated derivative, use the `Derivative` class.  It has the
same syntax as `diff`.

!!! tip "Julia differences"

    `Derivative` must be qualified by `sympy`, as it is not exposed by `SymPyCore`

```@repl Julia
deriv = sympy.Derivative(expr, x, y, y, z, 4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> deriv = Derivative(expr, x, y, y, z, 4)
    >>> deriv
         7
        ∂     ⎛ x⋅y⋅z⎞
    ──────────⎝ℯ     ⎠
      4   2
    ∂z  ∂y  ∂x
```

```@raw html
</details>
```
----


To evaluate an unevaluated derivative, use the `doit` method.


```@repl Julia
deriv.doit()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> deriv.doit()
     3  2 ⎛ 3  3  3       2  2  2                ⎞  x⋅y⋅z
    x ⋅y ⋅⎝x ⋅y ⋅z  + 14⋅x ⋅y ⋅z  + 52⋅x⋅y⋅z + 48⎠⋅ℯ
```

```@raw html
</details>
```
----


These unevaluated objects are useful for delaying the evaluation of the
derivative, or for printing purposes.  They are also used when SymPy does not
know how to compute the derivative of an expression (for example, if it
contains an undefined function, which are described in the [Solving Differential Equations](tutorial-dsolve) section).

Derivatives of unspecified order can be created using tuple `(x, n)` where
`n` is the order of the derivative with respect to `x`.


```@repl Julia
@syms m, n, a, b
expr = (a*x + b)^m
expr.diff((x,n))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> m, n, a, b = symbols('m n a b')
    >>> expr = (a*x + b)**m
    >>> expr.diff((x, n))
      n
     ∂ ⎛         m⎞
    ───⎝(a⋅x + b) ⎠
      n
    ∂x
```

```@raw html
</details>
```
----


Integrals
=========

To compute an integral, use the `integrate` function.  There are two kinds
of integrals, definite and indefinite.  To compute an indefinite integral,
that is, an antiderivative, or primitive, just pass the variable after the
expression.


```@repl Julia
integrate(cos(x), x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> integrate(cos(x), x)
    sin(x)
```

```@raw html
</details>
```
----


Note that SymPy does not include the constant of integration.  If you want it,
you can add one yourself, or rephrase your problem as a differential equation
and use `dsolve` to solve it, which does add the constant (see [tutorial-dsolve](tutorial-dsolve)).

!!! note "Quick Tip"

    ``\infty`` in SymPy is `oo` (that's the lowercase letter "oh" twice).  This
    is because `oo` looks like ``\infty``, and is easy to type.

To compute a definite integral, pass the argument `(integration_variable,
lower_limit, upper_limit)`.  For example, to compute

```math
\int_0^\infty e^{-x}\,dx,
```

we would do

```@repl Julia
integrate(exp(-x), (x, 0, oo))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> integrate(exp(-x), (x, 0, oo))
    1
```

```@raw html
</details>
```
----


As with indefinite integrals, you can pass multiple limit tuples to perform a
multiple integral.  For example, to compute

```math
\int_{-\infty}^{\infty}\int_{-\infty}^{\infty} e^{- x^{2} - y^{2}}\, dx\, dy,
```

do


```@repl Julia
integrate(exp(-x^2 - y^2), (x, -oo, oo), (y, -oo, oo))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> integrate(exp(-x**2 - y**2), (x, -oo, oo), (y, -oo, oo))
    π
```

```@raw html
</details>
```
----


If `integrate` is unable to compute an integral, it returns an unevaluated
`Integral` object.


```@repl Julia
expr = integrate(x^x, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = integrate(x**x, x)
    >>> print(expr)
    Integral(x**x, x)
    >>> expr
    ⌠
    ⎮  x
    ⎮ x  dx
    ⌡
```

```@raw html
</details>
```
----


As with `Derivative`, you can create an unevaluated integral using
`Integral`.  To later evaluate this integral, call `doit`.

!!! tip "Julia differences"

    `Integral` must be qualified as it not exposed by `SymPyCore`

```@repl Julia
expr = sympy.Integral(log(x)^2, x)
expr.doit()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = Integral(log(x)**2, x)
    >>> expr
    ⌠
    ⎮    2
    ⎮ log (x) dx
    ⌡
    >>> expr.doit()
             2
    x⋅log (x) - 2⋅x⋅log(x) + 2⋅x
```

```@raw html
</details>
```
----


`integrate` uses powerful algorithms that are always improving to compute
both definite and indefinite integrals, including heuristic pattern matching
type algorithms, a partial implementation of the [Risch algorithm](https://en.wikipedia.org/wiki/Risch_algorithm), and an algorithm using
[Meijer G-functions](https://en.wikipedia.org/wiki/Meijer_g-function) that is
useful for computing integrals in terms of special functions, especially
definite integrals.  Here is a sampling of some of the power of `integrate`.


```@repl Julia
integ = sympy.Integral((x^4 + x^2*exp(x) - x^2 - 2*x*exp(x) - 2*x - exp(x))*exp(x)/((x - 1)^2*(x + 1)^2*(exp(x) + 1)), x)
integ.doit()
integ = sympy.Integral(sin(x^2), x)
integ.doit()
integ = sympy.Integral(x^y*exp(-x), (x, 0, oo))
integ.doit()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> integ = Integral((x**4 + x**2*exp(x) - x**2 - 2*x*exp(x) - 2*x -
    ...     exp(x))*exp(x)/((x - 1)**2*(x + 1)**2*(exp(x) + 1)), x)
    >>> integ
    ⌠
    ⎮ ⎛ 4    2  x    2        x          x⎞  x
    ⎮ ⎝x  + x ⋅ℯ  - x  - 2⋅x⋅ℯ  - 2⋅x - ℯ ⎠⋅ℯ
    ⎮ ──────────────────────────────────────── dx
    ⎮               2        2 ⎛ x    ⎞
    ⎮        (x - 1) ⋅(x + 1) ⋅⎝ℯ  + 1⎠
    ⌡
    >>> integ.doit()
                     x
       ⎛ x    ⎞     ℯ
    log⎝ℯ  + 1⎠ + ──────
                   2
                  x  - 1

    >>> integ = Integral(sin(x**2), x)
    >>> integ
    ⌠
    ⎮    ⎛ 2⎞
    ⎮ sin⎝x ⎠ dx
    ⌡
    >>> integ.doit()
             ⎛√2⋅x⎞
    3⋅√2⋅√π⋅S⎜────⎟⋅Γ(3/4)
             ⎝ √π ⎠
    ──────────────────────
           8⋅Γ(7/4)

    >>> integ = Integral(x**y*exp(-x), (x, 0, oo))
    >>> integ
    ∞
    ⌠
    ⎮  y  -x
    ⎮ x ⋅ℯ   dx
    ⌡
    0
    >>> integ.doit()
    ⎧ Γ(y + 1)    for re(y) > -1
    ⎪
    ⎪∞
    ⎪⌠
    ⎨⎮  y  -x
    ⎪⎮ x ⋅ℯ   dx    otherwise
    ⎪⌡
    ⎪0
    ⎩
```

```@raw html
</details>
```
----


This last example returned a `Piecewise` expression because the integral
does not converge unless ``\Re(y) > 1.``

Limits
======

SymPy can compute symbolic limits with the `limit` function.  The syntax to compute

```math
\lim_{x\to x_0} f(x)
```

is `limit(f(x), x, x0)`.

!!! tip "Julia differences"

    We use `Pairs` notation `x => x0` to associate the variable and the limiting value

```@repl Julia
limit(sin(x)/x, x=>0)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> limit(sin(x)/x, x, 0)
    1
```

```@raw html
</details>
```
----


`limit` should be used instead of `subs` whenever the point of evaluation
is a singularity.  Even though SymPy has objects to represent ``\infty``, using
them for evaluation is not reliable because they do not keep track of things
like rate of growth.  Also, things like ``\infty - \infty`` and
``\frac{\infty}{\infty}`` return ``\mathrm{nan}`` (not-a-number).  For example


```@repl Julia
expr = x^2 / exp(x)
expr(x => oo)
limit(expr, x => oo)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = x**2/exp(x)
    >>> expr.subs(x, oo)
    nan
    >>> limit(expr, x, oo)
    0
```

```@raw html
</details>
```
----


Like `Derivative` and `Integral`, `limit` has an unevaluated
counterpart, `Limit`.  To evaluate it, use `doit`.

!!! tip "Julia differences"

    `Limit` must be qualified, as it is not exposed by `SymPyCore`. Also, the pair notation is
	not available.

```@repl Julia
expr = sympy.Limit((cos(x) - 1)/x, x, 0) # no => here
expr.doit()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = Limit((cos(x) - 1)/x, x, 0)
    >>> expr
         ⎛cos(x) - 1⎞
     lim ⎜──────────⎟
    x─→0⁺⎝    x     ⎠
    >>> expr.doit()
    0
```

```@raw html
</details>
```
----


To evaluate a limit at one side only, pass `'+'` or `'-'` as a fourth
argument to `limit`.  For example, to compute

```math
\lim_{x\to 0^+}\frac{1}{x},
```

do

!!! tip "Julia differences"

    The `limit` function in `SymPy` uses a keyword argument for `dir`.

```@repl Julia
limit(1/x, x=>0, dir="+")
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> limit(1/x, x, 0, '+')
    ∞
```

```@raw html
</details>
```
----


As opposed to


```@repl Julia
limit(1/x, x =>0, dir="-")
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> limit(1/x, x, 0, '-')
    -∞
```

```@raw html
</details>
```
----


Series Expansion
================

SymPy can compute asymptotic series expansions of functions around a point. To
compute the expansion of `f(x)` around the point `x = x_0` terms of order
`x^n`, use `f(x).series(x, x0, n)`.  `x0` and `n` can be omitted, in
which case the defaults `x0=0` and `n=6` will be used.

!!! tip "Julia differences"

    We may use `series` as a generic method, not an object method

```@repl Julia
expr = exp(sin(x))
series(expr, x, 0, 4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = exp(sin(x))
    >>> expr.series(x, 0, 4)
             2
            x     ⎛ 4⎞
    1 + x + ── + O⎝x ⎠
            2
```

```@raw html
</details>
```
----


The ``O\left(x^4\right)`` term at the end represents the Landau order term at
``x=0`` (not to be confused with big O notation used in computer science, which
generally represents the Landau order term at ``x`` where ``x \rightarrow \infty``).  It means that all
x terms with power greater than or equal to ``x^4`` are omitted.  Order terms
can be created and manipulated outside of `series`.  They automatically
absorb higher order terms.

!!! tip "Julia differences"

    `O` needs qualifying

```@repl Julia
 x + x^3 + x^6 + sympy.O(x^4)
 x * sympy.O(1)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x + x**3 + x**6 + O(x**4)
         3    ⎛ 4⎞
    x + x  + O⎝x ⎠
    >>> x*O(1)
    O(x)
```

```@raw html
</details>
```
----


If you do not want the order term, use the `removeO` method.


```@repl Julia
series(expr, x, 0, 4).removeO()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr.series(x, 0, 4).removeO()
     2
    x
    ── + x + 1
    2
```

```@raw html
</details>
```
----


The `O` notation supports arbitrary limit points (other than 0):


```@repl Julia
exp(x - 6).series(x, x0=6)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> exp(x - 6).series(x, x0=6)
                2          3          4          5
         (x - 6)    (x - 6)    (x - 6)    (x - 6)         ⎛       6       ⎞
    -5 + ──────── + ──────── + ──────── + ──────── + x + O⎝(x - 6) ; x → 6⎠
            2          6          24        120
```

```@raw html
</details>
```
----



Finite differences
==================

So far we have looked at expressions with analytic derivatives
and primitive functions respectively. But what if we want to have an
expression to estimate a derivative of a curve for which we lack a
closed form representation, or for which we don't know the functional
values for yet. One approach would be to use a finite difference
approach.

The simplest way the differentiate using finite differences is to use
the `differentiate_finite` function:

!!! tip "Julia differences"

    The `differentiate_finite` function needs qualifying.

```@repl Julia
@syms f(), g()
sympy.differentiate_finite(f(x)*g(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f, g = symbols('f g', cls=Function)
    >>> differentiate_finite(f(x)*g(x))
    -f(x - 1/2)⋅g(x - 1/2) + f(x + 1/2)⋅g(x + 1/2)
```

```@raw html
</details>
```
----


If you already have a `Derivative` instance, you can use the
`as_finite_difference` method to generate approximations of the
derivative to arbitrary order:


```@repl Julia
@syms f()
dfdx = f(x).diff(x)
dfdx.as_finite_difference()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f = Function('f')
    >>> dfdx = f(x).diff(x)
    >>> dfdx.as_finite_difference()
    -f(x - 1/2) + f(x + 1/2)
```

```@raw html
</details>
```
----


here the first order derivative was approximated around x using a
minimum number of points (2 for 1st order derivative) evaluated
equidistantly using a step-size of 1. We can use arbitrary steps
(possibly containing symbolic expressions):


```@repl Julia
@syms f()
d2fdx2 = f(x).diff(x, 2)
@syms h
d2fdx2.as_finite_difference([-3*h,-h,2*h])
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f = Function('f')
    >>> d2fdx2 = f(x).diff(x, 2)
    >>> h = Symbol('h')
    >>> d2fdx2.as_finite_difference([-3*h,-h,2*h])
    f(-3⋅h)   f(-h)   2⋅f(2⋅h)
    ─────── - ───── + ────────
         2        2        2
      5⋅h      3⋅h     15⋅h
```

```@raw html
</details>
```
----


If you are just interested in evaluating the weights, you can do so
manually:

!!! tip "Julia differences"

    This function needs qualifying. The indexing is different from Python
	for the array `arr`, as there is no `-1`, rather we use `Julia`'s `end`.

```@repl Julia
arr = sympy.finite_diff_weights(2, [-3, -1, 2], 0)
arr[end][end]
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> finite_diff_weights(2, [-3, -1, 2], 0)[-1][-1]
    [1/5, -1/3, 2/15]
```

```@raw html
</details>
```
----


note that we only need the last element in the last sublist
returned from `finite_diff_weights`. The reason for this is that
the function also generates weights for lower derivatives and
using fewer points (see the documentation of `finite_diff_weights`
for more details).

If using `finite_diff_weights` directly looks complicated, and the
`as_finite_difference` method of `Derivative` instances
is not flexible enough, you can use `apply_finite_diff` which
takes `order`, `x_list`, `y_list` and `x0` as parameters:

!!! tip "Julia differences"

    The `apply_finite_diff` function needs qualifying. The `y_list` construction below would be easier with numbered variables, as with `y_list = @syms y[1:3]`.

```@repl Julia
x_list = [-3, 1, 2]
@syms a b c
y_list = [a, b, c]
sympy.apply_finite_diff(1, x_list, y_list, 0)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x_list = [-3, 1, 2]
    >>> ylist = symbols("a b c")
    >>> apply_finite_diff(1, x_list, y_list, 0)
      3⋅a   b   2⋅c
    - ─── - ─ + ───
       20   4    5
```

```@raw html
</details>
```

Printing
==========

!!! tip "Julia differences"

    The default `show` method in `Julia` uses text-based `sstr` for printing. The `show` method for ``\LaTeX`` is different, utilizing the `latex` command described herein. There isn't much at all provided within `SymPyCore`

[Sympy printing](https://docs.sympy.org/latest/tutorials/intro-tutorial/printing.html_

Introduction
==============

```@setup Julia
using SymPyPythonCall
```


What is Symbolic Computation?
=============================

Symbolic computation deals with the computation of mathematical objects
symbolically.  This means that the mathematical objects are represented
exactly, not approximately, and mathematical expressions with unevaluated
variables are left in symbolic form.

Let's take an example. Say we wanted to use the built-in Python functions to
compute square roots. We might do something like this

!!! tip "Julia differences"

    Julis has `sqrt` in base

```@repl Julia
sqrt(9)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> import math
   >>> math.sqrt(9)
   3.0
```
```@raw html
</details>
```
----


9 is a perfect square, so we got the exact answer, 3. But suppose we computed
the square root of a number that isn't a perfect square


```@repl Julia
sqrt(8)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> math.sqrt(8)
   2.82842712475
```
```@raw html
</details>
```
----


Here we got an approximate result. 2.82842712475 is not the exact square root
of 8 (indeed, the actual square root of 8 cannot be represented by a finite
decimal, since it is an irrational number).  If all we cared about was the
decimal form of the square root of 8, we would be done.

But suppose we want to go further. Recall that `\sqrt{8} = \sqrt{4\cdot 2} =
2\sqrt{2}`.  We would have a hard time deducing this from the above result.
This is where symbolic computation comes in.  With a symbolic computation
system like SymPy, square roots of numbers that are not perfect squares are
left unevaluated by default

!!! tip "Julia differences"

    We see two ways to do this, call the `sqrt` function from `sympy` *or* use the overloaded `sqrt` function for symbolic objects. The latter is more idiomatic.

```@repl Julia
sympy.sqrt(3), sqrt(Sym(3))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> import sympy
   >>> sympy.sqrt(3)
   sqrt(3)
```
```@raw html
</details>
```
----


Furthermore---and this is where we start to see the real power of symbolic
computation---symbolic results can be symbolically simplified.

```@repl Julia
sqrt(Sym(8))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> sympy.sqrt(8)
   2*sqrt(2)
```
```@raw html
</details>
```
----


A More Interesting Example
==========================

The above example starts to show how we can manipulate irrational numbers
exactly using SymPy.  But it is much more powerful than that.  Symbolic
computation systems (which by the way, are also often called computer algebra
systems, or just CASs) such as SymPy are capable of computing symbolic
expressions with variables.

As we will see later, in SymPy, variables are defined using `symbols`.
Unlike many symbolic manipulation systems, variables in SymPy must be defined
before they are used (the reason for this will be discussed in the next section]).

Let us define a symbolic expression, representing the mathematical expression
`x + 2y`.

!!! tip "Julia differences"

    While `symbols` may be used in the same manner as the `Python` code, the use of the `@syms` macro is used in this translation of the tutorial to `Julia`.

```@repl Julia
@syms x, y
expr = x + 2y

```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> from sympy import symbols
   >>> x, y = symbols('x y')
   >>> expr = x + 2*y
   >>> expr
   x + 2*y
```
```@raw html
</details>
```
----


Note that we wrote `x + 2*y` just as we would if `x` and `y` were
ordinary Python variables. But in this case, instead of evaluating to
something, the expression remains as just `x + 2*y`.  Now let us play around
with it:


```@repl Julia
expr + 1
expr - x
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> expr + 1
   x + 2*y + 1
   >>> expr - x
   2*y
```
```@raw html
</details>
```
----


Notice something in the above example.  When we typed `expr - x`, we did not
get `x + 2*y - x`, but rather just `2*y`.  The `x` and the `-x`
automatically canceled one another.  This is similar to how `sqrt(8)`
automatically turned into `2*sqrt(2)` above.  This isn't always the case in
SymPy, however:


```@repl Julia
x * expr
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> x*expr
   x*(x + 2*y)
```
```@raw html
</details>
```
----


Here, we might have expected `x(x + 2y)` to transform into `x^2 + 2xy`, but
instead we see that the expression was left alone.  This is a common theme in
SymPy.  Aside from obvious simplifications like `x - x = 0` and `\sqrt{8} =
2\sqrt{2}`, most simplifications are not performed automatically.  This is
because we might prefer the factored form `x(x + 2y)`, or we might prefer the
expanded form `x^2 + 2xy`.  Both forms are useful in different circumstances.
In SymPy, there are functions to go from one form to the other

!!! tip "Julia differences"

    The `expand` and `factor` functions of SymPy are wrapped and exported. For non-exported functions from SymPy, the `sympy` module can be utilized.

```@repl Julia
expanded_expr = expand(x * expr)
factor(expanded_expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> from sympy import expand, factor
   >>> expanded_expr = expand(x*expr)
   >>> expanded_expr
   x**2 + 2*x*y
   >>> factor(expanded_expr)
   x*(x + 2*y)
```
```@raw html
</details>
```
----


The Power of Symbolic Computation
=================================

The real power of a symbolic computation system such as SymPy is the ability
to do all sorts of computations symbolically.  SymPy can simplify expressions,
compute derivatives, integrals, and limits, solve equations, work with
matrices, and much, much more, and do it all symbolically.  It includes
modules for plotting, printing (like 2D pretty printed output of math
formulas, or ``\mathrm{\LaTeX}``), code generation, physics, statistics, combinatorics,
number theory, geometry, logic, and more. Here is a small sampling of the sort
of symbolic power SymPy is capable of, to whet your appetite.

```@repl Julia
@syms x, t, z, nu
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> from sympy import *
 >>> x, t, z, nu = symbols('x t z nu')
```
```@raw html
</details>
```
----


This will make all further examples pretty print with unicode characters.

!!! tip "Julia differences"

    The ASCII pretty printing is used by `show` by default

```@repl Julia
nothing
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> init_printing(use_unicode=True)
```
```@raw html
</details>
```
----


Take the derivative of `\sin{(x)}e^x`.


```@repl Julia
diff(sin(x) * exp(x), x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> diff(sin(x)*exp(x), x)
  x           x
 ℯ ⋅sin(x) + ℯ ⋅cos(x)
```
```@raw html
</details>
```
----


Compute `\int(e^x\sin{(x)} + e^x\cos{(x)})\,dx`.


```@repl Julia
integrate(exp(x)*sin(x) + exp(x)*cos(x), x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> integrate(exp(x)*sin(x) + exp(x)*cos(x), x)
  x
 ℯ ⋅sin(x)
```
```@raw html
</details>
```
----


Compute ``\int_{-\infty}^\infty \sin{(x^2)}\,dx``.

!!! tip "Julia differences"

    The `oo` variable is exposed (along with `PI`, `E`, `IM`, `zoo`)

```@repl Julia
integrate(sin(x^2), (x, -oo, oo))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> integrate(sin(x**2), (x, -oo, oo))
 √2⋅√π
 ─────
   2
```
```@raw html
</details>
```
----


Find ``\lim_{x\to 0}\frac{\sin{(x)}}{x}``.

!!! tip "Julia differences"

    The `limit` function is wrapped and exported. The wrapping is given an interface which accepts a pair

```@repl Julia
limit(sin(x)/x, x => 0)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> limit(sin(x)/x, x, 0)
 1
```
```@raw html
</details>
```
----


Solve ``x^2 - 2 = 0``.

!!! tip "Julia differences"

    The `solve` function is wrapped and exported, as it and `solveset` are workhorses.


```@repl Julia
solve(x^2 - x, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> solve(x**2 - 2, x)
 [-√2, √2]
```
```@raw html
</details>
```
----


Solve the differential equation ``y'' - y = e^t``.

!!! tip "Julia differences"

    In `Julia`, following the `Symbolics.jl` interface, We provide a the `Differential` function. It cleans up the calls to `diff` a bit, though using `diff` is an option.

```@repl Julia
@syms t, y()
D = Differential(t)
D² = D∘D
dsolve(D²(y(t)) - y(t) ~ exp(t), y(t))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> y = Function('y')
 >>> dsolve(Eq(y(t).diff(t, t) - y(t), exp(t)), y(t))
            -t   ⎛     t⎞  t
 y(t) = C₂⋅ℯ   + ⎜C₁ + ─⎟⋅ℯ
                 ⎝     2⎠
```
```@raw html
</details>
```
----


Find the eigenvalues of
``\left[\begin{smallmatrix}1 & 2\\2 &2\end{smallmatrix}\right]``.

!!! tip "Julia differences"

    The package extends some generic function from the `LinearAlgebra` package

```@repl Julia
using LinearAlgebra
M = Sym[1 2; 2 2]
eigvals(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
 >>> Matrix([[1, 2], [2, 2]]).eigenvals()
 ⎧3   √17     3   √17   ⎫
 ⎨─ - ───: 1, ─ + ───: 1⎬
 ⎩2    2      2    2    ⎭
```
```@raw html
</details>
```
----


Rewrite the Bessel function ``J_{\nu}\left(z\right)`` in terms of the
spherical Bessel function ``j_\nu(z)``.

!!! tip "Julia differences"

    The package extends some generic function from the `SpecialFunctions` package. Special functions defined in `sympy` but not `SpecialFunctions`, such as several orthogonal polynomial related function can be qualified using the `sympy` module.

```@repl Julia
using SpecialFunctions
besselj(nu, z).rewrite("jn")
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
  >>> besselj(nu, z).rewrite(jn)
  √2⋅√z⋅jn(ν - 1/2, z)
  ────────────────────
           √π
```
```@raw html
</details>
```
----


Print ``\int_{0}^{\pi} \cos^{2}{\left (x \right )}\, dx`` using ``\mathrm{\LaTeX}``.

!!! tip "Julia differences"

    The `Latexify` package has a recipe for producing ``\LaTeX`` output. The `Integral` function below constructs an integral, but does not evaluate it. Either use `integrate` or the method `doit` to evaluate the integral.

```@repl Julia
using Latexify
out = sympy.Integral(cos(x)^2, (x, 0, PI))
latexify(out)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
  >>> latex(Integral(cos(x)**2, (x, 0, pi)))
  \int\limits_{0}^{\pi} \cos^{2}{\left(x \right)}\, dx
```
```@raw html
</details>
```
----


Why SymPy?
==========

There are many computer algebra systems out there.  [This](https://en.wikipedia.org/wiki/List_of_computer_algebra_systems) Wikipedia
article lists many of them.  What makes SymPy a better choice than the
alternatives?

First off, SymPy is completely free. It is open source, and licensed under the
liberal BSD license, so you can modify the source code and even sell it if you
want to.  This contrasts with popular commercial systems like Maple or
Mathematica that cost hundreds of dollars in licenses.

Second, SymPy uses Python.  Most computer algebra systems invent their own
language. Not SymPy. SymPy is written entirely in Python, and is executed
entirely in Python. This means that if you already know Python, it is much
easier to get started with SymPy, because you already know the syntax (and if
you don't know Python, it is really easy to learn).  We already know that
Python is a well-designed, battle-tested language.  The SymPy developers are
confident in their abilities in writing mathematical software, but programming
language design is a completely different thing.  By reusing an existing
language, we are able to focus on those things that matter: the mathematics.

Another computer algebra system, Sage also uses Python as its language.  But
Sage is large, with a download of over a gigabyte.  An advantage of SymPy is
that it is lightweight.  In addition to being relatively small, it has no
dependencies other than Python, so it can be used almost anywhere easily.
Furthermore, the goals of Sage and the goals of SymPy are different.  Sage
aims to be a full featured system for mathematics, and aims to do so by
compiling all the major open source mathematical systems together into
one. When you call some function in Sage, such as `integrate`, it calls out
to one of the open source packages that it includes.  In fact, SymPy is
included in Sage.  SymPy on the other hand aims to be an independent system,
with all the features implemented in SymPy itself.

A final important feature of SymPy is that it can be used as a library. Many
computer algebra systems focus on being usable in interactive environments, but
if you wish to automate or extend them, it is difficult to do.  With SymPy,
you can just as easily use it in an interactive Python environment or import
it in your own Python application.  SymPy also provides APIs to make it easy
to extend it with your own custom functions.


!!! tip "Julia differences"

    In `Juila` there are a few other choices for symbolic math, primarily `Symbolics.jl`, `SymEngine.jl`. `Symbolics.jl` is a `Julia` only solution. It is performant and widely used within the suite of `SciML` packages. The `SymEngine` package is much more limited in features, but extremely fast. Using SymPy may be slower, but the library has many more features available.

Simplification
================

```@setup Julia
using SymPyPythonCall
```

To make this document easier to read, we are going to enable pretty printing.

!!! tip "Julia differences"

    Pretty printing is the default output.

```@repl Julia
@syms x, y, z
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import *
    >>> x, y, z = symbols('x y z')
    >>> init_printing(use_unicode=True)
```
```@raw html
</details>
```
----


`simplify`
============

Now let's jump in and do some interesting mathematics.  One of the most useful
features of a symbolic manipulation system is the ability to simplify
mathematical expressions.  SymPy has dozens of functions to perform various
kinds of simplification.  There is also one general function called
`simplify()` that attempts to apply all of these functions in an intelligent
way to arrive at the simplest form of an expression.  Here are some examples

!!! tip "Julia differences"

    The `SpecialFunctions` package is loaded, so the method for `gamma` is available.


```@repl Julia
using SpecialFunctions

simplify(sin(x)^2 + cos(x)^2)
simplify( (x^3 + x^2 - x - 1) / (x^2 + 2x + 1) )
simplify( gamma(x) / gamma(x-2) )
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> simplify(sin(x)**2 + cos(x)**2)
    1
    >>> simplify((x**3 + x**2 - x - 1)/(x**2 + 2*x + 1))
    x - 1
    >>> simplify(gamma(x)/gamma(x - 2))
    (x - 2)⋅(x - 1)
```
```@raw html
</details>
```
----


Here, `gamma(x)` is ``\Gamma(x)``, the [gamma function](https://en.wikipedia.org/wiki/Gamma_function).
We see that `simplify()`
is capable of handling a large class of expressions.

But `simplify()` has a pitfall.  It just applies all the major
simplification operations in SymPy, and uses heuristics to determine the
simplest result. But "simplest" is not a well-defined term.  For example, say
we wanted to "simplify" `x^2 + 2x + 1` into `(x + 1)^2`:


```@repl Julia
simplify(x^2 + 2*x + 1)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> simplify(x**2 + 2*x + 1)
     2
    x  + 2⋅x + 1
```
```@raw html
</details>
```
----


We did not get what we want.  There is a function to perform this
simplification, called `factor()`, which will be discussed below.

Another pitfall to `simplify()` is that it can be unnecessarily slow, since
it tries many kinds of simplifications before picking the best one.  If you
already know exactly what kind of simplification you are after, it is better
to apply the specific simplification function(s) that apply those
simplifications.

Applying specific simplification functions instead of `simplify()` also has
the advantage that specific functions have certain guarantees about the form
of their output.  These will be discussed with each function below.  For
example, `factor()`, when called on a polynomial with rational coefficients,
is guaranteed to factor the polynomial into irreducible factors.
`simplify()` has no guarantees.  It is entirely heuristical, and, as we saw
above, it may even miss a possible type of simplification that SymPy is
capable of doing.

`simplify()` is best when used interactively, when you just want to whittle
down an expression to a simpler form.  You may then choose to apply specific
functions once you see what `simplify()` returns, to get a more precise
result.  It is also useful when you have no idea what form an expression will
take, and you need a catchall function to simplify it.

Polynomial/Rational Function Simplification
===========================================

expand
------

`expand()` is one of the most common simplification functions in SymPy.
Although it has a lot of scopes, for now, we will consider its function in
expanding polynomial expressions. For example:


```@repl Julia
expand( (x+1)^2 )
expand( (x+2) * (x-3) )
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand((x + 1)**2)
     2
    x  + 2⋅x + 1
    >>> expand((x + 2)*(x - 3))
     2
    x  - x - 6
```
```@raw html
</details>
```
----


Given a polynomial, `expand()` will put it into a canonical form of a sum of
monomials.

`expand()` may not sound like a simplification function.  After all, by its
very name, it makes expressions bigger, not smaller.  Usually this is the
case, but often an expression will become smaller upon calling `expand()` on
it due to cancellation.



```@repl Julia
expand((x + 1)*(x - 2) - (x - 1)*x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand((x + 1)*(x - 2) - (x - 1)*x)
    -2
```
```@raw html
</details>
```
----


factor
------

`factor()` takes a polynomial and factors it into irreducible factors over
the rational numbers.  For example:


```@repl Julia
factor(x^3 - x^2 + x - 1)
factor(x^2*z + 4*x*y*z + 4*y^2*z)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> factor(x**3 - x**2 + x - 1)
            ⎛ 2    ⎞
    (x - 1)⋅⎝x  + 1⎠
    >>> factor(x**2*z + 4*x*y*z + 4*y**2*z)
               2
    z⋅(x + 2⋅y)
```
```@raw html
</details>
```
----


For polynomials, `factor()` is the opposite of `expand()`.  `factor()`
uses a complete multivariate factorization algorithm over the rational
numbers, which means that each of the factors returned by `factor()` is
guaranteed to be irreducible.

If you are interested in the factors themselves, `factor_list` returns a
more structured output.

!!! tip "Julia differences"

    The `factor_list` function must be qualified

```@repl Julia
c, fs = sympy.factor_list(x^2*z + 4*x*y*z + 4*y^2*z);
c  # constant
fs # factors (fac, mult)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> factor_list(x**2*z + 4*x*y*z + 4*y**2*z)
    (1, [(z, 1), (x + 2⋅y, 2)])
```
```@raw html
</details>
```
----


Note that the input to `factor` and `expand` need not be polynomials in
the strict sense.  They will intelligently factor or expand any kind of
expression (though note that the factors may not be irreducible if the input
is no longer a polynomial over the rationals).


```@repl Julia
expand((cos(x) + sin(x))^2)
expand((cos(x) + sin(x))^2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand((cos(x) + sin(x))**2)
       2                           2
    sin (x) + 2⋅sin(x)⋅cos(x) + cos (x)
    >>>  expand((cos(x) + sin(x))**2)
                     2
    (sin(x) + cos(x))
```
```@raw html
</details>
```
----


collect
-------

`collect()` collects common powers of a term in an expression.  For example

!!! tip "Julia differences"

    As the `collect` function of `SymPy` does not match the generic meaning of `collect` from Base `Julia`, it must be qualified.

```@repl Julia
expr = x*y + x - 3 + 2*x^2 - z*x^2 + x^3
collected_expr = sympy.collect(expr, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = x*y + x - 3 + 2*x**2 - z*x**2 + x**3
    >>> expr
     3    2        2
    x  - x ⋅z + 2⋅x  + x⋅y + x - 3
    >>> collected_expr = collect(expr, x)
    >>> collected_expr
     3    2
    x  + x ⋅(2 - z) + x⋅(y + 1) - 3
```
```@raw html
</details>
```
----


`collect()` is particularly useful in conjunction with the `.coeff()`
method.  `expr.coeff(x, n)` gives the coefficient of `x**n` in `expr`:


```@repl Julia
collected_expr.coeff(x, 2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> collected_expr.coeff(x, 2)
    2 - z
```
```@raw html
</details>
```
----


!!! note "TODO"
    Discuss coeff method in more detail in some other section (maybe
    basic expression manipulation tools)

cancel
------

`cancel()` will take any rational function and put it into the standard
canonical form, ``\frac{p}{q}``, where `p` and `q` are expanded polynomials with
no common factors, and the leading coefficients of `p` and `q` do not have
denominators (i.e., are integers).

```@repl Julia
cancel((x^2 + 2*x + 1)/(x^2 + x))
expr = 1/x + (3*x/2 - 2)/(x - 4)
cancel(expr)
expr = (x*y^2 - 2*x*y*z + x*z^2 + y^2 - 2*y*z + z^2)/(x^2 - 1)
cancel(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> cancel((x**2 + 2*x + 1)/(x**2 + x))
    x + 1
    ─────
      x

    >>> expr = 1/x + (3*x/2 - 2)/(x - 4)
    >>> expr
    3⋅x
    ─── - 2
     2        1
    ─────── + ─
     x - 4    x
    >>> cancel(expr)
       2
    3⋅x  - 2⋅x - 8
    ──────────────
         2
      2⋅x  - 8⋅x

    >>> expr = (x*y**2 - 2*x*y*z + x*z**2 + y**2 - 2*y*z + z**2)/(x**2 - 1)
    >>> expr
       2                2    2            2
    x⋅y  - 2⋅x⋅y⋅z + x⋅z  + y  - 2⋅y⋅z + z
    ───────────────────────────────────────
                      2
                     x  - 1
    >>> cancel(expr)
     2            2
    y  - 2⋅y⋅z + z
    ───────────────
         x - 1
```
```@raw html
</details>
```
----


Note that since `factor()` will completely factorize both the numerator and
the denominator of an expression, it can also be used to do the same thing:


```@repl Julia
factor(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> factor(expr)
           2
    (y - z)
    ────────
     x - 1
```
```@raw html
</details>
```
----


However, if you are only interested in making sure that the expression is in
canceled form, `cancel()` is more efficient than `factor()`.

apart
-----

`apart()` performs a [partial fraction decomposition](https://en.wikipedia.org/wiki/Partial_fraction_decomposition) on a rational
function.

```@repl Julia
expr = (4*x^3 + 21*x^2 + 10*x + 12)/(x^4 + 5*x^3 + 5*x^2 + 4*x)
apart(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = (4*x**3 + 21*x**2 + 10*x + 12)/(x**4 + 5*x**3 + 5*x**2 + 4*x)
    >>> expr
       3       2
    4⋅x  + 21⋅x  + 10⋅x + 12
    ────────────────────────
      4      3      2
     x  + 5⋅x  + 5⋅x  + 4⋅x
    >>> apart(expr)
     2⋅x - 1       1     3
    ────────── - ───── + ─
     2           x + 4   x
    x  + x + 1
```
```@raw html
</details>
```
----


Trigonometric Simplification
============================

!!! note

    SymPy follows Python's naming conventions for inverse trigonometric
    functions, which is to append an `a` to the front of the function's
    name.  For example, the inverse cosine, or arc cosine, is called `acos()`.

!!! tip "Julia differences"

    The SymPy convention is the same as within `Julia`

```@repl Julia
acos(x)
cos(acos(x))
asin(Sym(1))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> acos(x)
    acos(x)
    >>> cos(acos(x))
    x
    >>> asin(1)
    π
    ─
    2
```
```@raw html
</details>
```
----


!!! note "TODO"
    Can we actually do anything with inverse trig functions,
    simplification wise?

trigsimp
--------

To simplify expressions using trigonometric identities, use `trigsimp()`.

!!! tip "Julia differences"

    The `trigsimp` function needs qualification

```@repl Julia
sympy.trigsimp(sin(x)^2 + cos(x)^2)
sympy.trigsimp(sin(x)^4 - 2*cos(x)^2*sin(x)^2 + cos(x)^4)
sympy.trigsimp(sin(x)*tan(x)/sec(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> trigsimp(sin(x)**2 + cos(x)**2)
    1
    >>> trigsimp(sin(x)**4 - 2*cos(x)**2*sin(x)**2 + cos(x)**4)
    cos(4⋅x)   1
    ──────── + ─
       2       2
    >>> trigsimp(sin(x)*tan(x)/sec(x))
       2
    sin (x)
```
```@raw html
</details>
```
----


`trigsimp()` also works with hyperbolic trig functions.


```@repl Julia
sympy.trigsimp(cosh(x)^2 + sinh(x)^2)
sympy.trigsimp(sinh(x)/tanh(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> trigsimp(cosh(x)**2 + sinh(x)**2)
    cosh(2⋅x)
    >>> trigsimp(sinh(x)/tanh(x))
    cosh(x)
```
```@raw html
</details>
```
----


Much like `simplify()`, `trigsimp()` applies various trigonometric identities to
the input expression, and then uses a heuristic to return the "best" one.

expand_trig
-----------

To expand trigonometric functions, that is, apply the sum or double angle
identities, use `expand_trig()`.

!!! tip "Julia differences"

    The `expand_trig` function must be qualified

```@repl Julia
sympy.expand_trig(sin(x + y))
sympy.expand_trig(tan(2*x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_trig(sin(x + y))
    sin(x)⋅cos(y) + sin(y)⋅cos(x)
    >>> expand_trig(tan(2*x))
      2⋅tan(x)
    ───────────
           2
    1 - tan (x)
```
```@raw html
</details>
```
----


Because `expand_trig()` tends to make trigonometric expressions larger, and
`trigsimp()` tends to make them smaller, these identities can be applied in
reverse using `trigsimp()`


```@repl Julia
sympy.trigsimp(sin(x)*cos(y) + sin(y)*cos(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> trigsimp(sin(x)*cos(y) + sin(y)*cos(x))
    sin(x + y)
```
```@raw html
</details>
```
----


!!! note "TODO"
    It would be much better to teach individual trig rewriting functions
    here, but they don't exist yet.  See
    https://github.com/sympy/sympy/issues/3456.

Powers
======

Before we introduce the power simplification functions, a mathematical
discussion on the identities held by powers is in order.  There are three
kinds of identities satisfied by exponents

1. ``x^ax^b = x^{a + b}``
2. ``x^ay^a = (xy)^a``
3. ``(x^a)^b = x^{ab}``

Identity 1 is always true.

Identity 2 is not always true.  For example, if ``x = y = -1`` and ``a =
\frac{1}{2}``, then ``x^ay^a = \sqrt{-1}\sqrt{-1} = i\cdot i = -1``, whereas
``(xy)^a = \sqrt{-1\cdot-1} = \sqrt{1} = 1``.  However, identity 2 is true at
least if ``x`` and ``y`` are nonnegative and ``a`` is real (it may also be true
under other conditions as well).  A common consequence of the failure of
identity 2 is that ``\sqrt{x}\sqrt{y} \neq \sqrt{xy}``.

Identity 3 is not always true.  For example, if ``x = -1``, ``a = 2``, and ``b =
\frac{1}{2}``, then ``(x^a)^b = {\left((-1)^2\right)}^{1/2} = \sqrt{1} = 1``
and ``x^{ab} = (-1)^{2\cdot1/2} = (-1)^1 = -1``.  However, identity 3 is true
when ``b`` is an integer (again, it may also hold in other cases as well).  Two
common consequences of the failure of identity 3 are that ``\sqrt{x^2}\neq x``
and that ``\sqrt{\frac{1}{x}} \neq \frac{1}{\sqrt{x}}``.

To summarize

|Identity               |Sufficient conditions to hold       |Counterexample when conditions are not met          |Important consequences                                                       |
|:----------------------|:-----------------------------------|:---------------------------------------------------|:----------------------------------------------------------------------------|
|1. ``x^ax^b = x^{a + b}``|Always true                         |None                                                |None                                                                         |
|2. ``x^ay^a = (xy)^a``   |``x, y \geq 0`` and ``a \in \mathbb{R}``|``(-1)^{1/2}(-1)^{1/2} \neq (-1\cdot-1)^{1/2}``       |``\sqrt{x}\sqrt{y} \neq \sqrt{xy}`` in general                                 |
|3. ``(x^a)^b = x^{ab}``  |``b \in \mathbb{Z}``                  |``{\left((-1)^2\right)}^{1/2} \neq (-1)^{2\cdot1/2}`` |``\sqrt{x^2}\neq x`` and ``\sqrt{\frac{1}{x}}\neq\frac{1}{\sqrt{x}}`` in general |


This is important to remember, because by default, SymPy will not perform
simplifications if they are not true in general.

In order to make SymPy perform simplifications involving identities that are
only true under certain assumptions, we need to put assumptions on our
Symbols.  We will undertake a full discussion of the assumptions system later,
but for now, all we need to know are the following.

- By default, SymPy Symbols are assumed to be complex (elements of
  ``\mathbb{C}``).  That is, a simplification will not be applied to an
  expression with a given Symbol unless it holds for all complex numbers.

- Symbols can be given different assumptions by passing the assumption to
  `symbols()`.  For the rest of this section, we will be assuming that `x`
  and `y` are positive, and that `a` and `b` are real.  We will leave
  `z`, `t`, and `c` as arbitrary complex Symbols to demonstrate what
  happens in that case.

!!! tip "Julia differences"

    We use `@syms` below, though `symbols` has an advantage when defining more than one variable with a certain assumption

```@repl Julia
@syms x::positive, y::positive
@syms a::real, b::rea;
@syms z, t, c
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x, y = symbols('x y', positive=True)
    >>> a, b = symbols('a b', real=True)
    >>> z, t, c = symbols('z t c')
```
```@raw html
</details>
```
----


!!! note "TODO"
    Rewrite this using the new assumptions

!!! note

    In SymPy, `sqrt(x)` is just a shortcut to `x**Rational(1, 2)`.  They
    are exactly the same object.

powsimp
-------

`powsimp()` applies identities 1 and 2 from above, from left to right.


!!! tip "Julia differences"

    The `powsimp` function must be qualified

```@repl Julia
sympy.powsimp(x^a*x^b)
sympy.powsimp(x^a*y^a)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> powsimp(x**a*x**b)
     a + b
    x
   >>> powsimp(x**a*y**a)
        a
   (x⋅y)
```
```@raw html
</details>
```
----


Notice that `powsimp()` refuses to do the simplification if it is not valid.



```@repl Julia
sympy.powsimp(t^c*z^c)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> powsimp(t**c*z**c)
     c  c
    t ⋅z
```
```@raw html
</details>
```
----


If you know that you want to apply this simplification, but you don't want to
mess with assumptions, you can pass the `force=True` flag.  This will force
the simplification to take place, regardless of assumptions.


```@repl Julia
sympy.powsimp(t^c*z^c, force=true)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> powsimp(t**c*z**c, force=True)
         c
    (t⋅z)
```
```@raw html
</details>
```
----


Note that in some instances, in particular, when the exponents are integers or
rational numbers, and identity 2 holds, it will be applied automatically.

```@repl Julia
(z*t)^2
sqrt(x*y)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> (z*t)**2
     2  2
    t ⋅z
   >>> sqrt(x*y)
    √x⋅√y
```
```@raw html
</details>
```
----


This means that it will be impossible to undo this identity with
`powsimp()`, because even if `powsimp()` were to put the bases together,
they would be automatically split apart again.

```@repl Julia
sympy.powsimp(z^2*t^2)
sympy.powsimp(sqrt(x)*sqrt(y))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> powsimp(z**2*t**2)
     2  2
    t ⋅z
   >>> powsimp(sqrt(x)*sqrt(y))
    √x⋅√y
```
```@raw html
</details>
```
----


expand_power_exp / expand_power_base
------------------------------------

`expand_power_exp()` and `expand_power_base()` apply identities 1 and 2
from right to left, respectively.

!!! tip "Julia differences"

    The too need qualification

```@repl Julia
sympy.expand_power_exp(x^(a + b))
sympy.expand_power_base((x*y)^a)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_power_exp(x**(a + b))
     a  b
    x ⋅x

    >>> expand_power_base((x*y)**a)
     a  a
    x ⋅y
```
```@raw html
</details>
```
----


As with `powsimp()`, identity 2 is not applied if it is not valid.



```@repl Julia
sympy.expand_power_base((z*t)^c)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_power_base((z*t)**c)
         c
    (t⋅z)
```
```@raw html
</details>
```
----


And as with `powsimp()`, you can force the expansion to happen without
fiddling with assumptions by using `force=True`.

```@repl Julia
sympy.expand_power_base((z*t)^c, force=true)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> expand_power_base((z*t)**c, force=True)
     c  c
    t ⋅z
```
```@raw html
</details>
```
----


As with identity 2, identity 1 is applied automatically if the power is a
number, and hence cannot be undone with `expand_power_exp()`.


```@repl Julia
x^2*x^3
sympy.expand_power_exp(x^5)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
   >>> x**2*x**3
     5
    x
   >>> expand_power_exp(x**5)
     5
    x
```
```@raw html
</details>
```
----


powdenest
---------

`powdenest()` applies identity 3, from left to right.

!!! tip "Julia differences"

    This function needs qualification

```@repl Julia
sympy.powdenest((x^a)^b)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> powdenest((x**a)**b)
     a⋅b
    x
```
```@raw html
</details>
```
----


As before, the identity is not applied if it is not true under the given
assumptions.


```@repl Julia
sympy.powdenest((z^a)^b)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> powdenest((z**a)**b)
        b
    ⎛ a⎞
    ⎝z ⎠
```
```@raw html
</details>
```
----


And as before, this can be manually overridden with `force=True`.


```@repl Julia
sympy.powdenest((z^a)^b, force=true)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> powdenest((z**a)**b, force=True)
     a⋅b
    z
```
```@raw html
</details>
```
----


Exponentials and logarithms
===========================

!!! note

    In SymPy, as in Python and most programming languages, `log` is the
    natural logarithm, also known as `ln`.  SymPy automatically provides an
    alias `ln = log` in case you forget this.

         >>> ln(x)
         log(x)

Logarithms have similar issues as powers.  There are two main identities

1. ``\log{(xy)} = \log{(x)} + \log{(y)}``
2. ``\log{(x^n)} = n\log{(x)}``

Neither identity is true for arbitrary complex `x` and `y`, due to the branch
cut in the complex plane for the complex logarithm.  However, sufficient
conditions for the identities to hold are if `x` and `y` are positive and `n`
is real.


```@repl Julia
@syms x::positive, y::positive, n::real
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x, y = symbols('x y', positive=True)
    >>> n = symbols('n', real=True)
```
```@raw html
</details>
```
----


As before, `z` and `t` will be Symbols with no additional assumptions.

Note that the identity ``\log{\left(\frac{x}{y}\right)} = \log(x) - \log(y)``
is a special case of identities 1 and 2 by ``\log{\left(\frac{x}{y}\right)}=``
``\log{\left(x\cdot\frac{1}{y}\right)} =``
``\log(x) + \log{\left(y^{-1}\right)} =` `\log(x) - \log(y)``, and thus it also holds if ``x`` and ``y``
are positive, but may not hold in general.

We also see that ``\log{\left( e^x \right)} = x`` comes from
``\log{\left( e^x \right)} = x\log(e) = x``, and thus holds when ``x`` is real (and it can be
verified that it does not hold in general for arbitrary complex ``x``, for
example,
``\log{\left(e^{x + 2\pi i}\right)} = \log{\left(e^x\right)} = x \neq x + 2\pi i``).

expand_log
----------

To apply identities 1 and 2 from left to right, use `expand_log()`.  As
always, the identities will not be applied unless they are valid.

!!! tip "Julia differences"

    This function needs qualification

```@repl Julia
sympy.expand_log(log(x*y))
sympy.expand_log(log(x/y))
sympy.expand_log(log(x^2))
sympy.expand_log(log(x^n))
sympy.expand_log(log(z*t))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_log(log(x*y))
    log(x) + log(y)
    >>> expand_log(log(x/y))
    log(x) - log(y)
    >>> expand_log(log(x**2))
    2⋅log(x)
    >>> expand_log(log(x**n))
    n⋅log(x)
    >>> expand_log(log(z*t))
    log(t⋅z)
```
```@raw html
</details>
```
----


As with `powsimp()` and `powdenest()`, `expand_log()` has a `force`
option that can be used to ignore assumptions.



```@repl Julia
sympy.expand_log(log(z^2))
sympy.expand_log(log(z^2), force=true)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_log(log(z**2))
       ⎛ 2⎞
    log⎝z ⎠
    >>> expand_log(log(z**2), force=True)
    2⋅log(z)
```
```@raw html
</details>
```
----


logcombine
----------

To apply identities 1 and 2 from right to left, use `logcombine()`.

!!! tip "Julia differences"

    This function needs qualification

```@repl Julia
sympy.logcombine(log(x) + log(y))
sympy.logcombine(n*log(x))
sympy.logcombine(n*log(z))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> logcombine(log(x) + log(y))
    log(x⋅y)
    >>> logcombine(n*log(x))
       ⎛ n⎞
    log⎝x ⎠
    >>> logcombine(n*log(z))
    n⋅log(z)
```
```@raw html
</details>
```
----


`logcombine()` also has a `force` option that can be used to ignore
assumptions.

```@repl Julia
sympy.logcombine(n*log(z), force=true)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> logcombine(n*log(z), force=True)
       ⎛ n⎞
    log⎝z ⎠
```
```@raw html
</details>
```
----


Special Functions
=================

SymPy implements dozens of special functions, ranging from functions in
combinatorics to mathematical physics.

An extensive list of the special functions included with SymPy and their
documentation is at the [Functions Module](functions-contents) page.

For the purposes of this tutorial, let's introduce a few special functions in
SymPy.

Let's define `x`, `y`, and `z` as regular, complex Symbols, removing any
assumptions we put on them in the previous section.  We will also define `k`,
`m`, and `n`.

!!! tip "Julia differences"

    Functions in `SpecialFunctions` with SymPy counterparts have methods defined for them which, generally, are dispatched on through the first argument being symbolic. Other special function in SymPy must be qualifed in usage, as in `sympy.hyper`. For these, there is no requirement that the first argument be symbolic.

```@repl Julia
@syms x y z k m n
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x, y, z = symbols('x y z')
    >>> k, m, n = symbols('k m n')
```
```@raw html
</details>
```
----


The [factorial](https://en.wikipedia.org/wiki/Factorial) function is
`factorial`.  `factorial(n)` represents `n!= 1\cdot2\cdots(n - 1)\cdot
n`. `n!` represents the number of permutations of `n` distinct items.



```@repl Julia
factorial(n)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> factorial(n)
    n!
```
```@raw html
</details>
```
----


The [binomial coefficient](https://en.wikipedia.org/wiki/Binomial_coefficient function is
`binomial`.  `binomial(n, k)` represents ``\binom{n}{k}``, the number of
ways to choose `k` items from a set of `n` distinct items.  It is also often
written as `nCk`, and is pronounced "`n` choose `k`".



```@repl Julia
binomial(n, k)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> binomial(n, k)
    ⎛n⎞
    ⎜ ⎟
    ⎝k⎠
```
```@raw html
</details>
```
----


The factorial function is closely related to the [gamma function](https://en.wikipedia.org/wiki/Gamma_function), `gamma`.  `gamma(z)`
represents ``\Gamma(z) = \int_0^\infty t^{z - 1}e^{-t}\,dt``, which for positive integer
``z`` is the same as ``(z - 1)!``.

!!! tip "Julia differences"

    As mentioned, `gamma` is exported by  `SpecialFunctions` and a method for symbolic arguments is provided when that package is loaded

```@repl Julia
gamma(z)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> gamma(z)
    Γ(z)
```
```@raw html
</details>
```
----


The [generalized hypergeometric function](https://en.wikipedia.org/wiki/Generalized_hypergeometric_function) is
`hyper`. ``hyper([a_1, ..., a_p], [b_1, ..., b_q], z)` represents
``{}_pF_q\left(\begin{matrix} a_1, \cdots, a_p \\ b_1, \cdots, b_q \end{matrix}
\middle| z \right)``.  The most common case is ``{}_2F_1``, which is often
referred to as the `ordinary hypergeometric function
[https://en.wikipedia.org/wiki/Hypergeometric_function](https://en.wikipedia.org/wiki/Hypergeometric_function).



```@repl Julia
sympy.hyper([1, 2], [3], z)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> hyper([1, 2], [3], z)
     ┌─  ⎛1, 2 │  ⎞
     ├─  ⎜     │ z⎟
    2╵ 1 ⎝ 3   │  ⎠
```
```@raw html
</details>
```
----


rewrite
-------

A common way to deal with special functions is to rewrite them in terms of one
another.  This works for any function in SymPy, not just special functions.
To rewrite an expression in terms of a function, use
`expr.rewrite(function)`.  For example,


```@repl Julia
tan(x).rewrite(cos)
factorial(x).rewrite(gamma)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> tan(x).rewrite(cos)
       ⎛    π⎞
    cos⎜x - ─⎟
       ⎝    2⎠
    ──────────
      cos(x)
    >>> factorial(x).rewrite(gamma)
    Γ(x + 1)
```
```@raw html
</details>
```
----


For some tips on applying more targeted rewriting, see the
:ref:`tutorial-manipulation` section.

expand_func
-----------

To expand special functions in terms of some identities, use
`expand_func()`.  For example

!!! tip "Julia differences"

    This function needs qualification

```@repl Julia
sympy.expand_func(gamma(x + 3))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expand_func(gamma(x + 3))
    x⋅(x + 1)⋅(x + 2)⋅Γ(x)
```
```@raw html
</details>
```
----


hyperexpand
-----------

To rewrite `hyper` in terms of more standard functions, use
`hyperexpand()`.



```@repl Julia
sympy.hyperexpand(sympy.hyper([1, 1], [2], z))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> hyperexpand(hyper([1, 1], [2], z))
    -log(1 - z)
    ────────────
         z
```
```@raw html
</details>
```
----


`hyperexpand()` also works on the more general Meijer G-function (see
[its documentation](sympy.functions.special.hyper.meijerg) for more
information).


```@repl Julia
expr = sympy.meijerg([[1],[1]], [[1],[]], -z)
sympy.hyperexpand(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = meijerg([[1],[1]], [[1],[]], -z)
    >>> expr
    ╭─╮1, 1 ⎛1  1 │   ⎞
    │╶┐     ⎜     │ -z⎟
    ╰─╯2, 1 ⎝1    │   ⎠
    >>> hyperexpand(expr)
     1
     ─
     z
    ℯ
```
```@raw html
</details>
```
----


combsimp
--------

To simplify combinatorial expressions, use `combsimp()`.



```@repl Julia
@syms n::integer, k::integer
sympy.combsimp(factorial(n)/factorial(n - 3))
sympy.combsimp(binomial(n+1, k+1)/binomial(n, k))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> n, k = symbols('n k', integer = True)
    >>> combsimp(factorial(n)/factorial(n - 3))
    n⋅(n - 2)⋅(n - 1)
    >>> combsimp(binomial(n+1, k+1)/binomial(n, k))
    n + 1
    ─────
    k + 1
```
```@raw html
</details>
```
----


gammasimp
---------

To simplify expressions with gamma functions or combinatorial functions with
non-integer argument, use `gammasimp()`.

!!! tip "Julia differences"

    This function needs qualification

```@repl Julia
sympy.gammasimp(gamma(x)*gamma(1 - x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> gammasimp(gamma(x)*gamma(1 - x))
       π
    ────────
    sin(π⋅x)
```
```@raw html
</details>
```
----


Example: Continued Fractions
============================

Let's use SymPy to explore continued fractions.  A [continued fraction](https://en.wikipedia.org/wiki/Continued_fraction) is an expression of the
form

```math
a_0 + \cfrac{1}{a_1 + \cfrac{1}{a_2 + \cfrac{1}{ \ddots + \cfrac{1}{a_n}
   }}}
```

where ``a_0, \ldots, a_n`` are integers, and ``a_1, \ldots, a_n`` are positive. A
continued fraction can also be infinite, but infinite objects are more
difficult to represent in computers, so we will only examine the finite case
here.

A continued fraction of the above form is often represented as a list ``[a_0;
a_1, \ldots, a_n]``.  Let's write a simple function that converts such a list
to its continued fraction form.  The easiest way to construct a continued
fraction from a list is to work backwards.  Note that despite the apparent
symmetry of the definition, the first element, `a_0`, must usually be handled
differently from the rest.

```@repl Julia
function list_to_frac(l)
  ex = Sym(0)
  for i in reverse(l[2:end])
    ex += i
    ex = 1/ex
  end
  first(l) + ex
end
list_to_frac([x, y, z])
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> def list_to_frac(l):
    ...     expr = Integer(0)
    ...     for i in reversed(l[1:]):
    ...         expr += i
    ...         expr = 1/expr
    ...     return l[0] + expr
    >>> list_to_frac([x, y, z])
          1
    x + ─────
            1
        y + ─
            z
```
```@raw html
</details>
```
----


We use `Integer(0)` in `list_to_frac` so that the result will always be a
SymPy object, even if we only pass in Python ints.

```@repl Julia
list_to_frac([1, 2, 3, 4])
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> list_to_frac([1, 2, 3, 4])
    43
    ──
    30
```
```@raw html
</details>
```
----


Every finite continued fraction is a rational number, but we are interested in
symbolics here, so let's create a symbolic continued fraction.  The
`symbols()` function that we have been using has a shortcut to create
numbered symbols.  `symbols('a0:5')` will create the symbols `a0`, `a1`,
..., `a4`.



```@repl Julia
@syms a[0:4]
frac = list_to_frac(a)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> syms = symbols('a0:5')
    >>> syms
    (a₀, a₁, a₂, a₃, a₄)
    >>> a0, a1, a2, a3, a4 = syms
    >>> frac = list_to_frac(syms)
    >>> frac
                 1
    a₀ + ─────────────────
                   1
         a₁ + ────────────
                      1
              a₂ + ───────
                        1
                   a₃ + ──
                        a₄
```
```@raw html
</details>
```
----


This form is useful for understanding continued fractions, but lets put it
into standard rational function form using `cancel()`.



```@repl Julia
frac = cancel(frac)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> frac = cancel(frac)
    >>> frac
    a₀⋅a₁⋅a₂⋅a₃⋅a₄ + a₀⋅a₁⋅a₂ + a₀⋅a₁⋅a₄ + a₀⋅a₃⋅a₄ + a₀ + a₂⋅a₃⋅a₄ + a₂ + a₄
    ─────────────────────────────────────────────────────────────────────────
                     a₁⋅a₂⋅a₃⋅a₄ + a₁⋅a₂ + a₁⋅a₄ + a₃⋅a₄ + 1
```
```@raw html
</details>
```
----


Now suppose we were given `frac` in the above canceled form. In fact, we
might be given the fraction in any form, but we can always put it into the
above canonical form with `cancel()`.  Suppose that we knew that it could be
rewritten as a continued fraction.  How could we do this with SymPy?  A
continued fraction is recursively `c + \frac{1}{f}`, where `c` is an integer
and `f` is a (smaller) continued fraction.  If we could write the expression
in this form, we could pull out each `c` recursively and add it to a list.  We
could then get a continued fraction with our `list_to_frac()` function.

The key observation here is that we can convert an expression to the form `c +
\frac{1}{f}` by doing a partial fraction decomposition with respect to
`c`. This is because `f` does not contain `c`.  This means we need to use the
`apart()` function.  We use `apart()` to pull the term out, then subtract
it from the expression, and take the reciprocal to get the `f` part.


```@repl Julia
l = Any[]
a0 = first(a)
frac = apart(frac, a0)
push!(l, a0)
frac = 1 / (frac - a0)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> l = []
    >>> frac = apart(frac, a0)
    >>> frac
                    a₂⋅a₃⋅a₄ + a₂ + a₄
    a₀ + ───────────────────────────────────────
         a₁⋅a₂⋅a₃⋅a₄ + a₁⋅a₂ + a₁⋅a₄ + a₃⋅a₄ + 1
    >>> l.append(a0)
    >>> frac = 1/(frac - a0)
    >>> frac
    a₁⋅a₂⋅a₃⋅a₄ + a₁⋅a₂ + a₁⋅a₄ + a₃⋅a₄ + 1
    ───────────────────────────────────────
               a₂⋅a₃⋅a₄ + a₂ + a₄
```
```@raw html
</details>
```
----


Now we repeat this process


```@repl Julia
a1,a2,a3,a4 = a[2:end]
frac = apart(frac, a1)
push!(l, a1)
frac = 1/(frac - a1)

frac = apart(frac, a2)
push!(l, a2)
frac = 1/(frac - a2)

frac = apart(frac, a3)
push!(l, a3)
frac = 1/(frac - a3)

frac = apart(frac, a4)
push!(l, a4)
frac = 1/(frac - a4)

list_to_frac(l)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> frac = apart(frac, a1)
    >>> frac
             a₃⋅a₄ + 1
    a₁ + ──────────────────
         a₂⋅a₃⋅a₄ + a₂ + a₄
    >>> l.append(a1)
    >>> frac = 1/(frac - a1)
    >>> frac = apart(frac, a2)
    >>> frac
             a₄
    a₂ + ─────────
         a₃⋅a₄ + 1
    >>> l.append(a2)
    >>> frac = 1/(frac - a2)
    >>> frac = apart(frac, a3)
    >>> frac
         1
    a₃ + ──
         a₄
    >>> l.append(a3)
    >>> frac = 1/(frac - a3)
    >>> frac = apart(frac, a4)
    >>> frac
    a₄
    >>> l.append(a4)
    >>> list_to_frac(l)
                 1
    a₀ + ─────────────────
                   1
         a₁ + ────────────
                      1
              a₂ + ───────
                        1
                   a₃ + ──
                        a₄
```
```@raw html
</details>
```
----



Of course, this exercise seems pointless, because we already know that our
`frac` is `list_to_frac([a0, a1, a2, a3, a4])`.  So try the following
exercise.  Take a list of symbols and randomize them, and create the canceled
continued fraction, and see if you can reproduce the original list.  For
example

!!! tip "Julia differences"

    Sampling with replacement is provided in the `StatsBase` package. Here we define a non-performant function to shuffle a vector of values.


```@repl Julia
shuffle(x) = [(i=rand(1:length(x)); a=x[i]; deleteat!(x,i); a) for _ ∈ 1:length(x)]
@syms a[0:4]
l = shuffle(a)
orig_frac = frac = cancel(list_to_frac(l))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> import random
    >>> l = list(symbols('a0:5'))
    >>> random.shuffle(l)
    >>> orig_frac = frac = cancel(list_to_frac(l))
    >>> del l
```
```@raw html
</details>
```
----


In SymPy, on the above example, try to reproduce `l` from
`frac`.  I have deleted `l` at the end to remove the temptation for
peeking (you can check your answer at the end by calling
`cancel(list_to_frac(l))` on the list that you generate at the end, and
comparing it to `orig_frac`.

See if you can think of a way to figure out what symbol to pass to `apart()`
at each stage (hint: think of what happens to ``a_0`` in the formula ``a_0 +
\frac{1}{a_1 + \cdots}`` when it is canceled).

Answer: ``a_0`` is the only symbol that does not appear in the denominator

# A SymPyCore introduction

This document provides an introduction to using SymPy within `Julia` via `SymPyCore`
It has examples from the [Introductory Tutorial](https://docs.sympy.org/latest/tutorials/intro-tutorial/index.html) of SymPy that is translated into `Julia` commands in this documentation.


```@setup introduction
using SymPyPythonCall
```

## Overview

In this document, we use `SymPy` to refer to either the `SymPy` or `SymPyPythonCall` packages that interface `Julia` with SymPy from `Python` using `SymPyCore`. The only difference being the glue package for interop between `Julia` and `Python`.

`SymPy` provides a `Julia`n interface to SymPy, a `Python` library for symbolic math, as alternative to working with `Python` objects directly using one of the glue packages. See the [overview](./overview.html) page for more details. Some brief implementation details are:

* Symbolic values in `Python` are wrapped in a subtype, typically `Sym{T}`, of `SymbolicObject{T}` or a container holding such values. The conversion from a Python object to a symbolic object in `Julia` is implemented in the `↑` method. Similarly, the  `↓` method takes a symbolic object and finds a Python counterpart for passing to underlying methods of SymPy.

* For many generic methods in `Base`, `LinearAlgebra`, or `SpecialFunctions` -- when there is a SymPy counterpart -- a method is made which dispatches on its first argument being symbolic. The basic pattern is akin to `Base.sin(x::Sym) = sympy.sin(x)` where `sympy.sin(x)` is essentially `↑(_sympy_.sin(↓(x)))` -- here `_sympy_` is the object holding the reference to the Python module, and `_sympy_.sin` the reference to its `sin` function. The `sympy` object handles the up and down conversions.

* For many primary functions of SymPy, such as `simplify`, `factor`, `expand`, etc., new methods are made for use within `Julia`. Less foundational functions of SymPy, such as `trigsimp` or `expand_log` are referenced as `sympy.trigsimp` or `sympy.expand_log`. The `sympy` object is not a `Julia` module, but this use is reminiscent of qualifying a function from a module.

* SymPy, being a Python library, has many methods for its objects. For example, a symbolic object, `obj` has a `diff` method accessed by `obj.diff(...)`. A object also has a `subs` method for substitution, accessed through `obj.subs(...)`. The same "dot" style is used for Python and `Julia`.

* For commonly used object methods, a `Julia`n interface is defined. For `diff` a `diff(obj::Sym, ...)` method is defined. For `subs` a `subs(obj::Sym, ...)` interface is defined, and exported. As `subs` has paired-off values, specifying the substitution, the `Julia`n interface allows pairs notation (`a => b`) to be used.

## The package

Either the `SymPy` or `SymPyPythonCall` packages needs to be loaded, e.g., `using SymPy`. The two can't be used in the same session.

When either is installed, the `SymPyCore` package is installed; the underlying glue package (either `PyCall` or `PythonCall`) should be installed; and that glue package should install the `sympy` library of `Python`.

## Symbols

At the core of `SymPy` is the introduction of symbolic variables that
differ quite a bit from `Julia`'s variables. Symbolic variables do not
immediately evaluate to a value, rather the "symbolicness" propagates
when interacted with. To keep things manageable, SymPy does some
simplifications along the way.

Symbolic expressions are primarily of the `Sym` type and can be constructed in the standard way:

```@repl introduction
x = Sym("x")
```

This creates a symbolic object `x`, which can be manipulated through further function calls.

### The `@syms` macro

There is the `@syms` macro that makes creating multiple variables a
bit less typing, as it creates variables in the local scope -- no
assignment is necessary. Compare these similar ways to create symbolic
variables:

```@repl introduction
@syms a b c
a,b,c = Sym("a"), Sym("b"), Sym("c")
```

Here are two ways to make related variables:

```@repl introduction
@syms xs[1:5]
ys = [Sym("y$i") for i in 1:5]
```

The former much more succinct, but the latter pattern of use when the number of terms is a variable.


The `@syms` macro is recommended, and will be modeled in the following, as it makes the specification of assumptions, collections of indexed variables,  and symbolic functions more natural.

### Assumptions

In `Python`'s SymPy documentation the `symbols` constructor is
suggested as idiomatic for producing symbolic objects. This function
can similarly be used within `Julia`. With `symbols` (and with
`@syms`) it is possible to pass assumptions onto the variables. A list
of possible assumptions is
[here](http://docs.sympy.org/dev/modules/core.html#module-sympy.core.assumptions). Some
examples are:

```@repl introduction
u = symbols("u")
x = symbols("x", real=true)
y1, y2 = symbols("y1, y2", positive=true)
alpha = symbols("alpha", integer=true, positive=true)
```

As seen, the `symbols` function can be used to make one or more variables with zero, one or more assumptions.

We jump ahead for a second to illustrate, but here we see that `solve` will respect these assumptions, by failing to find solutions to these equations:

```@repl introduction
solve(x^2 + 1)   # ±i are not real
```

```@repl introduction
solve(y1 + 1)    # -1 is not positive
```

----

The `@syms` macro allows annotations, akin to type annotations, to specify assumptions on new variables:

```@repl introduction
@syms u1::positive u2::positive
solve(u1 + u2)  # empty, though solving u1 - u2 is not.
```

Additionally you can rename arguments using pair notation:

```@repl introduction
@syms a1=>"α₁" a2=>"α₂"
```

In this example, the Julia variables `a1` and `a2` are defined to store SymPy
symbols with the "pretty" names `α₁` and `α₂` respectively.

As can be seen, there are several ways to create symbolic values, but
the recommended way is to use `@syms`.

### Special constants

`Julia` has its math constants, like `pi` and `e`, `SymPy` as well. A few of these have `Julia` counterparts provided by `SymPyCore`. For example, these two constants are defined (where `oo` is for infinity):

```@repl introduction
PI,  oo  # also Sym(pi) or Sym(Inf)
```

Numeric values themselves can be symbolic. This example shows the
difference. The first `asin` call dispatches to `Julia`'s `asin`
function, the second to `SymPy`'s:

```@repl introduction
[asin(1), asin(Sym(1))]
```


## Substitution

SymPy provides a means to substitute values in for the symbolic expressions. The specification requires an expression, a variable in the expression to substitute in for, and a new value. For example, this is one way to make a polynomial in a new variable:

```@repl introduction
@syms x y
ex = x^2 + 2x + 1
ex.subs(x, y)
```


Substitution can also be numeric:

```@repl introduction
ex.subs(x, 0)
```

The output has no free variables, but is still symbolic.

Expressions with more than one variable can have multiple substitutions, where each is expressed as a tuple:

```@repl introduction
@syms x,y,z
ex = x + y + z
ex.subs([(x,1), (y, pi)])
```


!!! note
    The SymPy documentation for many functions can be read from the terminal using `Base.Docs.getdoc(ex)`, as in `Base.Docs.getdoc(sin(x))`.


The `SymPyCore` package also offers a more `Julia`n interface, through the method `subs`. This replaces the specification of pairs by a tuple with the `=>` infix operator for `Pair` construction:

```@repl introduction
subs(ex, x=>1, y=>pi)
```


For `subs`, the simple substitution `ex.object(x,a)` or `subs(ex, x=>s)` is similar to simple function evaluation, so `Julia`'s call notation for symbolic expressions is reserved for substitution, where to specify the pairing off of `x` and `a`, the `=>`  pairs notation is used.

This calling style will be equivalent to the last:

```@repl introduction
ex(x=>1, y=>pi)
```

A straight call is also possible, where the order of the variables is determined by `free_symbols`. This is useful for expressions of a single variable, but being more explicit through the use of paired values is recommended.


## Conversion from symbolic to numeric

SymPy provides two identical means to convert a symbolic math
expression to a number. One is `evalf`, the other `N`. Within `Julia`
we decouple this, using `N` to also convert to a `Julian` value and
`evalf` to leave the conversion as a symbolic object.  The `N`
function converts symbolic integers, rationals, irrationals, and
complex values, while attempting to find an appropriate `Julia` type
for the value.

To see the difference, we use both on `PI`:

```@repl introduction
N(PI)  # converts to underlying pi irrational
```

Whereas, `evalf` will produce a symbolic numeric value:

```@repl introduction
(PI).evalf()
```


The `evalf` call allows for a precision argument to be passed through the second argument. This is how 30 digits of $\pi$ can be extracted:

```@repl introduction
PI.evalf(30)
```

This is a SymPy, symbolic number, not a `Julia` object. Composing with `N`

```@repl introduction
N(PI.evalf(30))
```

will produce a `Julia` number,


Explicit conversion via `convert(T, ex)` can also be done in some cases, but may need to be combined with a call to `evalf` in some compound cases.


## Algebraic expressions

`SymPyCore` overloads many of `Julia`'s functions to work with symbolic objects, such as seen above with `asin`. The usual mathematical operations such as `+`, `*`, `-`, `/` etc. work through `Julia`'s promotion mechanism, where numbers are promoted to symbolic objects, others dispatch internally to related SymPy functions.

In most all  cases, thinking about this distinction between numbers and symbolic numbers is unnecessary, as numeric values passed to `SymPyCore` functions are typically promoted to symbolic expressions. This conversion will take math constants to their corresponding `SymPyCore` counterpart, rational expressions to rational expressions, and floating point values to floating point values. However there are edge cases. An expression like `1//2 * pi * x` will differ from the seemingly identical  `1//2 * (pi * x)`. The former will produce a floating point value from `1//2 * pi` before being promoted to a symbolic instance. Using the symbolic value `PI` makes this expression work either way.

Most of `Julia`'s
[mathematical](http://julia.readthedocs.org/en/latest/manual/mathematical-operations/#elementary-functions)
functions are overloaded to work with symbolic expressions. `Julia`'s
generic definitions are used, as possible. This also introduces some
edge cases. For example, `x^(-2)` will balk due to the negative,
integer exponent, but either `x^(-2//1)` or `x^Sym(-2)` will work as
expected, as the former call first dispatches to a generic definition,
but the latter two expressions do not.




### The expand, factor, collect, and simplify functions

`SymPyCore makes it very easy to work with polynomial and rational expressions.

First we create some variables:

```@repl introduction
@syms x y z
```


A typical polynomial expression in a single variable can be written in two common ways, expanded or factored form. Using `factor` and `expand` can move between the two.

For example,

```@repl introduction
p = x^2 + 3x + 2
factor(p)
```

Or

```@repl introduction
expand(prod((x-i) for i in 1:5))
```

The `factor` function factors over the rational numbers, so something like this with obvious factors is not finished:

```@repl introduction
factor(x^2 - 2)
```

When expressions involve one or more variables, it can be convenient to be able to manipulate them. For example,
if we define `q` by:

```@repl introduction
q = x*y + x*y^2 + x^2*y + x
```

Then we can collect the terms by the variable `x`:

```@repl introduction
sympy.collect(q, x)
```

or the variable `y`:

```@repl introduction
sympy.collect(q, y)
```

These are identical expressions, though viewed differently.

!!! note
    `SymPy`'s `collect` function has a different meaning than the `collect` generic, which turns an iterable into a vector or, more generally, an array. The expression above dispatches to `SymPy`'s as `q` is symbolic.

A more broad-brush approach is to let `SymPyCore` simplify the values. In this case, the common value of `x` is factored out:

```@repl introduction
simplify(q)
```

The `simplify` function attempts to apply the dozens of functions related to simplification that are part of SymPy. It is also possible to apply these functions one at a time, for example `sympy.trigsimp` does trigonometric simplifications.

The SymPy tutorial illustrates that `expand` can also result in simplifications through this example:

```@repl introduction
expand((x + 1)*(x - 2) - (x - 1)*x)
```


These methods are not restricted to polynomial expressions and will
work with other expressions. For example, `factor` identifies the
following as a factorable object in terms of the variable `exp(x)`:

```@repl introduction
factor(exp(2x) + 3exp(x) + 2)
```

### Rational expressions: apart, together, cancel

When working with rational expressions, SymPy does not do much
simplification unless asked. For example this expression is not
simplified:

```@repl introduction
r = 1/x + 1/x^2
```

To put the terms of `r` over a common denominator, the `together` function is available:

```@repl introduction
together(r)
```

The `apart` function does the reverse, creating a partial fraction decomposition from a ratio of polynomials:

```@repl introduction
apart( (4x^3 + 21x^2 + 10x + 12) /  (x^4 + 5x^3 + 5x^2 + 4x))
```

Some times SymPy will cancel factors, as here:

```@repl introduction
top = (x-1)*(x-2)*(x-3)
bottom = (x-1)*(x-4)
top/bottom
```

(This might make math faculty a bit upset, but it is in line with student thinking.)

However, with expanded terms, the common factor of `(x-1)` is not cancelled:

```@repl introduction
r = expand(top) / expand(bottom)
```

The `cancel` function instructs SymPy to perform cancellations. It
takes rational functions and puts them in a canonical $p/q$ form with
no common (rational) factors and leading terms which are integers:

```@repl introduction
cancel(r)
```
### Powers

The SymPy [tutorial](http://docs.sympy.org/dev/tutorial/simplification.html#powers) offers a thorough explanation on powers and which get simplified and under what conditions. Basically

* The simplicfication $x^a x^b = x^{a+b}$ is always true. However

* The simplification $x^a y^a=(xy)^a$ is only true with assumptions, such as $x,y \geq 0$ and $a$ is real, but not in general. For example, $x=y=-1$ and $a=1/2$ has $x^a \cdot y^a = i \cdot i =  -1$, where as $(xy)^a = 1$.

* As well, the simplification $(x^a)^b = x^{ab}$ is only true with assumptions. For example $x=-1, a=2$, and $b=1/2$ gives $(x^a)^b = 1^{1/2} = 1$, whereas $x^{ab} = -1^1 = -1$.


We see that with assumptions, the following expression does simplify to $0$:

```@repl introduction
@syms x::nonnegatve y::nonnegative  a::real
simplify(x^a * y^a - (x*y)^a)
```

However, without assumptions this is not the case

```@repl introduction
@syms x,y,a
simplify(x^a * y^a - (x*y)^a)
```

The `simplify` function calls `powsimp` to simplify powers, as above. The `powsimp` function has the keyword argument `force=true` to force simplification even if assumptions are not specified:

```@repl introduction
sympy.powsimp(x^a * y^a - (x*y)^a, force=true)
```

### Trigonometric simplification

For trigonometric expressions, `simplify` will use `trigsimp` to simplify:

```@repl introduction
@syms theta::real
p = cos(theta)^2 + sin(theta)^2
```

Calling either `simplify` or `trigsimp` will apply the Pythagorean identity:

```@repl introduction
simplify(p)
```

The `trigsimp` function is, of course,  aware of the double angle formulas:

```@repl introduction
simplify(sin(2theta) - 2sin(theta)*cos(theta))
```

The `expand_trig` function will expand such expressions:

```@repl introduction
sympy.expand_trig(sin(2theta))
```

## Polynomials

### Coefficients of a polynomial

Returning to polynomials, there are a few functions to find various pieces of the polynomials. First we make a general quadratic polynomial:

```@repl introduction
@syms a,b,c,x
p = a*x^2 + b*x + c
```

If given a polynomial, like `p`, there are different means to extract the coefficients:

* SymPy provides a `coeffs` method for `Poly` objects, but `p` must first be converted to one.

* SymPy provides the `coeff` method for expressions, which allows extraction of a coefficient for a given monomial




The `ex.coeff(monom)` call will return the corresponding coefficient of the monomial:

```@repl introduction
p.coeff(x^2) # a
p.coeff(x)   # b
```

The constant can be found through substitution:

```@repl introduction
p(x=>0)
```

Though one could use some trick like this to find all the coefficients, that is cumbersome, at best.

```@repl introduction
vcat([p.coeff(x^i) for i in N(degree(p,gen=x)):-1:1], [p(x=>0)])
```




Polynomials are a special class in SymPy and must be constructed. The `poly` constructor can be used. As there is more than one free variable in `p`, we specify the variable `x` below:

```@repl introduction
q = sympy.poly(p, x)
q.coeffs()
```


### Polynomial roots: solve, real_roots, polyroots, nroots

SymPy provides functions to find the roots of a polynomial. In
general, a polynomial with real coefficients of degree $n$ will have
$n$ roots when multiplicities and complex roots are accounted for. The
number of real roots is consequently between $0$ and $n$.

For a *univariate* polynomial expression (a single variable), the real
roots, when available, are returned by `real_roots`. For example,

```@repl introduction
real_roots(x^2 - 2)
```

Unlike `factor` -- which only factors over rational factors --
`real_roots` finds the two irrational roots here. It is well known
(the
[Abel-Ruffini theorem](http://en.wikipedia.org/wiki/Abel%E2%80%93Ruffini_theorem))
that for degree 5 polynomials, or higher, it is not always possible to
express the roots in terms of radicals. However, when the roots are
rational SymPy can have success:


```@repl introduction
p = (x-3)^2*(x-2)*(x-1)*x*(x+1)*(x^2 + x + 1)
real_roots(p)
```


In this example, the degree of `p` is 8, but only the 6 real roots
returned, the double root of $3$ is accounted for. The two complex
roots of `x^2 + x+ 1` are not considered by this function. The complete set
of distinct roots can be found with `solve`:

```@repl introduction
solve(p)
```

This finds the complex roots, but does not account for the double
root. The `roots` function of SymPy does.



The output of calling `roots` will be a dictionary whose keys are the roots and values the multiplicity.

```julia
roots(p)
```

When exact answers are not provided, the `roots` call is contentless:

```@repl introduction
p = x^5 - x + 1
sympy.roots(p)
```

Calling `solve` seems to produce very little as well:

```@repl introduction
rts = solve(p)
```

But in fact, `rts` contains lots of information. We can extract numeric values quite easily with `N`:

```@repl introduction
N.(rts)
```

These are numeric approximations to irrational values. For numeric
approximations to polynomial roots, the `nroots` function is also
provided. The answers are still symbolic:

```@repl introduction
nroots(p)
```

## Solving equations

### The solve function

The `solve` function is more general purpose than just finding roots of univariate polynomials. The function tries to solve for when an expression is $0$, or a set of expressions are all $0$.

For example, it can be used to solve when $\cos(x) = \sin(x)$:

```@repl introduction
solve(cos(x) - sin(x))
```

Though there are infinitely many correct solutions, these are within a certain range.

The
[solveset](http://docs.sympy.org/latest/modules/solvers/solveset.html)
function appears in version 1.0 of SymPy and is an intended
replacement for `solve`. Here we see it describes all solutions:

```@repl introduction
u = solveset(cos(x) - sin(x))
```

The output of `solveset` is a set, rather than a vector or
dictionary.

```@repl introduction
v = solveset(x^2 - 4)
```



Solving within Sympy has limits. For example, there is no symbolic solution here:

```@repl introduction
try  solve(cos(x) - x)  catch err "error" end # wrap command for doctest of error
```

(And hence the error message generated.)

For such an equation, a numeric method would be needed, similar to the `Roots` package. For example:

```@repl introduction
nsolve(cos(x) - x, 1)
```

Though it can't solve everything, the `solve` function can also solve
equations of a more general type. For example, here it is used to
derive the quadratic equation:

```@repl introduction
@syms a::real, b::real, c::real
p = a*x^2 + b*x + c
xs = solve(p, x);
```

The extra argument `x` is passed to `solve` so that `solve` knows
which variable to solve for.

### The `solveset` function

The `solveset` function is similar:

```@repl introduction
solveset(p, x); # Set with two elements
```

If the `x` value is not given, `solveset` will error and  `solve` will try to find a
solution over all the free variables:

```@repl introduction
solve(p)
```

The output of `solveset` in Python is always a set, which may be finite or not. Finite sets are converted to `Set`s in `Julia`. Infinite sets have no natural counterpart and are not realized. Rather, they can be queried, as with "needle `in` haystack". For example:

```@repl introduction
u = solveset(sin(x) ≧ 0)  # [\geqq] or with u  = solveset(Ge(sin(x), 0))
PI/2 in u
3PI/2 in u
```

Infinite sets can have unions and intersections taken:

```@repl introduction
v = solveset(cos(x) ≧ 0)
[3PI/4 in A for A ∈ (u, v, intersect(u, v), union(u, v))]
```

Infinite sets can be filtered by intersecting them with an interval. For example,

```@repl introduction
u = solveset(sin(x) ~ 1//2, x)
intersect(u, sympy.Interval(0, 2PI))  # a finite set after intersection
```

There are more sympy methods for working with sets, beyond those mirroring `Julia` generics.

----

Systems of equations can be solved as well. We specify them within a
tuple of expressions, `(ex1, ex2, ..., exn)` where a found solution
is one where all the expressions are 0. For example, to solve this
linear system: $2x + 3y = 6, 3x - 4y=12$, we have:

```@repl introduction
@syms x::real, y::real
exs = (2x+3y-6, 3x-4y-12)
```

```@repl introduction
d = solve(exs); # Dict(x=>60/17, y=>-6/17)
```


We can "check our work" by plugging into each equation. We take advantage of how the `subs` function allows us to pass in a dictionary:

```@repl introduction
map(ex -> ex.subs(d), exs)
```



The more `Julia`n way to solve a linear  equation, like this   would be as follows:

```@repl introduction
A = Sym[2 3; 3  -4]; b = Sym[6, 12]
A \ b
```

(Rather than use a generic  `lu` solver through `Julia` (which  proved slow for larger  systems),  the `\` operator utilizes  `solve` to perform this  computation.)



In the previous example, the system had two equations and two
unknowns. When that is not the case, one can specify the variables to
solve for as a vector. In this example, we find a quadratic polynomial
that approximates $\cos(x)$ near $0$:

```@repl introduction
a,b,c,h = symbols("a,b,c,h", real=true)

p = a*x^2 + b*x + c

fn = cos;
exs = [fn(0*h)-p(x=>0), fn(h)-p(x => h), fn(2h)-p(x => 2h)]
d = solve(exs, (a,b,c));
d[a], d[b], d[c]
```

Again, a dictionary is returned, though we display its named elements individually. The polynomial itself can be found by
substituting back in for `a`, `b`, and `c`:

```@repl introduction
quad_approx = p.subs(d)
```

Taking the "limit" as $h$ goes to 0 produces the answer $1 - x^2/2$, as  will be shown.

Finally for `solve`, we show one way to re-express the polynomial $a_2x^2 + a_1x + a_0$
as $b_2(x-c)^2 + b_1(x-c) + b_0$ using `solve` (and not, say, an
expansion theorem.)

```@repl introduction
n = 3
@syms x, c
@syms as[1:3]
@syms bs[1:3]
p = sum(as[i]*x^(i-1) for i ∈ 1:n)
q = sum(bs[i]*(x-c)^(i-1) for i ∈ 1:n)
d = solve(p-q, bs)
```


### Solving using logical operators

The `solve` function does not need to just solve `ex = 0`. There are other means to specify an equation. Ideally, it would be nice to say `ex1 == ex2`, but the interpretation of `==` is not for this. Rather, `SymPyCore` introduces `Eq` for equality. So this expression

```@repl introduction
solve(Eq(x, 1))
```

gives ``1``, as expected from solving `x == 1`.

!!! note "Equals"

    Mathematics uses `=` for equations. `Julia` uses `=` for assignment and `==` for generic equality, and `===` to test for identical values. There is no general infix equation operation in `Julia`, though `~` is used by the `Symbolics` package its ecosystem. SymPy uses `Eq` for expressing an equation. For `SymPyCore`, both `Eq` and `~` may be used to indicate an equation between unknowns.

In addition to `Eq`, there are `Lt`, `Le`, `Ge`, `Gt`. The Unicode
operators (e.g., `\leq`  and not  `\leq`)  are not aliased to these, but there are alternatives
`\ll[tab]`, `\leqq[tab]`, `\Equal[tab]`, `\geqq[tab]`, `\gg[tab]` and
`\neg[tab]` to negate.

So, the above could have been written with the following nearly identical expression, though it is entered with `\Equal[tab]`:

```@repl introduction
solve(x ⩵ 1)
```

Or as

```@repl introduction
solve(x ~ 1)
```

Here is an alternative way of asking a previous question on a pair of linear equations:

```@repl introduction
@syms x::real, y::real
exs = (2x+3y ~ 6, 3x-4y ~ 12)
d = solve(exs);
```

Here  is  one other way  to  express  the same

```@repl introduction
Eq.( (2x+3y,3x-4y), (6,12)) |>  solve == d
```

### Solving a linear recurrence

The `rsolve` function solves univariate recurrence with rational coefficients. It's use is like `solve`, though we need to qualify it, as the function does not have a `Julia`n counterpart:

```@repl introduction
@syms y() n
eqn = y(n) ~ y(n-1) + y(n-2)
sympy.rsolve(eqn ,y(n))
```

A possibly familiar solution to the Fibonacci pattern is produced.


## Matrices

A matrix of symbolic values could be represented in `Julia` as either a symbolic matrix or a matrix of symbolic elements. In `SymPy` the default is to use the latter:

```@repl introduction
@syms x y
A = [1 x; x^2 x^3]
```

The `getproperty` method for matrices with symbolic values is overridden to allow object methods to be called:

```@repl introduction
A.det()
```

In addition, many of the generic methods from the `LinearAlgebra` package will work, as shown here where the trace is taken:

```@repl introduction
using LinearAlgebra
tr(A)
```


To create symbolic matrices, a bit of work is needed, as `↑` converts symbolic matrices to matrices of symbolic values. Here are few ways

Using an immutable matrix will work, but we specify the matrix through a tuple of row vectors, as the `ImmutableMatrix` type of SymPy is preserved by `↑`:



```@repl introduction
B = [1 2 3; 3 4 5]
sympy.ImmutableMatrix(tuple(eachrow(B)...))
```

A mutable `Matrix` can be created by inhibiting the call to `↑` and calling `Sym` directly. (This is not recommended, as matrices with symbolic values require an extra call with `↓`.)

```@repl introduction
 Sym(↓(sympy).Matrix(tuple(eachrow(B)...)))
```


The `MatrixSymbol` feature of `SymPy` allows for the definition of sized matrices where the element values are not of interest:

```@repl introduction
A, B = sympy.MatrixSymbol("A", 2, 3), sympy.MatrixSymbol("B", 3, 1)
A * B
```

As seen, `A * B` is defined. The values can be seen through:

```@repl introduction
sympy.Matrix(A * B)
```

However, `B * A` will error:


```@repl introduction
try  B * A catch err "Error" end
```

## External packages

Using packages from the sympy ecosphere not imported into `SymPyCore` requires calling into the `_pyimport` method of the underlying module. Depending on which is being used. The following shows how the `WignerD` method can be called from the `sympy.physics.quantum.spin` module under `SymPyPythonCall`.

```
julia> spin = SymPyPythonCall._pyimport("sympy.physics.quantum.spin")

Julia> WignerD = spin.WignerD(1,1,0, pi, pi/2, 0)
Python: WignerD(1, 1, 0, 3.14159265358979, 1.5707963267949, 0)
```

This example flushes out some idiosyncracies: passing `PI` errors; the output is a python reference, call `Sym` to get a symbolic one.

Introductory Tutorial
=====================

!!! tip "Julia differences"

    This is a translation of the
	[SymPy Tutorial](https://docs.sympy.org/latest/tutorials/intro-tutorial/index.html)
	using the `SymPyCore` package for `Julia` to
	show the similarities and differences when calling into the Python package from `Julia`.
	This version of the tutorial is not endorsed by any member of the SymPy project.
	If its presence is believed to be inconsistent with the licensing of the original tutorial,
	notification would be appreciated.
	As much as possible, the Python text is kept and clarified through comments
	flagged with "Julia differences," though some minor formatting changes were made.

    Some notable differences using SymPy under `Julia`:

    * Julia uses `^` not `**` for exponentiation
    * Julia is ``1``-based, not ``0``-based
	* Julia uses `"` for strings, not `'`
    * The macro `@syms` is primarily used to create symbolic variables and functions, not `symbols`, though that function can be used.
    * Many sympy calls of the form `obj.method(args...)` are wrapped in the `Julian` style `method(obj, args...)`.
    * when methods are not wrapped, use `sympy.method` or `obj.method` as needed.
	* The name method in `Julia` is used for specializations of *generic* functions. The package wraps numerous generic methods from Base `Julia` specialized on the first argument being symbolic. (E.g., for the ``\sin`` function a definition like the following is provided: `Base.sin(x::Sym) = sympy.sin(x)`.)
	* method in sympy is used for an object method; A function like `sympy.method` is the underlying function from `SymPy`.)

	In this translation of the Python tutorial, `Julia` specific notes are contained in admonition boxes styled exactly like this one. The code shown is run (using `SymPyPythonCall`) and styled to look like the `Julia` REPL. The original Python code, is hidden with an expandable DIV tag. Footnotes were removed, as they aren't supported within Documenter.

This tutorial aims to give an introduction to SymPy for someone who has not
used the library before.  Many features of SymPy will be introduced in this
tutorial, but they will not be exhaustive. In fact, virtually every
functionality shown in this tutorial will have more options or capabilities
than what will be shown.  The rest of the SymPy documentation serves as API
documentation, which extensively lists every feature and option of each
function.

These are the goals of this tutorial:

!!! note "note bene"
    This is mainly here for you, the person who is editing and adding to
    this tutorial. Try to keep these principles in mind.

* To give a guide, suitable for someone who has never used SymPy (but who has
  used Python and knows the necessary mathematics).

* To be written in a narrative format, which is both easy and fun to follow.
  It should read like a book.

* To give insightful examples and exercises, to help the reader learn and to
  make it entertaining to work through.

* To introduce concepts in a logical order.

  In other words, don't try to get ahead of yourself.

* To use good practices and idioms, and avoid antipatterns.  Functions or
  methodologies that tend to lead to antipatterns are avoided. Features that
  are only useful to advanced users are not shown.

* To be consistent.  If there are multiple ways to do it, only the best way is
  shown.

  For example, there are at least five different ways to create Symbols.
   ``symbols`` is the only one that is general and doesn't lead to
   antipatterns, so it is the only one used.

* To avoid unnecessary duplication, it is assumed that previous sections of
  the tutorial have already been read.

Feedback on this tutorial, or on SymPy in general is always welcome. Just
write to our [mailing list](https://groups.google.com/forum/?fromgroups#!forum/sympy).

Matrices
==========

```@setup Julia
using SymPyPythonCall
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import *
    >>> init_printing(use_unicode=True)
```

```@raw html
</details>
```
----

To make a matrix in SymPy, use the `Matrix` object.  A matrix is constructed
by providing a list of row vectors that make up the matrix.  For example,
to construct the matrix

```math
\left[\begin{array}{cc}1 & -1\\3 & 4\\0 & 2\end{array}\right]
```

use

!!! tip "Julia differences"

    We have two ways to store matrices -- as a matrix of symbolic objects or as a symbolic wrapper around the underlying Python `Matrix` objects. The former gives access to Julia's common idioms, the latter access to SymPy's methods for matrices. `↓(M)` takes a matrix of symbolic values and returns a SymPy matrix object, `↑(𝑀)` does the reverse. The `getindex` notation for a matrix of symbolic values is overridden to call the SymPy method.  Matrices of symbolic objects can be created by adding `Sym` as a type hint; or more commonly occur by promotion when one or more entries is symbolic.

```@repl Julia
Sym[1 -1; 3 4; 0 2]
[Sym(1) -1; 3 4; 0 2]
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Matrix([[1, -1], [3, 4], [0, 2]])
    ⎡1  -1⎤
    ⎢     ⎥
    ⎢3  4 ⎥
    ⎢     ⎥
    ⎣0  2 ⎦
```

```@raw html
</details>
```
----

To make it easy to make column vectors, a list of elements is considered to be
a column vector.

!!! tip "Julia differences"

    This is different in `Julia`, as column syntax does not use commas.

```@repl Julia
Sym[1 2 3]
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Matrix([1, 2, 3])
    ⎡1⎤
    ⎢ ⎥
    ⎢2⎥
    ⎢ ⎥
    ⎣3⎦
```

```@raw html
</details>
```
----

Matrices are manipulated just like any other object in SymPy or Python.

!!! tip "Julia differences"

    The resulting matrix is just a matrix with symbolic elements, so is manipulated like any other matrix

```@repl Julia
M1 = Sym[1 2 3; 3 2 1]
M2 = Sym[0, 1, 1]  # can't use N
M1 * M2
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 2, 3], [3, 2, 1]])
    >>> N = Matrix([0, 1, 1])
    >>> M*N
    ⎡5⎤
    ⎢ ⎥
    ⎣3⎦
```

```@raw html
</details>
```
----

One important thing to note about SymPy matrices is that, unlike every other
object in SymPy, they are mutable.  This means that they can be modified in
place, as we will see below.  The downside to this is that `Matrix` cannot
be used in places that require immutability, such as inside other SymPy
expressions or as keys to dictionaries.  If you need an immutable version of
`Matrix`, use `ImmutableMatrix`.

Basic Operations
================

Here are some basic operations on `Matrix`.

Shape
-----

To get the shape of a matrix, use :func:`~.shape()` function.

!!! tip "Julia differences"

    We can use `Julia` generics or object methods of sympy

```@repl Julia
M = Sym[1 2 3; -2 0 4]
size(M)
M.shape
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import shape
    >>> M = Matrix([[1, 2, 3], [-2, 0, 4]])
    >>> M
    ⎡1   2  3⎤
    ⎢        ⎥
    ⎣-2  0  4⎦
    >>> shape(M)
    (2, 3)
```

```@raw html
</details>
```
----

Accessing Rows and Columns
--------------------------

To get an individual row or column of a matrix, use `row` or `col`.  For
example, `M.row(0)` will get the first row. `M.col(-1)` will get the last
column.

!!! tip "Julia differences"

    We use standard Julia notation for array access

```@repl Julia
M[1, :]
M[:, end]
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M.row(0)
    [1  2  3]
    >>> M.col(-1)
    ⎡3⎤
    ⎢ ⎥
    ⎣4⎦
```

```@raw html
</details>
```
----

Deleting and Inserting Rows and Columns
---------------------------------------

To delete a row or column, use `row_del` or `col_del`.  These operations
will modify the Matrix **in place**.

!!! tip "Julia differences"

    These mutation operations will work if the matrix is converted via  `↓` to an underlying Python matrix, but that is not illustrated here.

```@repl Julia
nothing
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M.col_del(0)
    >>> M
    ⎡2  3⎤
    ⎢    ⎥
    ⎣0  4⎦
    >>> M.row_del(1)
    >>> M
    [2  3]
```

```@raw html
</details>
```
----

!!! note "TODO"

    This is a mess. See issue 6992.

To insert rows or columns, use `row_insert` or `col_insert`.  These
operations **do not** operate in place.

!!! tip "Julia differences"

    One can use `Julia` idioms, but that is not illustrated

```@repl Julia
nothing
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M
    [2  3]
    >>> M = M.row_insert(1, Matrix([[0, 4]]))
    >>> M
    ⎡2  3⎤
    ⎢    ⎥
    ⎣0  4⎦
    >>> M = M.col_insert(0, Matrix([1, -2]))
    >>> M
    ⎡1   2  3⎤
    ⎢        ⎥
    ⎣-2  0  4⎦
```

```@raw html
</details>
```
----

Unless explicitly stated, the methods mentioned below do not operate in
place. In general, a method that does not operate in place will return a new
`Matrix` and a method that does operate in place will return `None`.

Basic Methods
=============

As noted above, simple operations like addition, multiplication and power are
done just by using `+`, `*`, and `**`.  To find the inverse of a matrix,
just raise it to the `-1` power.


```@repl Julia
M1, M2 = Sym[1 3; -2 3], Sym[0 3; 0 7]
M1 + M2
M1 * M2
3*M1
M1^2
inv(M2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 3], [-2, 3]])
    >>> N = Matrix([[0, 3], [0, 7]])
    >>> M + N
    ⎡1   6 ⎤
    ⎢      ⎥
    ⎣-2  10⎦
    >>> M*N
    ⎡0  24⎤
    ⎢     ⎥
    ⎣0  15⎦
    >>> 3*M
    ⎡3   9⎤
    ⎢     ⎥
    ⎣-6  9⎦
    >>> M**2
    ⎡-5  12⎤
    ⎢      ⎥
    ⎣-8  3 ⎦
    >>> M**-1
    ⎡1/3  -1/3⎤
    ⎢         ⎥
    ⎣2/9  1/9 ⎦
    >>> N**-1
    Traceback (most recent call last):
    ...
    NonInvertibleMatrixError: Matrix det == 0; not invertible.
```

```@raw html
</details>
```
----

To take the transpose of a Matrix, use `T`.

!!! tip "Julia differences"

    Use `'` for the adjoint, `transpose` for transpose

```@repl Julia
M = Sym[1 2 3; 4 5 6]
transpose(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 2, 3], [4, 5, 6]])
    >>> M
    ⎡1  2  3⎤
    ⎢       ⎥
    ⎣4  5  6⎦
    >>> M.T
    ⎡1  4⎤
    ⎢    ⎥
    ⎢2  5⎥
    ⎢    ⎥
    ⎣3  6⎦
```

```@raw html
</details>
```
----

Matrix Constructors
===================

Several constructors exist for creating common matrices.  To create an
identity matrix, use `eye`.  `eye(n)` will create an ``n\times n`` identity matrix.

!!! tip "Julia differences"

    This cnostructor is not exported, so needs to be qualified

```@repl Julia
sympy.eye(3)
sympy.eye(4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> eye(3)
    ⎡1  0  0⎤
    ⎢       ⎥
    ⎢0  1  0⎥
    ⎢       ⎥
    ⎣0  0  1⎦
    >>> eye(4)
    ⎡1  0  0  0⎤
    ⎢          ⎥
    ⎢0  1  0  0⎥
    ⎢          ⎥
    ⎢0  0  1  0⎥
    ⎢          ⎥
    ⎣0  0  0  1⎦
```

```@raw html
</details>
```
----

To create a matrix of all zeros, use `zeros`.  `zeros(n, m)` creates an
``n\times m`` matrix of ``0`` s.

!!! tip "Julia differences"

    This is more idiomatically done with a type:

```@repl Julia
zeros(Sym, 2, 3)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> zeros(2, 3)
    ⎡0  0  0⎤
    ⎢       ⎥
    ⎣0  0  0⎦
```

```@raw html
</details>
```
----

Similarly, `ones` creates a matrix of ones.


```@repl Julia
ones(Sym, 3, 4)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> ones(3, 2)
    ⎡1  1⎤
    ⎢    ⎥
    ⎢1  1⎥
    ⎢    ⎥
    ⎣1  1⎦
```

```@raw html
</details>
```
----

To create diagonal matrices, use `diag`.  The arguments to `diag` can be
either numbers or matrices.  A number is interpreted as a ``1\times 1``
matrix. The matrices are stacked diagonally.  The remaining elements are
filled with ``0`` s.

!!! tip "Julia differences"

    We qualify the use of `diag`, it is not exported. It has a different calling pattern than the `diag` method of the standard `LinearAlgebra` package.

```@repl Julia
sympy.diag(1,2,3)
sympy.diag(-1, ones(Sym, 2, 2), Sym[5,7,5])
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> diag(1, 2, 3)
    ⎡1  0  0⎤
    ⎢       ⎥
    ⎢0  2  0⎥
    ⎢       ⎥
    ⎣0  0  3⎦
    >>> diag(-1, ones(2, 2), Matrix([5, 7, 5]))
    ⎡-1  0  0  0⎤
    ⎢           ⎥
    ⎢0   1  1  0⎥
    ⎢           ⎥
    ⎢0   1  1  0⎥
    ⎢           ⎥
    ⎢0   0  0  5⎥
    ⎢           ⎥
    ⎢0   0  0  7⎥
    ⎢           ⎥
    ⎣0   0  0  5⎦
```

```@raw html
</details>
```
----

Advanced Methods
================

Determinant
-----------

To compute the determinant of a matrix, use `det`.

!!! tip "Julia differences"

    This can be called using `det` (if the `LinearAlgebra` package is loaded) or as a method

```@repl Julia
M = Sym[1 0 1; 2 -1 3; 4 3 2]
M.det()
using LinearAlgebra
det(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 0, 1], [2, -1, 3], [4, 3, 2]])
    >>> M
    ⎡1  0   1⎤
    ⎢        ⎥
    ⎢2  -1  3⎥
    ⎢        ⎥
    ⎣4  3   2⎦
    >>> M.det()
    -1
```

```@raw html
</details>
```
----
RREF
----

To put a matrix into reduced row echelon form, use `rref`.  `rref` returns
a tuple of two elements. The first is the reduced row echelon form, and the
second is a tuple of indices of the pivot columns.


```@repl Julia
M = Sym[1 0 1 3; 2 3 4 7; -1 -3 -3 -4]
M.rref()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 0, 1, 3], [2, 3, 4, 7], [-1, -3, -3, -4]])
    >>> M
    ⎡1   0   1   3 ⎤
    ⎢              ⎥
    ⎢2   3   4   7 ⎥
    ⎢              ⎥
    ⎣-1  -3  -3  -4⎦
    >>> M.rref()
    ⎛⎡1  0   1    3 ⎤        ⎞
    ⎜⎢              ⎥        ⎟
    ⎜⎢0  1  2/3  1/3⎥, (0, 1)⎟
    ⎜⎢              ⎥        ⎟
    ⎝⎣0  0   0    0 ⎦        ⎠
```

```@raw html
</details>
```
----

!!! note
    The first element of the tuple returned by `rref` is of type `Matrix`. The second is of type `tuple`.

Nullspace
---------

To find the nullspace of a matrix, use `nullspace`. `nullspace` returns a
`list` of column vectors that span the nullspace of the matrix.



```@repl Julia
M = Sym[1 2 3 0 0; 4 10 0 0 1]
M.nullspace()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 2, 3, 0, 0], [4, 10, 0, 0, 1]])
    >>> M
    ⎡1  2   3  0  0⎤
    ⎢              ⎥
    ⎣4  10  0  0  1⎦
    >>> M.nullspace()
    ⎡⎡-15⎤  ⎡0⎤  ⎡ 1  ⎤⎤
    ⎢⎢   ⎥  ⎢ ⎥  ⎢    ⎥⎥
    ⎢⎢ 6 ⎥  ⎢0⎥  ⎢-1/2⎥⎥
    ⎢⎢   ⎥  ⎢ ⎥  ⎢    ⎥⎥
    ⎢⎢ 1 ⎥, ⎢0⎥, ⎢ 0  ⎥⎥
    ⎢⎢   ⎥  ⎢ ⎥  ⎢    ⎥⎥
    ⎢⎢ 0 ⎥  ⎢1⎥  ⎢ 0  ⎥⎥
    ⎢⎢   ⎥  ⎢ ⎥  ⎢    ⎥⎥
    ⎣⎣ 0 ⎦  ⎣0⎦  ⎣ 1  ⎦⎦
```

```@raw html
</details>
```
----

Columnspace
-----------

To find the columnspace of a matrix, use `columnspace`. `columnspace` returns a
`list` of column vectors that span the columnspace of the matrix.


```@repl Julia
M = Sym[1 1 2; 2 1 3; 3 1 4]
M.columnspace()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[1, 1, 2], [2 ,1 , 3], [3 , 1, 4]])
    >>> M
    ⎡1  1  2⎤
    ⎢       ⎥
    ⎢2  1  3⎥
    ⎢       ⎥
    ⎣3  1  4⎦
    >>> M.columnspace()
    ⎡⎡1⎤  ⎡1⎤⎤
    ⎢⎢ ⎥  ⎢ ⎥⎥
    ⎢⎢2⎥, ⎢1⎥⎥
    ⎢⎢ ⎥  ⎢ ⎥⎥
    ⎣⎣3⎦  ⎣1⎦⎦
```

```@raw html
</details>
```
----

Eigenvalues, Eigenvectors, and Diagonalization
----------------------------------------------

To find the eigenvalues of a matrix, use `eigenvals`.  `eigenvals`
returns a dictionary of `eigenvalue: algebraic_multiplicity` pairs (similar to the
output of [roots](./solvers#tutorial-roots)).

!!! tip "Julia differences"

    The `LinearAlgebra` generic functions have methods `eigvals` and `eigvecs` for this task

```@repl Julia
M = Sym[3 -2 4 -2; 5 3 -3 -2; 5 -2 2 -2; 5 -2 -3 3]
eigvals(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix([[3, -2,  4, -2], [5,  3, -3, -2], [5, -2,  2, -2], [5, -2, -3,  3]])
    >>> M
    ⎡3  -2  4   -2⎤
    ⎢             ⎥
    ⎢5  3   -3  -2⎥
    ⎢             ⎥
    ⎢5  -2  2   -2⎥
    ⎢             ⎥
    ⎣5  -2  -3  3 ⎦
    >>> M.eigenvals()
    {-2: 1, 3: 1, 5: 2}
```

```@raw html
</details>
```
----

This means that `M` has eigenvalues -2, 3, and 5, and that the
eigenvalues -2 and 3 have algebraic multiplicity 1 and that the eigenvalue 5
has algebraic multiplicity 2.

To find the eigenvectors of a matrix, use `eigenvects`.  `eigenvects`
returns a list of tuples of the form `(eigenvalue, algebraic_multiplicity,
[eigenvectors])`.


```@repl Julia
eigvecs(M)
M.eigenvects()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M.eigenvects()
    ⎡⎛       ⎡⎡0⎤⎤⎞  ⎛      ⎡⎡1⎤⎤⎞  ⎛      ⎡⎡1⎤  ⎡0 ⎤⎤⎞⎤
    ⎢⎜       ⎢⎢ ⎥⎥⎟  ⎜      ⎢⎢ ⎥⎥⎟  ⎜      ⎢⎢ ⎥  ⎢  ⎥⎥⎟⎥
    ⎢⎜       ⎢⎢1⎥⎥⎟  ⎜      ⎢⎢1⎥⎥⎟  ⎜      ⎢⎢1⎥  ⎢-1⎥⎥⎟⎥
    ⎢⎜-2, 1, ⎢⎢ ⎥⎥⎟, ⎜3, 1, ⎢⎢ ⎥⎥⎟, ⎜5, 2, ⎢⎢ ⎥, ⎢  ⎥⎥⎟⎥
    ⎢⎜       ⎢⎢1⎥⎥⎟  ⎜      ⎢⎢1⎥⎥⎟  ⎜      ⎢⎢1⎥  ⎢0 ⎥⎥⎟⎥
    ⎢⎜       ⎢⎢ ⎥⎥⎟  ⎜      ⎢⎢ ⎥⎥⎟  ⎜      ⎢⎢ ⎥  ⎢  ⎥⎥⎟⎥
    ⎣⎝       ⎣⎣1⎦⎦⎠  ⎝      ⎣⎣1⎦⎦⎠  ⎝      ⎣⎣0⎦  ⎣1 ⎦⎦⎠⎦
```

```@raw html
</details>
```
----

This shows us that, for example, the eigenvalue 5 also has geometric
multiplicity 2, because it has two eigenvectors.  Because the algebraic and
geometric multiplicities are the same for all the eigenvalues, `M` is
diagonalizable.

To diagonalize a matrix, use `diagonalize`. `diagonalize` returns a tuple
`(P, D)`, where `D` is diagonal and `M = PDP^{-1}`.


```@repl Julia
P, D = M.diagonalize()
P * D * inv(P)
P * D * inv(P) == M
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> P, D = M.diagonalize()
    >>> P
    ⎡0  1  1  0 ⎤
    ⎢           ⎥
    ⎢1  1  1  -1⎥
    ⎢           ⎥
    ⎢1  1  1  0 ⎥
    ⎢           ⎥
    ⎣1  1  0  1 ⎦
    >>> D
    ⎡-2  0  0  0⎤
    ⎢           ⎥
    ⎢0   3  0  0⎥
    ⎢           ⎥
    ⎢0   0  5  0⎥
    ⎢           ⎥
    ⎣0   0  0  5⎦
    >>> P*D*P**-1
    ⎡3  -2  4   -2⎤
    ⎢             ⎥
    ⎢5  3   -3  -2⎥
    ⎢             ⎥
    ⎢5  -2  2   -2⎥
    ⎢             ⎥
    ⎣5  -2  -3  3 ⎦
    >>> P*D*P**-1 == M
    True
```

```@raw html
</details>
```
----

!!! note "Quick Tip"

    `lambda` is a reserved keyword in Python, so to create a Symbol called
    ``\lambda``, while using the same names for SymPy Symbols and Python
    variables, use `lamda` (without the `b`).  It will still pretty print
    as ``\lambda``.

Note that since `eigenvects` also includes the eigenvalues, you should use
it instead of `eigenvals` if you also want the eigenvectors. However, as
computing the eigenvectors may often be costly, `eigenvals` should be
preferred if you only wish to find the eigenvalues.

If all you want is the characteristic polynomial, use `charpoly`.  This is
more efficient than `eigenvals`, because sometimes symbolic roots can be
expensive to calculate.



```@repl Julia
@syms lambda => "λ"
p = M.charpoly(lambda)
factor(p.as_expr())
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> lamda = symbols('lamda')
    >>> p = M.charpoly(lamda)
    >>> factor(p.as_expr())
           2
    (λ - 5) ⋅(λ - 3)⋅(λ + 2)
```

```@raw html
</details>
```
----

!!! note "TODO"
    Add an example for `jordan_form`, once it is fully implemented.

Possible Issues
===============

Zero Testing
------------

If your matrix operations are failing or returning wrong answers,
the common reasons would likely be from zero testing.
If there is an expression not properly zero-tested,
it can possibly bring issues in finding pivots for gaussian elimination,
or deciding whether the matrix is inversible,
or any high level functions which relies on the prior procedures.

Currently, the SymPy's default method of zero testing `_iszero` is only
guaranteed to be accurate in some limited domain of numerics and symbols,
and any complicated expressions beyond its decidability are treated as `None`,
which behaves similarly to logical `False`.

The list of methods using zero testing procedures are as follows:

`echelon_form` , `is_echelon` , `rank` , `rref` , `nullspace` ,
`eigenvects` , `inverse_ADJ` , `inverse_GE` , `inverse_LU` ,
`LUdecomposition` , `LUdecomposition_Simple` , `LUsolve`

They have property `iszerofunc` opened up for user to specify zero testing
method, which can accept any function with single input and boolean output,
while being defaulted with `_iszero`.

Here is an example of solving an issue caused by undertested zero. While the
output for this particular matrix has since been improved, the technique
below is still of interest.


```@repl Julia
@syms q::positive
M = [-2cosh(q/3) exp(-q) 1; exp(q) -2cosh(q/3) 1; 1 1 -2cosh(q/3)]
M.nullspace()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import *
    >>> q = Symbol("q", positive = True)
    >>> m = Matrix([
    ... [-2*cosh(q/3),      exp(-q),            1],
    ... [      exp(q), -2*cosh(q/3),            1],
    ... [           1,            1, -2*cosh(q/3)]])
    >>> m.nullspace() # doctest: +SKIP
    []
```

```@raw html
</details>
```
----

You can trace down which expression is being underevaluated,
by injecting a custom zero test with warnings enabled.


```@repl Julia
my_iszero(x) = x.is_zero
my_iszero.(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> import warnings
    >>>
    >>> def my_iszero(x):
    ...     try:
    ...         result = x.is_zero
    ...     except AttributeError:
    ...         result = None
    ...
    ...     # Warnings if evaluated into None
    ...     if result is None:
    ...         warnings.warn("Zero testing of {} evaluated into None".format(x))
    ...     return result
    ...
    >>> m.nullspace(iszerofunc=my_iszero) # doctest: +SKIP
    __main__:9: UserWarning: Zero testing of 4*cosh(q/3)**2 - 1 evaluated into None
    __main__:9: UserWarning: Zero testing of (-exp(q) - 2*cosh(q/3))*(-2*cosh(q/3) - exp(-q)) - (4*cosh(q/3)**2 - 1)**2 evaluated into None
    __main__:9: UserWarning: Zero testing of 2*exp(q)*cosh(q/3) - 16*cosh(q/3)**4 + 12*cosh(q/3)**2 + 2*exp(-q)*cosh(q/3) evaluated into None
    __main__:9: UserWarning: Zero testing of -(4*cosh(q/3)**2 - 1)*exp(-q) - 2*cosh(q/3) - exp(-q) evaluated into None
    []
```

```@raw html
</details>
```
----

In this case,
`(-exp(q) - 2*cosh(q/3))*(-2*cosh(q/3) - exp(-q)) - (4*cosh(q/3)**2 - 1)**2`
should yield zero, but the zero testing had failed to catch.
possibly meaning that a stronger zero test should be introduced.
For this specific example, rewriting to exponentials and applying simplify would
make zero test stronger for hyperbolics,
while being harmless to other polynomials or transcendental functions.

!!! tip "Julia differences"

    We use broadcasting over the matrix

```@repl Julia
my_iszero(x) = x.rewrite(exp).simplify().is_zero
my_iszero.(M)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> def my_iszero(x):
    ...     try:
    ...         result = x.rewrite(exp).simplify().is_zero
    ...     except AttributeError:
    ...         result = None
    ...
    ...     # Warnings if evaluated into None
    ...     if result is None:
    ...         warnings.warn("Zero testing of {} evaluated into None".format(x))
    ...     return result
    ...
    >>> m.nullspace(iszerofunc=my_iszero) # doctest: +SKIP
    __main__:9: UserWarning: Zero testing of -2*cosh(q/3) - exp(-q) evaluated into None
    ⎡⎡  ⎛   q         ⎛q⎞⎞  -q         2⎛q⎞    ⎤⎤
    ⎢⎢- ⎜- ℯ  - 2⋅cosh⎜─⎟⎟⋅ℯ   + 4⋅cosh ⎜─⎟ - 1⎥⎥
    ⎢⎢  ⎝             ⎝3⎠⎠              ⎝3⎠    ⎥⎥
    ⎢⎢─────────────────────────────────────────⎥⎥
    ⎢⎢          ⎛      2⎛q⎞    ⎞     ⎛q⎞       ⎥⎥
    ⎢⎢        2⋅⎜4⋅cosh ⎜─⎟ - 1⎟⋅cosh⎜─⎟       ⎥⎥
    ⎢⎢          ⎝       ⎝3⎠    ⎠     ⎝3⎠       ⎥⎥
    ⎢⎢                                         ⎥⎥
    ⎢⎢           ⎛   q         ⎛q⎞⎞            ⎥⎥
    ⎢⎢          -⎜- ℯ  - 2⋅cosh⎜─⎟⎟            ⎥⎥
    ⎢⎢           ⎝             ⎝3⎠⎠            ⎥⎥
    ⎢⎢          ────────────────────           ⎥⎥
    ⎢⎢                   2⎛q⎞                  ⎥⎥
    ⎢⎢             4⋅cosh ⎜─⎟ - 1              ⎥⎥
    ⎢⎢                    ⎝3⎠                  ⎥⎥
    ⎢⎢                                         ⎥⎥
    ⎣⎣                    1                    ⎦⎦
```

```@raw html
</details>
```
----

You can clearly see `nullspace` returning proper result, after injecting an
alternative zero test.

Note that this approach is only valid for some limited cases of matrices
containing only numerics, hyperbolics, and exponentials.
For other matrices, you should use different method opted for their domains.

Possible suggestions would be either taking advantage of rewriting and
simplifying, with tradeoff of speed,
or using random numeric testing, with tradeoff of accuracy.

If you wonder why there is no generic algorithm for zero testing that can work
with any symbolic entities,
it's because of the constant problem stating that zero testing is undecidable,
and not only the SymPy, but also other computer algebra systems
would face the same fundamental issue.

However, discovery of any zero test failings can provide some good examples to
improve SymPy,
so if you have encountered one, you can report the issue to
SymPy issue tracker to get detailed help from the community.

!!! note "Footnotes"

    * Inspired by https://gitter.im/sympy/sympy?at=5b7c3e8ee5b40332abdb206c

    * Discovered from https://github.com/sympy/sympy/issues/15141

    *  Improved by https://github.com/sympy/sympy/pull/19548

    * Suggested from https://github.com/sympy/sympy/issues/10120

    *  Suggested from https://github.com/sympy/sympy/issues/10279

    * https://en.wikipedia.org/wiki/Constant_problem

    *  How mathematica tests zero https://reference.wolfram.com/language/ref/PossibleZeroQ.html

    *  How matlab tests zero https://web.archive.org/web/20200307091449/https://www.mathworks.com/help/symbolic/mupad_ref/iszero.html

    * https://github.com/sympy/sympy/issues

Advanced Expression Manipulation
==================================

```@setup Julia
using SymPyPythonCall
```

In this section, we discuss some ways that we can perform advanced
manipulation of expressions.


Understanding Expression Trees
==============================

Before we can do this, we need to understand how expressions are represented
in SymPy.  A mathematical expression is represented as a tree.  Let us take
the expression `x^2 + xy`, i.e., `x**2 + x*y`.  We can see what this
expression looks like internally by using `srepr`

!!! tip "Julia differences"

    The `srepr` function needs qualification

```@repl Julia
@syms x, y, z
expr = x^2 + x*y
sympy.srepr(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import *
    >>> x, y, z = symbols('x y z')

    >>> expr = x**2 + x*y
    >>> srepr(expr)
    "Add(Pow(Symbol('x'), Integer(2)), Mul(Symbol('x'), Symbol('y')))"
```
```@raw html
</details>
```
----


The easiest way to tear this apart is to look at a diagram of the expression
tree:

!!! tip "Julia differences"

    The diagram is not presented here

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
.. This comes from dotprint(x**2 + x*y, labelfunc=srepr)

.. graphviz::

    digraph{

    # Graph style
    "ordering"="out"
    "rankdir"="TD"

    #########
    # Nodes #
    #########

    "Add(Pow(Symbol('x'), Integer(2)), Mul(Symbol('x'), Symbol('y')))_()" ["color"="black", "label"="Add", "shape"="ellipse"];
    "Pow(Symbol('x'), Integer(2))_(0,)" ["color"="black", "label"="Pow", "shape"="ellipse"];
    "Symbol('x')_(0, 0)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Integer(2)_(0, 1)" ["color"="black", "label"="Integer(2)", "shape"="ellipse"];
    "Mul(Symbol('x'), Symbol('y'))_(1,)" ["color"="black", "label"="Mul", "shape"="ellipse"];
    "Symbol('x')_(1, 0)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Symbol('y')_(1, 1)" ["color"="black", "label"="Symbol('y')", "shape"="ellipse"];

    #########
    # Edges #
    #########

    "Add(Pow(Symbol('x'), Integer(2)), Mul(Symbol('x'), Symbol('y')))_()" -> "Pow(Symbol('x'), Integer(2))_(0,)";
    "Add(Pow(Symbol('x'), Integer(2)), Mul(Symbol('x'), Symbol('y')))_()" -> "Mul(Symbol('x'), Symbol('y'))_(1,)";
    "Pow(Symbol('x'), Integer(2))_(0,)" -> "Symbol('x')_(0, 0)";
    "Pow(Symbol('x'), Integer(2))_(0,)" -> "Integer(2)_(0, 1)";
    "Mul(Symbol('x'), Symbol('y'))_(1,)" -> "Symbol('x')_(1, 0)";
    "Mul(Symbol('x'), Symbol('y'))_(1,)" -> "Symbol('y')_(1, 1)";
    }
```
```@raw html
</details>
```
----


!!! note

    The above diagram was made using [Graphviz](https://www.graphviz.org/) and
    the [dotprint](sympy.printing.dot.dotprint) function.

First, let's look at the leaves of this tree.  Symbols are instances of the
class Symbol.  While we have been doing

```@repl Julia
@syms x
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x = symbols('x')
```
```@raw html
</details>
```
----


we could have also done


```@repl Julia
x = symbols("x")
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> x = Symbol('x')
```
```@raw html
</details>
```
----


Either way, we get a Symbol with the name "`x`".  For the number in the
expression, 2, we got `Integer(2)`.  `Integer` is the SymPy class for
integers.  It is similar to the Python built-in type `int`, except that
`Integer` plays nicely with other SymPy types.

When we write `x**2`, this creates a `Pow` object.  `Pow` is short for
"power".


```@repl Julia
sympy.srepr(x^2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> srepr(x**2)
    "Pow(Symbol('x'), Integer(2))"
```
```@raw html
</details>
```
----


We could have created the same object by calling `Pow(x, 2)`


```@repl Julia
sympy.Pow(x, 2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Pow(x, 2)
    x**2
```
```@raw html
</details>
```
----


Note that in the `srepr` output, we see `Integer(2)`, the SymPy version of
integers, even though technically, we input `2`, a Python int.  In general,
whenever you combine a SymPy object with a non-SymPy object via some function
or operation, the non-SymPy object will be converted into a SymPy object.  The
function that does this is `sympify`.

!!! tip "Julia differences"

    Using `Sym(2)` is more idiomatic. It uses `sympify`, though a more performant means would be to create a Python object (which differs between `PyCall` (`PyObject(2)`) and `PythonCall` (`Py(2)`)) and call `Sym` on that.


```@repl Julia
sympify(2)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> type(2)
    <... 'int'>
    >>> type(sympify(2))
    <class 'sympy.core.numbers.Integer'>
```
```@raw html
</details>
```
----


We have seen that `x**2` is represented as `Pow(x, 2)`.  What about
`x*y`?  As we might expect, this is the multiplication of `x` and `y`.
The SymPy class for multiplication is `Mul`.


```@repl Julia
sympy.srepr(x * y)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> srepr(x*y)
    "Mul(Symbol('x'), Symbol('y'))"
```
```@raw html
</details>
```
----


Thus, we could have created the same object by writing `Mul(x, y)`.


```@repl Julia
sympy.Mul(x, y)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Mul(x, y)
    x*y
```
```@raw html
</details>
```
----


Now we get to our final expression, `x**2 + x*y`.  This is the addition of
our last two objects, `Pow(x, 2)`, and `Mul(x, y)`.  The SymPy class for
addition is `Add`, so, as you might expect, to create this object, we use
`Add(Pow(x, 2), Mul(x, y))`.


```@repl Julia
sympy.Add(sympy.Pow(x, 2), sympy.Mul(x, y))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Add(Pow(x, 2), Mul(x, y))
    x**2 + x*y
```
```@raw html
</details>
```
----


SymPy expression trees can have many branches, and can be quite deep or quite
broad.  Here is a more complicated example


```@repl Julia
expr = sin(x*2)/2 - x^2 + 1/y
sympy.srepr(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = sin(x*y)/2 - x**2 + 1/y
    >>> srepr(expr)
    "Add(Mul(Integer(-1), Pow(Symbol('x'), Integer(2))), Mul(Rational(1, 2),
    sin(Mul(Symbol('x'), Symbol('y')))), Pow(Symbol('y'), Integer(-1)))"
```
```@raw html
</details>
```
----


Here is a diagram

!!! tip "Julia differences"

    This is not present in this translation

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
.. dotprint(sin(x*y)/2 - x**2 + 1/y, labelfunc=srepr)

.. graphviz::

    digraph{

    # Graph style
    "rankdir"="TD"

    #########
    # Nodes #
    #########

    "Half()_(0, 0)" ["color"="black", "label"="Rational(1, 2)", "shape"="ellipse"];
    "Symbol(y)_(2, 0)" ["color"="black", "label"="Symbol('y')", "shape"="ellipse"];
    "Symbol(x)_(1, 1, 0)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Integer(2)_(1, 1, 1)" ["color"="black", "label"="Integer(2)", "shape"="ellipse"];
    "NegativeOne()_(2, 1)" ["color"="black", "label"="Integer(-1)", "shape"="ellipse"];
    "NegativeOne()_(1, 0)" ["color"="black", "label"="Integer(-1)", "shape"="ellipse"];
    "Symbol(y)_(0, 1, 0, 1)" ["color"="black", "label"="Symbol('y')", "shape"="ellipse"];
    "Symbol(x)_(0, 1, 0, 0)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Pow(Symbol(x), Integer(2))_(1, 1)" ["color"="black", "label"="Pow", "shape"="ellipse"];
    "Pow(Symbol(y), NegativeOne())_(2,)" ["color"="black", "label"="Pow", "shape"="ellipse"];
    "Mul(Symbol(x), Symbol(y))_(0, 1, 0)" ["color"="black", "label"="Mul", "shape"="ellipse"];
    "sin(Mul(Symbol(x), Symbol(y)))_(0, 1)" ["color"="black", "label"="sin", "shape"="ellipse"];
    "Mul(Half(), sin(Mul(Symbol(x), Symbol(y))))_(0,)" ["color"="black", "label"="Mul", "shape"="ellipse"];
    "Mul(NegativeOne(), Pow(Symbol(x), Integer(2)))_(1,)" ["color"="black", "label"="Mul", "shape"="ellipse"];
    "Add(Mul(Half(), sin(Mul(Symbol(x), Symbol(y)))), Mul(NegativeOne(), Pow(Symbol(x), Integer(2))), Pow(Symbol(y), NegativeOne()))_()" ["color"="black", "label"="Add", "shape"="ellipse"];

    #########
    # Edges #
    #########

    "Pow(Symbol(y), NegativeOne())_(2,)" -> "Symbol(y)_(2, 0)";
    "Pow(Symbol(x), Integer(2))_(1, 1)" -> "Symbol(x)_(1, 1, 0)";
    "Pow(Symbol(x), Integer(2))_(1, 1)" -> "Integer(2)_(1, 1, 1)";
    "Pow(Symbol(y), NegativeOne())_(2,)" -> "NegativeOne()_(2, 1)";
    "Mul(Symbol(x), Symbol(y))_(0, 1, 0)" -> "Symbol(x)_(0, 1, 0, 0)";
    "Mul(Symbol(x), Symbol(y))_(0, 1, 0)" -> "Symbol(y)_(0, 1, 0, 1)";
    "Mul(Half(), sin(Mul(Symbol(x), Symbol(y))))_(0,)" -> "Half()_(0, 0)";
    "Mul(NegativeOne(), Pow(Symbol(x), Integer(2)))_(1,)" -> "NegativeOne()_(1, 0)";
    "sin(Mul(Symbol(x), Symbol(y)))_(0, 1)" -> "Mul(Symbol(x), Symbol(y))_(0, 1, 0)";
    "Mul(NegativeOne(), Pow(Symbol(x), Integer(2)))_(1,)" -> "Pow(Symbol(x), Integer(2))_(1, 1)";
    "Mul(Half(), sin(Mul(Symbol(x), Symbol(y))))_(0,)" -> "sin(Mul(Symbol(x), Symbol(y)))_(0, 1)";
    "Add(Mul(Half(), sin(Mul(Symbol(x), Symbol(y)))), Mul(NegativeOne(), Pow(Symbol(x), Integer(2))), Pow(Symbol(y), NegativeOne()))_()" -> "Pow(Symbol(y), NegativeOne())_(2,)";
    "Add(Mul(Half(), sin(Mul(Symbol(x), Symbol(y)))), Mul(NegativeOne(), Pow(Symbol(x), Integer(2))), Pow(Symbol(y), NegativeOne()))_()" -> "Mul(Half(), sin(Mul(Symbol(x), Symbol(y))))_(0,)";
    "Add(Mul(Half(), sin(Mul(Symbol(x), Symbol(y)))), Mul(NegativeOne(), Pow(Symbol(x), Integer(2))), Pow(Symbol(y), NegativeOne()))_()" -> "Mul(NegativeOne(), Pow(Symbol(x), Integer(2)))_(1,)";
    }
```
```@raw html
</details>
```
----


This expression reveals some interesting things about SymPy expression
trees. Let's go through them one by one.

Let's first look at the term `x**2`.  As we expected, we see `Pow(x, 2)`.
One level up, we see we have `Mul(-1, Pow(x, 2))`.  There is no subtraction
class in SymPy.  `x - y` is represented as `x + -y`, or, more completely,
`x + -1*y`, i.e., `Add(x, Mul(-1, y))`.


```@repl Julia
sympy.srepr(x - y)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> srepr(x - y)
    "Add(Symbol('x'), Mul(Integer(-1), Symbol('y')))"
```
```@raw html
</details>
```
----



----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
.. dotprint(x - y, labelfunc=srepr)

.. graphviz::

    digraph{

    # Graph style
    "rankdir"="TD"

    #########
    # Nodes #
    #########

    "Symbol(x)_(1,)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Symbol(y)_(0, 1)" ["color"="black", "label"="Symbol('y')", "shape"="ellipse"];
    "NegativeOne()_(0, 0)" ["color"="black", "label"="Integer(-1)", "shape"="ellipse"];
    "Mul(NegativeOne(), Symbol(y))_(0,)" ["color"="black", "label"="Mul", "shape"="ellipse"];
    "Add(Mul(NegativeOne(), Symbol(y)), Symbol(x))_()" ["color"="black", "label"="Add", "shape"="ellipse"];

    #########
    # Edges #
    #########

    "Mul(NegativeOne(), Symbol(y))_(0,)" -> "Symbol(y)_(0, 1)";
    "Mul(NegativeOne(), Symbol(y))_(0,)" -> "NegativeOne()_(0, 0)";
    "Add(Mul(NegativeOne(), Symbol(y)), Symbol(x))_()" -> "Symbol(x)_(1,)";
    "Add(Mul(NegativeOne(), Symbol(y)), Symbol(x))_()" -> "Mul(NegativeOne(), Symbol(y))_(0,)";
    }
```
```@raw html
</details>
```
----


Next, look at `1/y`.  We might expect to see something like `Div(1, y)`,
but similar to subtraction, there is no class in SymPy for division.  Rather,
division is represented by a power of -1.  Hence, we have `Pow(y, -1)`.
What if we had divided something other than 1 by `y`, like `x/y`?  Let's
see.


```@repl Julia
expr = x / y
sympy.srepr(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = x/y
    >>> srepr(expr)
    "Mul(Symbol('x'), Pow(Symbol('y'), Integer(-1)))"
```
```@raw html
</details>
```
----



----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
.. dotprint(x/y, labelfunc=srepr)

.. graphviz::

    digraph{

    # Graph style
    "rankdir"="TD"

    #########
    # Nodes #
    #########

    "Symbol(x)_(0,)" ["color"="black", "label"="Symbol('x')", "shape"="ellipse"];
    "Symbol(y)_(1, 0)" ["color"="black", "label"="Symbol('y')", "shape"="ellipse"];
    "NegativeOne()_(1, 1)" ["color"="black", "label"="Integer(-1)", "shape"="ellipse"];
    "Pow(Symbol(y), NegativeOne())_(1,)" ["color"="black", "label"="Pow", "shape"="ellipse"];
    "Mul(Symbol(x), Pow(Symbol(y), NegativeOne()))_()" ["color"="black", "label"="Mul", "shape"="ellipse"];

    #########
    # Edges #
    #########

    "Pow(Symbol(y), NegativeOne())_(1,)" -> "Symbol(y)_(1, 0)";
    "Pow(Symbol(y), NegativeOne())_(1,)" -> "NegativeOne()_(1, 1)";
    "Mul(Symbol(x), Pow(Symbol(y), NegativeOne()))_()" -> "Symbol(x)_(0,)";
    "Mul(Symbol(x), Pow(Symbol(y), NegativeOne()))_()" -> "Pow(Symbol(y), NegativeOne())_(1,)";
    }
```
```@raw html
</details>
```
----


We see that `x/y` is represented as `x*y**-1`, i.e., `Mul(x, Pow(y,
-1))`.

Finally, let's look at the `sin(x*y)/2` term.  Following the pattern of the
previous example, we might expect to see `Mul(sin(x*y), Pow(Integer(2),
-1))`.  But instead, we have `Mul(Rational(1, 2), sin(x*y))`.  Rational
numbers are always combined into a single term in a multiplication, so that
when we divide by 2, it is represented as multiplying by 1/2.

Finally, one last note.  You may have noticed that the order we entered our
expression and the order that it came out from `srepr` or in the graph were
different.  You may have also noticed this phenomenon earlier in the
tutorial.  For example

```@repl Julia
1 + x
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
     >>> 1 + x
     x + 1
```
```@raw html
</details>
```
----


This because in SymPy, the arguments of the commutative operations `Add` and
`Mul` are stored in an arbitrary (but consistent!) order, which is
independent of the order inputted (if you're worried about noncommutative
multiplication, don't be.  In SymPy, you can create noncommutative Symbols
using `Symbol('A', commutative=False)`, and the order of multiplication for
noncommutative Symbols is kept the same as the input).  Furthermore, as we
shall see in the next section, the printing order and the order in which
things are stored internally need not be the same either.

!!! note "Quick Tip"

    The way an expression is represented internally and the way it is printed
    are often not the same.

In general, an important thing to keep in mind when working with SymPy expression
trees is this:  the internal representation of an expression and the way it is
printed need not be the same.  The same is true for the input form.   If some
expression manipulation algorithm is not working in the way you expected it
to, chances are, the internal representation of the object is different from
what you thought it was.

Recursing through an Expression Tree
====================================

Now that you know how expression trees work in SymPy, let's look at how to dig
our way through an expression tree.  Every object in SymPy has two very
important attributes, `func`, and `args`.


func
----

`func` is the head of the object. For example, `(x*y).func` is `Mul`.
Usually it is the same as the class of the object (though there are exceptions
to this rule).

Two notes about `func`.  First, the class of an object need not be the same
as the one used to create it.  For example

!!! tip "Julia differences"

    The `Introspection.func` methods (and others) allows a more `Julia`n calling style

```@repl Julia
expr = sympy.Add(x,x)
Introspection.func(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = Add(x, x)
    >>> expr.func
    <class 'sympy.core.mul.Mul'>
```
```@raw html
</details>
```
----


We created `Add(x, x)`, so we might expect `expr.func` to be `Add`, but
instead we got `Mul`.  Why is that?  Let's take a closer look at `expr`.


```@repl Julia
expr
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr
    2*x
```
```@raw html
</details>
```
----


`Add(x, x)`, i.e., `x + x`, was automatically converted into `Mul(2,
x)`, i.e., `2*x`, which is a `Mul`.   SymPy classes make heavy use of the
`__new__` class constructor, which, unlike `__init__`, allows a different
class to be returned from the constructor.

Second, some classes are special-cased, usually for efficiency reasons.

```@repl Julia
Introspection.func(Sym(2))
Introspection.func(Sym(0))
Introspection.func(Sym(-1))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Integer(2).func
    <class 'sympy.core.numbers.Integer'>
    >>> Integer(0).func
    <class 'sympy.core.numbers.Zero'>
    >>> Integer(-1).func
    <class 'sympy.core.numbers.NegativeOne'>
```
```@raw html
</details>
```
----


For the most part, these issues will not bother us.  The special classes
`Zero`, `One`, `NegativeOne`, and so on are subclasses of `Integer`,
so as long as you use `isinstance`, it will not be an issue.

args
----

`args` are the top-level arguments of the object.  `(x*y).args` would be
`(x, y)`.  Let's look at some examples

!!! tip "Julia differences"

    Again, `Introspection` allows a more `Julia`n means to call this object method. Unlike `func`, `args` returns `Sym` values. In the example below, they are converted to underling Python values.

```@repl Julia
expr = 3 * y^2* x
Introspection.func(expr)
Introspection.args(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = 3*y**2*x
    >>> expr.func
    <class 'sympy.core.mul.Mul'>
    >>> expr.args
    (3, x, y**2)
```
```@raw html
</details>
```
----


From this, we can see that `expr == Mul(3, y**2, x)`.  In fact, we can see
that we can completely reconstruct `expr` from its `func` and its
`args`.

!!! tip "Julia differences"

    Actually, what is created is the Python value, which if swrapped in `Sym` becoes the original value. Note the use of `\downarrow[tab]` to pass the Python values to the output of `func`.

```@repl Julia
u = Introspection.func(expr)(↓(Introspection.args(expr))...)
↓(expr) == u
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr.func(*expr.args)
    3*x*y**2
    >>> expr == expr.func(*expr.args)
    True
```
```@raw html
</details>
```
----


Note that although we entered `3*y**2*x`, the `args` are `(3, x, y**2)`.
In a `Mul`, the Rational coefficient will come first in the `args`, but
other than that, the order of everything else follows no special pattern.  To
be sure, though, there is an order.


```@repl Julia
expr = y^2 * 3*x
Introspection.args(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = y**2*3*x
    >>> expr.args
    (3, x, y**2)
```
```@raw html
</details>
```
----


Mul's `args` are sorted, so that the same `Mul` will have the same
`args`.  But the sorting is based on some criteria designed to make the
sorting unique and efficient that has no mathematical significance.

The `srepr` form of our `expr` is `Mul(3, x, Pow(y, 2))`.  What if we
want to get at the `args` of `Pow(y, 2)`.  Notice that the `y**2` is in
the third slot of `expr.args`, i.e., `expr.args[2]`.

!!! tip "Julia differences"

    `Julia` is `1` based, not `0` based like `Python`, so the index is `3`

```@repl Julia
Introspection.args(expr)[3]
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr.args[2]
    y**2
```
```@raw html
</details>
```
----


So to get the `args` of this, we call `expr.args[2].args`.


```@repl Julia
Introspection.args(Introspection.args(expr)[3])
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr.args[2].args
    (y, 2)
```
```@raw html
</details>
```
----


Now what if we try to go deeper.  What are the args of `y`.  Or `2`.
Let's see.


```@repl Julia
Introspection.args(y)
Introspection.args(Sym(2))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> y.args
    ()
    >>> Integer(2).args
    ()
```
```@raw html
</details>
```
----


They both have empty `args`.  In SymPy, empty `args` signal that we have
hit a leaf of the expression tree.

So there are two possibilities for a SymPy expression. Either it has empty
`args`, in which case it is a leaf node in any expression tree, or it has
`args`, in which case, it is a branch node of any expression tree.  When it
has `args`, it can be completely rebuilt from its `func` and its `args`.
This is expressed in the key invariant.

!!! note "Key Invariant"

    Every well-formed SymPy expression must either have empty `args` or
    satisfy `expr == expr.func(*expr.args)`.

(Recall that in Python if `a` is a tuple, then `f(*a)` means to call `f`
with arguments from the elements of `a`, e.g., `f(*(1, 2, 3))` is the same
as `f(1, 2, 3)`.)

This key invariant allows us to write simple algorithms that walk expression
trees, change them, and rebuild them into new expressions.

Walking the Tree
----------------

With this knowledge, let's look at how we can recurse through an expression
tree.  The nested nature of `args` is a perfect fit for recursive functions.
The base case will be empty `args`.  Let's write a simple function that goes
through an expression and prints all the `args` at each level.


```@repl Julia
function pre(expr)
   println(expr)
   for arg in Introspection.args(expr)
       pre(arg)
   end
end
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> def pre(expr):
    ...     print(expr)
    ...     for arg in expr.args:
    ...         pre(arg)
```
```@raw html
</details>
```
----


See how nice it is that `()` signals leaves in the expression tree.  We
don't even have to write a base case for our recursion; it is handled
automatically by the for loop.

Let's test our function.


```@repl Julia
expr = x*y + 1
pre(expr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = x*y + 1
    >>> pre(expr)
    x*y + 1
    1
    x*y
    x
    y
```
```@raw html
</details>
```
----


Can you guess why we called our function `pre`?  We just wrote a pre-order
traversal function for our expression tree.   See if you can write a
post-order traversal function.

Such traversals are so common in SymPy that the generator functions
`preorder_traversal` and `postorder_traversal` are provided to make such
traversals easy.  We could have also written our algorithm as


```@repl Julia
collect(sympy.preorder_traversal(expr))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> for arg in preorder_traversal(expr):
    ...     print(arg)
    x*y + 1
    1
    x*y
    x
    y
```
```@raw html
</details>
```
----



Prevent expression evaluation
=============================

There are generally two ways to prevent the evaluation, either pass an
`evaluate=False` parameter while constructing the expression, or create
an evaluation stopper by wrapping the expression with `UnevaluatedExpr`.

For example:


```@repl Julia
x + x
sympy.Add(x, x)
sympy.Add(x, x, evaluate=false)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import Add
    >>> from sympy.abc import x, y, z
    >>> x + x
    2*x
    >>> Add(x, x)
    2*x
    >>> Add(x, x, evaluate=False)
    x + x
```
```@raw html
</details>
```
----


If you don't remember the class corresponding to the expression you
want to build (operator overloading usually assumes `evaluate=True`),
just use `sympify` and pass a string:


```@repl Julia
sympify("x + x", evaluate = false)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import sympify
    >>> sympify("x + x", evaluate=False)
    x + x
```
```@raw html
</details>
```
----


Note that `evaluate=False` won't prevent future evaluation in later
usages of the expression:

```@repl Julia
expr = sympy.Add(x, x, evaluate = false)
expr + x
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr = Add(x, x, evaluate=False)
    >>> expr
    x + x
    >>> expr + x
    3*x
```
```@raw html
</details>
```
----


That's why the class `UnevaluatedExpr` comes handy.
`UnevaluatedExpr` is a method provided by SymPy which lets the user keep
an expression unevaluated. By *unevaluated* it is meant that the value
inside of it will not interact with the expressions outside of it to give
simplified outputs. For example:

```@repl Julia
expr = x + sympy.UnevaluatedExpr(x)
x + expr
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import UnevaluatedExpr
    >>> expr = x + UnevaluatedExpr(x)
    >>> expr
    x + x
    >>> x + expr
    2*x + x
```
```@raw html
</details>
```
----


The `x` remaining alone is the `x` wrapped by `UnevaluatedExpr`.
To release it:

!!! tip "Julia differences"

    the `doit` object method finds many other uses.

```@repl Julia
 (x + expr).doit()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> (x + expr).doit()
    3*x
```
```@raw html
</details>
```
----


Other examples:

!!! tip "Julia differences"

    The `S` module of Python, is not available as `sympy.S`. Rather, we export it through `𝑆`

```@repl Julia
sympy.UnevaluatedExpr(𝑆.One * 5 /7) * sympy.UnevaluatedExpr(𝑆.One * 3 / 4)
x * sympy.UnevaluatedExpr(1/x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import *
    >>> from sympy.abc import x, y, z
    >>> uexpr = UnevaluatedExpr(S.One*5/7)*UnevaluatedExpr(S.One*3/4)
    >>> uexpr
    (5/7)*(3/4)
    >>> x*UnevaluatedExpr(1/x)
    x*1/x
```
```@raw html
</details>
```
----


A point to be noted is that  `UnevaluatedExpr` cannot prevent the
evaluation of an expression which is given as argument. For example:


```@repl Julia
expr1 = sympy.UnevaluatedExpr(x + x)
expr2 = sympify("x + x", evaluate=false)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> expr1 = UnevaluatedExpr(x + x)
    >>> expr1
    2*x
    >>> expr2 = sympify('x + x', evaluate=False)
    >>> expr2
    x + x
```
```@raw html
</details>
```
----


Remember that `expr2` will be evaluated if included into another
expression. Combine both of the methods to prevent both inside and outside
evaluations:


```@repl Julia
sympy.UnevaluatedExpr(sympify("x + x", evaluate=false)) + y
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> UnevaluatedExpr(sympify("x + x", evaluate=False)) + y
    y + (x + x)
```
```@raw html
</details>
```
----


`UnevaluatedExpr` is supported by SymPy printers and can be used to print the
result in different output forms. For example

```@repl Julia
using Latexify
uexpr = sympy.UnevaluatedExpr(𝑆.One * 5 /7) * sympy.UnevaluatedExpr(𝑆.One * 3 / 4)
latexify(uexpr)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import latex
    >>> uexpr = UnevaluatedExpr(S.One*5/7)*UnevaluatedExpr(S.One*3/4)
    >>> print(latex(uexpr))
    \frac{5}{7} \cdot \frac{3}{4}
```
```@raw html
</details>
```
----


In order to release the expression and get the evaluated LaTeX form,
just use `.doit()`:


```@repl Julia
latexify(uexpr.doit())
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> print(latex(uexpr.doit()))
    \frac{15}{28}
```
```@raw html
</details>
```
----



!!! note "Footnotes"

    * We have been using `symbols` instead of `Symbol` because it
    automatically splits apart strings into multiple `Symbol`s.
  ` * symbols('x y z')` returns a tuple of three `Symbol` s.  `Symbol('x y z')`
    returns a single `Symbol` called `x y z`.
    * Technically, it is an internal function called `_sympify`,  which differs from `sympify`
	in that it does not convert strings.  `x +  '2'` is not allowed.
    * Classes like `One` and `Zero` are singletonized, meaning that only one object is ever created,
	no matter how many times the class is called.  This is done for space efficiency,
	as these classes are very  common.  For example, `Zero` might occur very often in a sparse matrix
    represented densely.  As we have seen, `NegativeOne` occurs any time we
    have `-x` or `1/x`.  It is also done for speed efficiency because
    singletonized objects can be compared by `is`.  The unique objects for
    each singletonized class can be accessed from the `S` object.

#= TODO
✓ * @syms
  ✓ x
  ✓ x()
  ✓ x[1:10]
  ✓ x::integer
✓ * promotion()
✓ * subs()
✓ * lambdify
✓ * N, _N
✓ * equations
✓ * Assumptions (struct?) 3-value logic in julia? RIght now, True, None, False
✓ * Differential
✓ * lambdify
✓ * AbstractNumbers.jl
✓ * Introspection()
✓ * 𝑄
✓ * doit
✓ * Matrices
? * getindex[] (?)
* rewrite, replaces, cse, ...
* Wild
* Testing -- rewrite! using this order?
* Docs
* Tutorial -- started; finish editing; NOT WORKING with Core package, just SymPy itself
* pytypemappings (more?? not sure)


## AbstractNumbers

:exponent
:round
:significand
:≈
:mod1
:cmp
:<<
:>>
:\
:div # <- Mod(x,x)
:rem # <- Mod(x,x)
:divrem

✓ :sinc
✓ :cosc
✓ :cosd
✓ :cotd
✓ :cscd
✓ :secd
✓ :sind
✓ :tand
✓ :acosd
✓ :acotd
✓ :acscd
✓ :asecd
✓ :asind
✓ :atand
✓ :rad2deg
✓ :deg2rad
✓ :sinpi
✓ :cospi
✓ :~
✓ :conj
✓ :abs
✓ :sin
✓ :cos
✓ :tan
✓ :sinh
✓ :cosh
✓ :tanh
✓ :asin
✓ :acos
✓ :atan
✓ :asinh
✓ :acosh
✓ :atanh
✓ :sec
✓ :csc
✓ :cot
✓ :asec
✓ :acsc
✓ :acot
✓ :sech
✓ :csch
✓ :coth
✓ :asech
✓ :acsch
✓ :acoth
✓ :log
✓ :log2
✓ :log10
✓ :log1p
✓ :exp
✓ :exp2
✓ :expm1
✓ :cbrt
✓ :sqrt
✓ :ceil
✓ :floor
✓ :trunc
✓ :frexp
✓ :ldexp
✓ :modf
✓ :real
✓ :imag
✓ :!
✓ :identity
✓ :zero
✓ :one
✓ :abs2
✓ :sign
✓ :exp10
✓ :iseven
✓ :ispow2
✓ :isfinite
✓ :isinf
✓ :isodd
✓ :isinteger
✓ :isreal
✓ :isnan
? :isempty
✓ :iszero
✓ :transpose
✓ :copysign
✓ :flipsign
:signbit
✓ :+
✓ :-
✓ :*
✓ :/
✓ :^
✓ :(==)
✓ :(!=)
✓ :<
✓ :(<=)
✓ :>
✓ :(>=)
✓ :min
✓ :max
✓ :fld
✓ :mod
✓? :&
✓? :|
✓?:xor
✓ :clamp

=#

# Basic overview

An interface between `Julia` and the SymPy library of `Python` requires a connection between the two languages. The `PythonCall` package provides a means to  call into an underlying sympy library in `Python`. (As well as `PyCall`.) For example

```@setup overview
using SymPyPythonCall
PythonCall = SymPyPythonCall.PythonCall
```

```julia
julia> import PythonCall
```

```@repl overview
_sympy_ = PythonCall.pyimport("sympy");
```

The `_sympy_` object holds references to the underlying sympy library. As an example, the following creates a symbolic variable, `x`, and calls the `sin` function on it:

```@repl overview
x = _sympy_.symbols("x")
_sympy_.sin(x)
x.is_commutative
x.conjugate()
typeof(x)
```

The `PythonCall` package provides some basic operations for `Py` objects, such as basic math operations:

```@repl overview
x + x
x * x
x ^ x
```

`SymPyPythonCall`, which uses `SymPyCore`, wraps the `Py` objects in its `Sym` class to provide a means to dispatch familiar `Julia` generics:

```@repl overview
using SymPyPythonCall
```

```@repl overview
x = symbols("x") # or @syms x
simplify(2sin(x)*cos(x))
```

By wrapping the Python object in a `Julia` struct, there are many advantages, such as:

* The type can be used for dispatch, allowing `Julia` generic functions to have methods specialized for symbolic objects.
* The `getproperty` method can be specialized. This allows object methods, like `x.conjugate` to have arguments translated from `Sym` objects to `Python` objects when being called.
* The `show` method can be used to adjust printing of objects


The package also provides methods for some sympy methods, such as `simplify` above. To make this work, there needs to be a means to take `Sym` objects to their `Py` counterparts and a means to take `Py` objects to a symbolic type. As these conversions may be type dependent two operators (`↓` and  `↑`) are used internally to allow the definition along these lines:

```julia
simplify(x::Sym, args...; kwargs...) = ↑(sympy.simplify(↓(x), ↓(args)...; ↓(kwargs)...))
```

(Though there is some overhead introduced, it does not seem to be significant compared to computational cost of most symbolic computations.)

The `expand_log` function is not wrapped as such, but can still be called from the `sympy` object exported by `SymPyPythonCall`:

```@repl overview
@syms x::real
simplify(log(2x))
sympy.expand_log(log(2x))
```

Methods of `sympy` are also called using the conversion operators above.

### Some functions of SymPy are Julia methods

A few select functions of SymPy are available as `Julia` methods where *typically* the dispatch is based on the first element being symbolic. Other methods must by qualified, as in `sympy.expand_log`. Historically, `SymPy` was pretty expansive with what it chose to export, but that is no longer the case. Currently, only a few foundational function are exported. E.g., `expand` but not `expand_log`; `simplify` but not `trigsimp`. This should reduce name collisions with other packages. The drawback, is we can add more `Julia`n interfaces when a method is defined. Open an issue, should you think this advantageous.

## Using other SymPy modules

We now show how to access one of the numerous external modules of `sympy` beyond those exposed immediately by `SymPy`. In this case, the `stats` module.


```@repl overview
_stats_ = PythonCall.pyimport("sympy.stats");
```

The `stats` module holds several probability functions, similar to the `Distributions` package of `Julia`. This set of commands creates a normally distributed random variable, `X`, with symbolic parameters:

```@repl overview
𝑋,mu = _sympy_.symbols("X, mu")
sigma = _sympy_.symbols("sigma", positive=true)
X = _stats_.Normal(𝑋, mu, sigma)
_stats_.E(X)
_stats_.E(X^2)
_stats_.variance(X)
```

The one thing to note is the method calls return `Py` objects, as there is no intercepting of the method calls done the way there is for the `sympy` module.  Wrapping `_stats_` in `Sym` uses the `getproperty` specialization:

```@repl overview
stats = Sym(_stats_);
@syms 𝑋, μ, σ::positive
X = stats.Normal(𝑋, μ, σ)
stats.variance(X)
```

Next statements like $P(X > \mu)$ can be answered by specifying the inequality using `Gt` in the following:

```@repl overview
stats.P(Gt(X, μ))
```

The unicode `≧` operator (`\geqq[tab]`) is an infix alternative to `Gt`.

A typical calculation for the normal distribution is the area one or more standard deviations larger than the mean:

```jldoctest overview
julia> stats.P(X ≧ μ + 1 * σ)
sqrt(2)*(-sqrt(2)*pi*exp(1/2)*erf(sqrt(2)/2)/2 + sqrt(2)*pi*exp(1/2)/2)*exp(-1/2)/(2*pi)
```

The familiar  answer could be found by calling `N` or `evalf`.

One more distribution is illustrated, the uniform distribution over a symbolic interval $[a,b]$:

```@repl overview
@syms 𝑈 a::real b::real
U = stats.Uniform(𝑈, a, b)
stats.E(U)
stats.variance(U) |> factor
```

### The mpmath library

According to its [website](https://mpmath.org/):
`mpmath` is a free (BSD licensed) Python library for real and complex floating-point arithmetic with arbitrary precision. It has been developed by Fredrik Johansson since 2007, with help from many contributors.
For Sympy, versions prior to 1.0 included `mpmath`, but SymPy now depends on it`mpmath` as an external dependency.


The `mpmath` library provides numeric, not symbolic routines. To access these directly, the `mpmath` library can be loaded, in the manner just described.

```@repl overview
_mpmath_ = PythonCall.pyimport("mpmath")
mpmath = Sym(_mpmath_)
```

To compare values, consider the `besselj` function which has an implementation in `Julia`'s `SpecialFunctions` package, `SymPy` itself, and `mpmath`. `SymPyCore` provides an overloaded method for a symbolic second argument which is available once `SpecialFunctions` is loaded.

```@repl overview
using SpecialFunctions
@syms x
nu, c = 1//2, pi/3
(mpmath.besselj(nu,c), besselj(nu, x)(c).evalf(), besselj(nu, c))
```



## Different output types

`SymPyPythonCall` provides a few conversions into containers of symbolic objects, like for lists, tuples, finite sets, and matrices
.
Not all outputs are so simple to incorporate and are simply wrapped in the `Sym` type.

Conversion to a workable `Julia` structure can require some massaging. This example shows how to get at the pieces of the `Piecewise` type.

The output of many integration problems is a piecewise function:

```@repl overview
@syms n::integer x::real
u = integrate(x^n, x)
```

The `u` object is of type `Sym`, but there are no methods for working with it. The `.args` call will break this into its argument, which again will by symbolic. The `Introspection.args` function will perform the same thing.

```@repl overview
as = Introspection.args(u)
```

The `as` object is a tuple of `Sym` objects. Consider the first one:

```@repl overview
c1 = first(as)
```

The value of `c1` prints as a tuple, but is of type `Sym` and sympy type `CondExprPair`. Though the underlying python type is iterable or indexable, the wrapped type is not. It can  be made iterable in a manner of ways: by calling `↓(c1)`; by finding the underlying Python object through the attribute `.o`, as in `c1.o`; or by calling the `Py` method of `PythonCall`, as in `PythonCall.Py(c1)`. More generically, `PythonCall` provides a `PyIterable` wrapper. As there is no defined `lastindex`, the latter is a bit more cumbersome to use. This pattern below, expands the conditions into a dictionary:

```@repl overview
[Sym(↓(a)[1]) => Sym(↓(a)[0]) for a ∈ as]
```

The Python object, `↓(a)` is indexed, so 0-based indexing is used above. These pieces are then converted to `Sym` objects for familiarity.

What’s Next
===========

Congratulations on finishing the SymPy tutorial!

If you are a developer interested in using SymPy in your code, please visit
the [How-to Guides](guides) which discuss key developer tasks.

Intermediate SymPy users and developers might want to visit the
[Explanations](explanations) section for common pitfalls and advanced
topics.

The [SymPy API Reference](reference) has a detailed description of the
SymPy API.

If you are interested in contributing to SymPy, visit the [contribution guides](contributing).

Solvers
=========

```@setup Julia
using SymPyPythonCall
```


!!! note

    For a beginner-friendly guide focused on solving common types of equations,
    refer to [Solving](https://docs.sympy.org/latest/guides/solving/index.html#solving-guide)


```@repl Julia
@syms x, y, z
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
>>> from sympy import *
>>> x, y, z = symbols('x y z')
>>> init_printing(use_unicode=True)
```
```@raw html
</details>
```
----


A Note about Equations
======================

Recall from the [gotchas](./gotchas/#Equals-signs) section of this
tutorial that symbolic equations in SymPy are not represented by `=` or
`==`, but by `Eq`.


!!! tip "Julia differences"

    The infix operator `~` is an elternative to `Eq`.

```@repl Julia
x ~ y
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> Eq(x, y)
    x = y
```
```@raw html
</details>
```
----



However, there is an even easier way.  In SymPy, any expression not in an
`Eq` is automatically assumed to equal 0 by the solving functions.  Since `a
= b` if and only if `a - b = 0`, this means that instead of using `x == y`,
you can just use `x - y`.  For example



```@repl Julia
solveset(x^2 ~ 1, x)
solveset(x^2 - 1 ~ 0, x)
solveset(x^2 - 1, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> solveset(Eq(x**2, 1), x)
    {-1, 1}
    >>> solveset(Eq(x**2 - 1, 0), x)
    {-1, 1}
    >>> solveset(x**2 - 1, x)
    {-1, 1}
```
```@raw html
</details>
```
----


This is particularly useful if the equation you wish to solve is already equal
to 0. Instead of typing `solveset(Eq(expr, 0), x)`, you can just use
`solveset(expr, x)`.

Solving Equations Algebraically
===============================

The main function for solving algebraic equations is `solveset`.
The syntax for `solveset` is `solveset(equation, variable=None, domain=S.Complexes)`
Where `equations` may be in the form of `Eq` instances or expressions
that are assumed to be equal to zero.

Please note that there is another function called `solve` which
can also be used to solve equations. The syntax is `solve(equations, variables)`
However, it is recommended to use `solveset` instead.

When solving a single equation, the output of `solveset` is a `FiniteSet` or
an `Interval` or `ImageSet` of the solutions.


!!! tip "Julia differences"

    Finite sets are turned into `Set` containers in `Julia`.

!!! tip "Julia differences"

    The exported `𝑆` objects mirror `S` from Python. Using `sympy.S` fails, as the underlying object has a `__call__` method, so `sympy.S` is a callable function, not an object. The construction `↓(sympy).S` works, but is cumbersome and `\itS[tab]` seems easy enough to enter.



```@repl Julia
solveset(x^2 - x, x)
solveset(x - x, x, domain= 𝑆.Reals)
solveset(sin(x) - 1, x, domain= 𝑆.Reals)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> solveset(x**2 - x, x)
    {0, 1}
    >>> solveset(x - x, x, domain=S.Reals)
    ℝ
    >>> solveset(sin(x) - 1, x, domain=S.Reals)
    ⎧        π │      ⎫
    ⎨2⋅n⋅π + ─ │ n ∊ ℤ⎬
    ⎩        2 │      ⎭
```
```@raw html
</details>
```
----



If there are no solutions, an `EmptySet` is returned and if it
is not able to find solutions then a `ConditionSet` is returned.

```@repl Julia
solveset(exp(x), x)
solveset(cos(x) - x, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> solveset(exp(x), x)     # No solution exists
    ∅
    >>> solveset(cos(x) - x, x)  # Not able to find solution
    {x │ x ∊ ℂ ∧ (-x + cos(x) = 0)}
```
```@raw html
</details>
```
----



In the `solveset` module, the linear system of equations is solved using `linsolve`.
In future we would be able to use linsolve directly from `solveset`. Following
is an example of the syntax of `linsolve`.

* List of Equations Form:

```@repl Julia
linsolve([x + y + z - 1, x + y + 2*z - 3 ], (x, y, z))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> linsolve([x + y + z - 1, x + y + 2*z - 3 ], (x, y, z))
    {(-y - 1, y, 2)}
```
```@raw html
</details>
```
----


* Augmented Matrix Form:

!!! tip "Julia differences"

    We paas in a symbolic matrix to `linsolve`. The variables are passed as a tuple or as, in this case, three variables, but not as a vector. (The `↓` conversion of a vector creates ``n\times 1` matrix, not a list, as is expected by the underlying function.)

```@repl Julia
linsolve(Sym[ 1 1 1 1; 1 1 2 3], (x, y, z))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> linsolve(Matrix(([1, 1, 1, 1], [1, 1, 2, 3])), (x, y, z))
    {(-y - 1, y, 2)}
```
```@raw html
</details>
```
----


* A*x = b Form


```@repl Julia
M = Sym[ 1 1 1 1; 1 1 2 3]
system = A, b = M[:, 1:end-1], M[:, end]
linsolve(system, x, y, z)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> M = Matrix(((1, 1, 1, 1), (1, 1, 2, 3)))
    >>> system = A, b = M[:, :-1], M[:, -1]
    >>> linsolve(system, x, y, z)
    {(-y - 1, y, 2)}
```
```@raw html
</details>
```
----


!!! note

    The order of solution corresponds the order of given symbols.


In the `solveset` module, the non linear system of equations is solved using
`nonlinsolve`. Following are examples of `nonlinsolve`.

1. When only real solution is present:

!!! tip "Julia differences"

    We can pass in equations using a tuple or a vector, but the variables are passed as a tuple or individually, not within a vector.

```@repl Julia
@syms a::real, b::real, c::real, d::real
nonlinsolve( (a^2 + a, a - b), (a, b))
nonlinsolve((x*y - 1, x - 2), x, y)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> a, b, c, d = symbols('a, b, c, d', real=True)
    >>> nonlinsolve([a**2 + a, a - b], [a, b])
    {(-1, -1), (0, 0)}
    >>> nonlinsolve([x*y - 1, x - 2], x, y)
    {(2, 1/2)}
```
```@raw html
</details>
```
----


2. When only complex solution is present:

!!! tip "Julia differences"

    Again, we use tuples, not vectors, to pass in the variables

```@repl Julia
nonlinsolve((x^2 + 1, y^2 + 1), (x, y))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> nonlinsolve([x**2 + 1, y**2 + 1], [x, y])
    {(-ⅈ, -ⅈ), (-ⅈ, ⅈ), (ⅈ, -ⅈ), (ⅈ, ⅈ)}
```
```@raw html
</details>
```
----


3. When both real and complex solution are present:

```@repl Julia
system = (x^2 - 2*y^2 -2, x*y - 2)
vars = (x, y)
nonlinsolve(system, vars)
system = (exp(x) - sin(y), 1/y - 3)
nonlinsolve(system, vars)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> from sympy import sqrt
    >>> system = [x**2 - 2*y**2 -2, x*y - 2]
    >>> vars = [x, y]
    >>> nonlinsolve(system, vars)
    {(-2, -1), (2, 1), (-√2⋅ⅈ, √2⋅ⅈ), (√2⋅ⅈ, -√2⋅ⅈ)}

    >>> system = [exp(x) - sin(y), 1/y - 3]
    >>> nonlinsolve(system, vars)
    {({2⋅n⋅ⅈ⋅π + log(sin(1/3)) │ n ∊ ℤ}, 1/3)}
```
```@raw html
</details>
```
----


4. When the system is positive-dimensional system (has infinitely many solutions):



```@repl Julia
nonlinsolve((x*y, x*y - x), (x, y))
system = (a^2 + a*c, a - b)
nonlinsolve(system, (a, b))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> nonlinsolve([x*y, x*y - x], [x, y])
    {(0, y)}

    >>> system = [a**2 + a*c, a - b]
    >>> nonlinsolve(system, [a, b])
    {(0, 0), (-c, -c)}
```
```@raw html
</details>
```
----



Notes:

1. The order of solution corresponds the order of given symbols.

2. Currently `nonlinsolve` doesn't return solution in form of `LambertW` (if there
is solution present in the form of `LambertW`).

`solve` can be used for such cases:

 ```
 >>> solve([x**2 - y**2/exp(x)], [x, y], dict=True)
⎡⎧         ____⎫  ⎧        ____⎫⎤
⎢⎨        ╱  x ⎬  ⎨       ╱  x ⎬⎥
⎣⎩y: -x⋅╲╱  ℯ  ⎭, ⎩y: x⋅╲╱  ℯ  ⎭⎦
>>> solve(x**2 - y**2/exp(x), x, dict=True)
⎡⎧      ⎛-y ⎞⎫  ⎧      ⎛y⎞⎫⎤
⎢⎨x: 2⋅W⎜───⎟⎬, ⎨x: 2⋅W⎜─⎟⎬⎥
⎣⎩      ⎝ 2 ⎠⎭  ⎩      ⎝2⎠⎭⎦
```

3. Currently `nonlinsolve` is not properly capable of solving the system of equations
having trigonometric functions.

`solve` can be used for such cases (but does not give all solution):

```
>>> solve([sin(x + y), cos(x - y)], [x, y])
⎡⎛-3⋅π   3⋅π⎞  ⎛-π   π⎞  ⎛π  3⋅π⎞  ⎛3⋅π  π⎞⎤
⎢⎜─────, ───⎟, ⎜───, ─⎟, ⎜─, ───⎟, ⎜───, ─⎟⎥
⎣⎝  4     4 ⎠  ⎝ 4   4⎠  ⎝4   4 ⎠  ⎝ 4   4⎠⎦
```

----

`solveset` reports each solution only once.  To get the solutions of a
polynomial including multiplicity use `roots`.

!!! tip "Julia differences"

    The `roots` function needs qualification

```@repl Julia
solveset(x^3 - 6*x^2 + 9*x, x)
sympy.roots(x^3 - 6*x^2 + 9*x, x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> solveset(x**3 - 6*x**2 + 9*x, x)
    {0, 3}
    >>> roots(x**3 - 6*x**2 + 9*x, x)
    {0: 1, 3: 2}
```
```@raw html
</details>
```
----


The output `{0: 1, 3: 2}` of `roots` means that `0` is a root of
multiplicity 1 and `3` is a root of multiplicity 2.

Note:

Currently `solveset` is not capable of solving the following types of equations:

* Equations solvable by LambertW (Transcendental equation solver).

`solve` can be used for such cases:

    >>> solve(x*exp(x) - 1, x )
    [W(1)]

Solving Differential Equations
==============================

To solve differential equations, use `dsolve`.  First, create an undefined
function by passing `cls=Function` to the `symbols` function.


!!! tip "Julia differences"

    We can use `@syms` to define symbolic functions

```@repl Julia
@syms f() g()
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f, g = symbols('f g', cls=Function)
```
```@raw html
</details>
```
----


`f` and `g` are now undefined functions.  We can call `f(x)`, and it
will represent an unknown function.

```@repl Julia
f(x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f(x)
    f(x)
```
```@raw html
</details>
```
----


Derivatives of `f(x)` are unevaluated.

```@repl Julia
diff(f(x), x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> f(x).diff(x)
    d
    ──(f(x))
    dx
```
```@raw html
</details>
```
----


(see the [`Derivatives](./calculus#Derivatives) section for more on
derivatives).

To represent the differential equation `f''(x) - 2f'(x) + f(x) = \sin(x)`, we
would thus use

!!! tip "Julia differences"

    We could use similar notation, as within Python, e.g., `f(x).diff(x)`, but we show the use of `Differential` which hides some repetition

```@repl Julia
∂ = Differential(x)
diffeq = ∂(∂(f(x))) - 2 * ∂(f(x)) + f(x) ~ sin(x)
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> diffeq = Eq(f(x).diff(x, x) - 2*f(x).diff(x) + f(x), sin(x))
    >>> diffeq
                          2
             d           d
    f(x) - 2⋅──(f(x)) + ───(f(x)) = sin(x)
             dx           2
                        dx
```
```@raw html
</details>
```
----


To solve the ODE, pass it and the function to solve for to `dsolve`.

```@repl Julia
dsolve(diffeq, f(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> dsolve(diffeq, f(x))
                        x   cos(x)
    f(x) = (C₁ + C₂⋅x)⋅ℯ  + ──────
                              2
```
```@raw html
</details>
```
----


`dsolve` returns an instance of `Eq`.  This is because, in general,
solutions to differential equations cannot be solved explicitly for the
function.


```@repl Julia
dsolve(∂(f) * (1 - sin(f(x))), f(x))
```

----

```@raw html
<details><summary>Expand for Python example</summary>
```

```python
    >>> dsolve(f(x).diff(x)*(1 - sin(f(x))) - 1, f(x))
    x - f(x) - cos(f(x)) = C₁
```
```@raw html
</details>
```
----


The arbitrary constants in the solutions from dsolve are symbols of the form
`C1`, `C2`, `C3`, and so on.


!!! tip "Julia differences"

    The `ics` argument of `dsolve` allows a dictionary to be passed to specify initiial conditions.

# SymPyCore.jl

Documentation for SymPyCore.jl, a package allowing the use of `Python`'s SymPy library from within a `Julia` session.

----

[SymPy](https://www.sympy.org/) is Python library for symbolic mathematics.

As there are two means to call `Python` code from `Julia`, two packages have been developed to call into SymPy:

* [SymPy.jl](https://github.com/JuliaPy/SymPy.jl) is a `Julia` package using `PyCall.jl` to provide a "`Julia`n" interface to SymPy.

* [SymPyPythonCall.jl](https://github.com/jverzani/SymPyPythonCall.jl) is a `Julia` package using `PythonCall.jl` to provide a "`Julia`n" interface to SymPy providing a nearly identical experience as `SymPy.jl`.

The `SymPyCore` package aims to unify the underlying code, leaving only a small amount of glue code in the primary packages. The most recent versions of the above use this backend.

----

While both glue packages provide a means to interact directly with the `sympy` library in `Python`, `SymPyCore` adds some conveniences, including many `Julia`n idioms for easier use within `Julia`.

The *SympyCore introduction* page shows basic usages. The `Julia` translation of the *SymPy Tutorial* is more extensive.


## Alternatives

`Julia` provides a few alternatives to `SymPy` for symbolic math. Two that are more performant though not as feature rich are:

* [Symbolics](https://symbolics.juliasymbolics.org) which is used within the SciML suite of packages.

* [SymEngine](https://github.com/symengine/symengine.jl) an interface to the underlying C++ symengine library
